using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Debugger", DoNotGenerateAcw=true)]
	public sealed partial class Debugger : global::Android.Views.GestureDetector.SimpleOnGestureListener, global::Android.Views.View.IOnClickListener, global::Android.Views.View.IOnTouchListener, global::Android.Widget.AdapterView.IOnItemClickListener {

		// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger.DebuggerEvent']"
		[global::Android.Runtime.Register ("com/atinternet/tracker/Debugger$DebuggerEvent", DoNotGenerateAcw=true)]
		public partial class DebuggerEvent : global::Java.Lang.Object {

			internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Debugger$DebuggerEvent", typeof (DebuggerEvent));
			internal static new IntPtr class_ref {
				get {
					return _members.JniPeerType.PeerReference.Handle;
				}
			}

			public override global::Java.Interop.JniPeerMembers JniPeerMembers {
				get { return _members; }
			}

			protected override IntPtr ThresholdClass {
				get { return _members.JniPeerType.PeerReference.Handle; }
			}

			protected override global::System.Type ThresholdType {
				get { return _members.ManagedPeerType; }
			}

			protected DebuggerEvent (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		}

		// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger.DebuggerEventListAdapter']"
		[global::Android.Runtime.Register ("com/atinternet/tracker/Debugger$DebuggerEventListAdapter", DoNotGenerateAcw=true)]
		public partial class DebuggerEventListAdapter : global::Android.Widget.BaseAdapter {

			internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Debugger$DebuggerEventListAdapter", typeof (DebuggerEventListAdapter));
			internal static new IntPtr class_ref {
				get {
					return _members.JniPeerType.PeerReference.Handle;
				}
			}

			public override global::Java.Interop.JniPeerMembers JniPeerMembers {
				get { return _members; }
			}

			protected override IntPtr ThresholdClass {
				get { return _members.JniPeerType.PeerReference.Handle; }
			}

			protected override global::System.Type ThresholdType {
				get { return _members.ManagedPeerType; }
			}

			protected DebuggerEventListAdapter (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

			static Delegate cb_getCount;
#pragma warning disable 0169
			static Delegate GetGetCountHandler ()
			{
				if (cb_getCount == null)
					cb_getCount = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetCount);
				return cb_getCount;
			}

			static int n_GetCount (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.Count;
			}
#pragma warning restore 0169

			public override unsafe int Count {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger.DebuggerEventListAdapter']/method[@name='getCount' and count(parameter)=0]"
				[Register ("getCount", "()I", "GetGetCountHandler")]
				get {
					const string __id = "getCount.()I";
					try {
						var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
						return __rm;
					} finally {
					}
				}
			}

			static Delegate cb_getItem_I;
#pragma warning disable 0169
			static Delegate GetGetItem_IHandler ()
			{
				if (cb_getItem_I == null)
					cb_getItem_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_GetItem_I);
				return cb_getItem_I;
			}

			static IntPtr n_GetItem_I (IntPtr jnienv, IntPtr native__this, int position)
			{
				global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return JNIEnv.ToLocalJniHandle (__this.GetItem (position));
			}
#pragma warning restore 0169

			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger.DebuggerEventListAdapter']/method[@name='getItem' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("getItem", "(I)Ljava/lang/Object;", "GetGetItem_IHandler")]
			public override unsafe global::Java.Lang.Object GetItem (int position)
			{
				const string __id = "getItem.(I)Ljava/lang/Object;";
				try {
					JniArgumentValue* __args = stackalloc JniArgumentValue [1];
					__args [0] = new JniArgumentValue (position);
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
					return global::Java.Lang.Object.GetObject<global::Java.Lang.Object> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}

			static Delegate cb_getItemId_I;
#pragma warning disable 0169
			static Delegate GetGetItemId_IHandler ()
			{
				if (cb_getItemId_I == null)
					cb_getItemId_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, long>) n_GetItemId_I);
				return cb_getItemId_I;
			}

			static long n_GetItemId_I (IntPtr jnienv, IntPtr native__this, int position)
			{
				global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.GetItemId (position);
			}
#pragma warning restore 0169

			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger.DebuggerEventListAdapter']/method[@name='getItemId' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("getItemId", "(I)J", "GetGetItemId_IHandler")]
			public override unsafe long GetItemId (int position)
			{
				const string __id = "getItemId.(I)J";
				try {
					JniArgumentValue* __args = stackalloc JniArgumentValue [1];
					__args [0] = new JniArgumentValue (position);
					var __rm = _members.InstanceMethods.InvokeVirtualInt64Method (__id, this, __args);
					return __rm;
				} finally {
				}
			}

			static Delegate cb_getView_ILandroid_view_View_Landroid_view_ViewGroup_;
#pragma warning disable 0169
			static Delegate GetGetView_ILandroid_view_View_Landroid_view_ViewGroup_Handler ()
			{
				if (cb_getView_ILandroid_view_View_Landroid_view_ViewGroup_ == null)
					cb_getView_ILandroid_view_View_Landroid_view_ViewGroup_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr, IntPtr, IntPtr>) n_GetView_ILandroid_view_View_Landroid_view_ViewGroup_);
				return cb_getView_ILandroid_view_View_Landroid_view_ViewGroup_;
			}

			static IntPtr n_GetView_ILandroid_view_View_Landroid_view_ViewGroup_ (IntPtr jnienv, IntPtr native__this, int position, IntPtr native_convertView, IntPtr native_parent)
			{
				global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Debugger.DebuggerEventListAdapter> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				global::Android.Views.View convertView = global::Java.Lang.Object.GetObject<global::Android.Views.View> (native_convertView, JniHandleOwnership.DoNotTransfer);
				global::Android.Views.ViewGroup parent = global::Java.Lang.Object.GetObject<global::Android.Views.ViewGroup> (native_parent, JniHandleOwnership.DoNotTransfer);
				IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.GetView (position, convertView, parent));
				return __ret;
			}
#pragma warning restore 0169

			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger.DebuggerEventListAdapter']/method[@name='getView' and count(parameter)=3 and parameter[1][@type='int'] and parameter[2][@type='android.view.View'] and parameter[3][@type='android.view.ViewGroup']]"
			[Register ("getView", "(ILandroid/view/View;Landroid/view/ViewGroup;)Landroid/view/View;", "GetGetView_ILandroid_view_View_Landroid_view_ViewGroup_Handler")]
			public override unsafe global::Android.Views.View GetView (int position, global::Android.Views.View convertView, global::Android.Views.ViewGroup parent)
			{
				const string __id = "getView.(ILandroid/view/View;Landroid/view/ViewGroup;)Landroid/view/View;";
				try {
					JniArgumentValue* __args = stackalloc JniArgumentValue [3];
					__args [0] = new JniArgumentValue (position);
					__args [1] = new JniArgumentValue ((convertView == null) ? IntPtr.Zero : ((global::Java.Lang.Object) convertView).Handle);
					__args [2] = new JniArgumentValue ((parent == null) ? IntPtr.Zero : ((global::Java.Lang.Object) parent).Handle);
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
					return global::Java.Lang.Object.GetObject<global::Android.Views.View> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}

		}

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Debugger", typeof (Debugger));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		internal Debugger (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='create' and count(parameter)=2 and parameter[1][@type='android.content.Context'] and parameter[2][@type='com.atinternet.tracker.Tracker']]"
		[Register ("create", "(Landroid/content/Context;Lcom/atinternet/tracker/Tracker;)V", "")]
		public static unsafe void Create (global::Android.Content.Context context, global::Com.Atinternet.Tracker.Tracker tracker)
		{
			const string __id = "create.(Landroid/content/Context;Lcom/atinternet/tracker/Tracker;)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				__args [1] = new JniArgumentValue ((tracker == null) ? IntPtr.Zero : ((global::Java.Lang.Object) tracker).Handle);
				_members.StaticMethods.InvokeVoidMethod (__id, __args);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='onClick' and count(parameter)=1 and parameter[1][@type='android.view.View']]"
		[Register ("onClick", "(Landroid/view/View;)V", "")]
		public unsafe void OnClick (global::Android.Views.View v)
		{
			const string __id = "onClick.(Landroid/view/View;)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((v == null) ? IntPtr.Zero : ((global::Java.Lang.Object) v).Handle);
				_members.InstanceMethods.InvokeAbstractVoidMethod (__id, this, __args);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='onItemClick' and count(parameter)=4 and parameter[1][@type='android.widget.AdapterView&lt;?&gt;'] and parameter[2][@type='android.view.View'] and parameter[3][@type='int'] and parameter[4][@type='long']]"
		[Register ("onItemClick", "(Landroid/widget/AdapterView;Landroid/view/View;IJ)V", "")]
		public unsafe void OnItemClick (global::Android.Widget.AdapterView parent, global::Android.Views.View view, int position, long id)
		{
			const string __id = "onItemClick.(Landroid/widget/AdapterView;Landroid/view/View;IJ)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [4];
				__args [0] = new JniArgumentValue ((parent == null) ? IntPtr.Zero : ((global::Java.Lang.Object) parent).Handle);
				__args [1] = new JniArgumentValue ((view == null) ? IntPtr.Zero : ((global::Java.Lang.Object) view).Handle);
				__args [2] = new JniArgumentValue (position);
				__args [3] = new JniArgumentValue (id);
				_members.InstanceMethods.InvokeAbstractVoidMethod (__id, this, __args);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='onTouch' and count(parameter)=2 and parameter[1][@type='android.view.View'] and parameter[2][@type='android.view.MotionEvent']]"
		[Register ("onTouch", "(Landroid/view/View;Landroid/view/MotionEvent;)Z", "")]
		public unsafe bool OnTouch (global::Android.Views.View v, global::Android.Views.MotionEvent e)
		{
			const string __id = "onTouch.(Landroid/view/View;Landroid/view/MotionEvent;)Z";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue ((v == null) ? IntPtr.Zero : ((global::Java.Lang.Object) v).Handle);
				__args [1] = new JniArgumentValue ((e == null) ? IntPtr.Zero : ((global::Java.Lang.Object) e).Handle);
				var __rm = _members.InstanceMethods.InvokeAbstractBooleanMethod (__id, this, __args);
				return __rm;
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='remove' and count(parameter)=0]"
		[Register ("remove", "()V", "")]
		public static unsafe void Remove ()
		{
			const string __id = "remove.()V";
			try {
				_members.StaticMethods.InvokeVoidMethod (__id, null);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='setViewerVisibility' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setViewerVisibility", "(Z)V", "")]
		public static unsafe void SetViewerVisibility (bool visible)
		{
			const string __id = "setViewerVisibility.(Z)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (visible);
				_members.StaticMethods.InvokeVoidMethod (__id, __args);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Debugger']/method[@name='show' and count(parameter)=2 and parameter[1][@type='android.content.Context'] and parameter[2][@type='com.atinternet.tracker.Tracker']]"
		[Obsolete (@"deprecated")]
		[Register ("show", "(Landroid/content/Context;Lcom/atinternet/tracker/Tracker;)V", "")]
		public static unsafe void Show (global::Android.Content.Context context, global::Com.Atinternet.Tracker.Tracker tracker)
		{
			const string __id = "show.(Landroid/content/Context;Lcom/atinternet/tracker/Tracker;)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				__args [1] = new JniArgumentValue ((tracker == null) ? IntPtr.Zero : ((global::Java.Lang.Object) tracker).Handle);
				_members.StaticMethods.InvokeVoidMethod (__id, __args);
			} finally {
			}
		}

	}
}
