using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/DynamicScreens", DoNotGenerateAcw=true)]
	public partial class DynamicScreens : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/DynamicScreens", typeof (DynamicScreens));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected DynamicScreens (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_ILjava_lang_String_Ljava_util_Date_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetAdd_ILjava_lang_String_Ljava_util_Date_Handler ()
		{
			if (cb_add_ILjava_lang_String_Ljava_util_Date_ == null)
				cb_add_ILjava_lang_String_Ljava_util_Date_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr, IntPtr, IntPtr>) n_Add_ILjava_lang_String_Ljava_util_Date_);
			return cb_add_ILjava_lang_String_Ljava_util_Date_;
		}

		[Obsolete]
		static IntPtr n_Add_ILjava_lang_String_Ljava_util_Date_ (IntPtr jnienv, IntPtr native__this, int screenId, IntPtr native_name, IntPtr native_update)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=3 and parameter[1][@type='int'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date']]"
		[Obsolete (@"deprecated")]
		[Register ("add", "(ILjava/lang/String;Ljava/util/Date;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_ILjava_lang_String_Ljava_util_Date_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (int screenId, string name, global::Java.Util.Date update)
		{
			const string __id = "add.(ILjava/lang/String;Ljava/util/Date;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

		static Delegate cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetAdd_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Handler ()
		{
			if (cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_ == null)
				cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_);
			return cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_Add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, int screenId, IntPtr native_name, IntPtr native_update, IntPtr native_chapter1)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update, chapter1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=4 and parameter[1][@type='int'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date'] and parameter[4][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("add", "(ILjava/lang/String;Ljava/util/Date;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (int screenId, string name, global::Java.Util.Date update, string chapter1)
		{
			const string __id = "add.(ILjava/lang/String;Ljava/util/Date;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [4];
				__args [0] = new JniArgumentValue (screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				__args [3] = new JniArgumentValue (native_chapter1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
			}
		}

		static Delegate cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetAdd_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_Add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, int screenId, IntPtr native_name, IntPtr native_update, IntPtr native_chapter1, IntPtr native_chapter2)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update, chapter1, chapter2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=5 and parameter[1][@type='int'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("add", "(ILjava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (int screenId, string name, global::Java.Util.Date update, string chapter1, string chapter2)
		{
			const string __id = "add.(ILjava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [5];
				__args [0] = new JniArgumentValue (screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				__args [3] = new JniArgumentValue (native_chapter1);
				__args [4] = new JniArgumentValue (native_chapter2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
				JNIEnv.DeleteLocalRef (native_chapter2);
			}
		}

		static Delegate cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetAdd_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_Add_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, int screenId, IntPtr native_name, IntPtr native_update, IntPtr native_chapter1, IntPtr native_chapter2, IntPtr native_chapter3)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			string chapter3 = JNIEnv.GetString (native_chapter3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update, chapter1, chapter2, chapter3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=6 and parameter[1][@type='int'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String'] and parameter[6][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("add", "(ILjava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_ILjava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (int screenId, string name, global::Java.Util.Date update, string chapter1, string chapter2, string chapter3)
		{
			const string __id = "add.(ILjava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			IntPtr native_chapter3 = JNIEnv.NewString (chapter3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [6];
				__args [0] = new JniArgumentValue (screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				__args [3] = new JniArgumentValue (native_chapter1);
				__args [4] = new JniArgumentValue (native_chapter2);
				__args [5] = new JniArgumentValue (native_chapter3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
				JNIEnv.DeleteLocalRef (native_chapter2);
				JNIEnv.DeleteLocalRef (native_chapter3);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_ (IntPtr jnienv, IntPtr native__this, IntPtr native_screenId, IntPtr native_name, IntPtr native_update)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string screenId = JNIEnv.GetString (native_screenId, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (string screenId, string name, global::Java.Util.Date update)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_screenId = JNIEnv.NewString (screenId);
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_screenId);
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_screenId, IntPtr native_name, IntPtr native_update, IntPtr native_chapter1)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string screenId = JNIEnv.GetString (native_screenId, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update, chapter1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=4 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date'] and parameter[4][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (string screenId, string name, global::Java.Util.Date update, string chapter1)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_screenId = JNIEnv.NewString (screenId);
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [4];
				__args [0] = new JniArgumentValue (native_screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				__args [3] = new JniArgumentValue (native_chapter1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_screenId);
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_screenId, IntPtr native_name, IntPtr native_update, IntPtr native_chapter1, IntPtr native_chapter2)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string screenId = JNIEnv.GetString (native_screenId, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update, chapter1, chapter2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=5 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (string screenId, string name, global::Java.Util.Date update, string chapter1, string chapter2)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_screenId = JNIEnv.NewString (screenId);
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [5];
				__args [0] = new JniArgumentValue (native_screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				__args [3] = new JniArgumentValue (native_chapter1);
				__args [4] = new JniArgumentValue (native_chapter2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_screenId);
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
				JNIEnv.DeleteLocalRef (native_chapter2);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_screenId, IntPtr native_name, IntPtr native_update, IntPtr native_chapter1, IntPtr native_chapter2, IntPtr native_chapter3)
		{
			global::Com.Atinternet.Tracker.DynamicScreens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string screenId = JNIEnv.GetString (native_screenId, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			string chapter3 = JNIEnv.GetString (native_chapter3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (screenId, name, update, chapter1, chapter2, chapter3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreens']/method[@name='add' and count(parameter)=6 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.Date'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String'] and parameter[6][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_util_Date_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen Add (string screenId, string name, global::Java.Util.Date update, string chapter1, string chapter2, string chapter3)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/util/Date;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_screenId = JNIEnv.NewString (screenId);
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			IntPtr native_chapter3 = JNIEnv.NewString (chapter3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [6];
				__args [0] = new JniArgumentValue (native_screenId);
				__args [1] = new JniArgumentValue (native_name);
				__args [2] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				__args [3] = new JniArgumentValue (native_chapter1);
				__args [4] = new JniArgumentValue (native_chapter2);
				__args [5] = new JniArgumentValue (native_chapter3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_screenId);
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
				JNIEnv.DeleteLocalRef (native_chapter2);
				JNIEnv.DeleteLocalRef (native_chapter3);
			}
		}

	}
}
