using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/ECommerce", DoNotGenerateAcw=true)]
	public partial class ECommerce : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/ECommerce", typeof (ECommerce));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected ECommerce (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_AddProducts;
#pragma warning disable 0169
		static Delegate GetAddProductsHandler ()
		{
			if (cb_AddProducts == null)
				cb_AddProducts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_AddProducts);
			return cb_AddProducts;
		}

		static IntPtr n_AddProducts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.AddProducts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='AddProducts' and count(parameter)=0]"
		[Register ("AddProducts", "()Lcom/atinternet/tracker/ecommerce/AddProducts;", "GetAddProductsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.AddProducts AddProducts ()
		{
			const string __id = "AddProducts.()Lcom/atinternet/tracker/ecommerce/AddProducts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.AddProducts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_CartAwaitingPayments;
#pragma warning disable 0169
		static Delegate GetCartAwaitingPaymentsHandler ()
		{
			if (cb_CartAwaitingPayments == null)
				cb_CartAwaitingPayments = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_CartAwaitingPayments);
			return cb_CartAwaitingPayments;
		}

		static IntPtr n_CartAwaitingPayments (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CartAwaitingPayments ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='CartAwaitingPayments' and count(parameter)=0]"
		[Register ("CartAwaitingPayments", "()Lcom/atinternet/tracker/ecommerce/CartAwaitingPayments;", "GetCartAwaitingPaymentsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.CartAwaitingPayments CartAwaitingPayments ()
		{
			const string __id = "CartAwaitingPayments.()Lcom/atinternet/tracker/ecommerce/CartAwaitingPayments;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.CartAwaitingPayments> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_DeliveryCheckouts;
#pragma warning disable 0169
		static Delegate GetDeliveryCheckoutsHandler ()
		{
			if (cb_DeliveryCheckouts == null)
				cb_DeliveryCheckouts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_DeliveryCheckouts);
			return cb_DeliveryCheckouts;
		}

		static IntPtr n_DeliveryCheckouts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.DeliveryCheckouts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='DeliveryCheckouts' and count(parameter)=0]"
		[Register ("DeliveryCheckouts", "()Lcom/atinternet/tracker/ecommerce/DeliveryCheckouts;", "GetDeliveryCheckoutsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.DeliveryCheckouts DeliveryCheckouts ()
		{
			const string __id = "DeliveryCheckouts.()Lcom/atinternet/tracker/ecommerce/DeliveryCheckouts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.DeliveryCheckouts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_DisplayCarts;
#pragma warning disable 0169
		static Delegate GetDisplayCartsHandler ()
		{
			if (cb_DisplayCarts == null)
				cb_DisplayCarts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_DisplayCarts);
			return cb_DisplayCarts;
		}

		static IntPtr n_DisplayCarts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.DisplayCarts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='DisplayCarts' and count(parameter)=0]"
		[Register ("DisplayCarts", "()Lcom/atinternet/tracker/ecommerce/DisplayCarts;", "GetDisplayCartsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.DisplayCarts DisplayCarts ()
		{
			const string __id = "DisplayCarts.()Lcom/atinternet/tracker/ecommerce/DisplayCarts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.DisplayCarts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_DisplayPageProducts;
#pragma warning disable 0169
		static Delegate GetDisplayPageProductsHandler ()
		{
			if (cb_DisplayPageProducts == null)
				cb_DisplayPageProducts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_DisplayPageProducts);
			return cb_DisplayPageProducts;
		}

		static IntPtr n_DisplayPageProducts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.DisplayPageProducts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='DisplayPageProducts' and count(parameter)=0]"
		[Register ("DisplayPageProducts", "()Lcom/atinternet/tracker/ecommerce/DisplayPageProducts;", "GetDisplayPageProductsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.DisplayPageProducts DisplayPageProducts ()
		{
			const string __id = "DisplayPageProducts.()Lcom/atinternet/tracker/ecommerce/DisplayPageProducts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.DisplayPageProducts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_DisplayProducts;
#pragma warning disable 0169
		static Delegate GetDisplayProductsHandler ()
		{
			if (cb_DisplayProducts == null)
				cb_DisplayProducts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_DisplayProducts);
			return cb_DisplayProducts;
		}

		static IntPtr n_DisplayProducts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.DisplayProducts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='DisplayProducts' and count(parameter)=0]"
		[Register ("DisplayProducts", "()Lcom/atinternet/tracker/ecommerce/DisplayProducts;", "GetDisplayProductsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.DisplayProducts DisplayProducts ()
		{
			const string __id = "DisplayProducts.()Lcom/atinternet/tracker/ecommerce/DisplayProducts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.DisplayProducts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_PaymentCheckouts;
#pragma warning disable 0169
		static Delegate GetPaymentCheckoutsHandler ()
		{
			if (cb_PaymentCheckouts == null)
				cb_PaymentCheckouts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_PaymentCheckouts);
			return cb_PaymentCheckouts;
		}

		static IntPtr n_PaymentCheckouts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.PaymentCheckouts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='PaymentCheckouts' and count(parameter)=0]"
		[Register ("PaymentCheckouts", "()Lcom/atinternet/tracker/ecommerce/PaymentCheckouts;", "GetPaymentCheckoutsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.PaymentCheckouts PaymentCheckouts ()
		{
			const string __id = "PaymentCheckouts.()Lcom/atinternet/tracker/ecommerce/PaymentCheckouts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.PaymentCheckouts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_RemoveProducts;
#pragma warning disable 0169
		static Delegate GetRemoveProductsHandler ()
		{
			if (cb_RemoveProducts == null)
				cb_RemoveProducts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_RemoveProducts);
			return cb_RemoveProducts;
		}

		static IntPtr n_RemoveProducts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.RemoveProducts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='RemoveProducts' and count(parameter)=0]"
		[Register ("RemoveProducts", "()Lcom/atinternet/tracker/ecommerce/RemoveProducts;", "GetRemoveProductsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.RemoveProducts RemoveProducts ()
		{
			const string __id = "RemoveProducts.()Lcom/atinternet/tracker/ecommerce/RemoveProducts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.RemoveProducts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_TransactionConfirmations;
#pragma warning disable 0169
		static Delegate GetTransactionConfirmationsHandler ()
		{
			if (cb_TransactionConfirmations == null)
				cb_TransactionConfirmations = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_TransactionConfirmations);
			return cb_TransactionConfirmations;
		}

		static IntPtr n_TransactionConfirmations (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.TransactionConfirmations ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='TransactionConfirmations' and count(parameter)=0]"
		[Register ("TransactionConfirmations", "()Lcom/atinternet/tracker/ecommerce/TransactionConfirmations;", "GetTransactionConfirmationsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmations TransactionConfirmations ()
		{
			const string __id = "TransactionConfirmations.()Lcom/atinternet/tracker/ecommerce/TransactionConfirmations;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmations> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_UpdateCarts;
#pragma warning disable 0169
		static Delegate GetUpdateCartsHandler ()
		{
			if (cb_UpdateCarts == null)
				cb_UpdateCarts = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_UpdateCarts);
			return cb_UpdateCarts;
		}

		static IntPtr n_UpdateCarts (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.UpdateCarts ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='UpdateCarts' and count(parameter)=0]"
		[Register ("UpdateCarts", "()Lcom/atinternet/tracker/ecommerce/UpdateCarts;", "GetUpdateCartsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.UpdateCarts UpdateCarts ()
		{
			const string __id = "UpdateCarts.()Lcom/atinternet/tracker/ecommerce/UpdateCarts;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.UpdateCarts> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZ;
#pragma warning disable 0169
		static Delegate GetSetAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZHandler ()
		{
			if (cb_setAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZ == null)
				cb_setAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool, IntPtr, IntPtr>) n_SetAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZ);
			return cb_setAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZ;
		}

		static void n_SetAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZ (IntPtr jnienv, IntPtr native__this, bool enabled, IntPtr native_setConfigCallback, IntPtr native_sync)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.ISetConfigCallback setConfigCallback = (global::Com.Atinternet.Tracker.ISetConfigCallback)global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ISetConfigCallback> (native_setConfigCallback, JniHandleOwnership.DoNotTransfer);
			bool[] sync = (bool[]) JNIEnv.GetArray (native_sync, JniHandleOwnership.DoNotTransfer, typeof (bool));
			__this.SetAutoSalesTrackerEnabled (enabled, setConfigCallback, sync);
			if (sync != null)
				JNIEnv.CopyArray (sync, native_sync);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='setAutoSalesTrackerEnabled' and count(parameter)=3 and parameter[1][@type='boolean'] and parameter[2][@type='com.atinternet.tracker.SetConfigCallback'] and parameter[3][@type='boolean...']]"
		[Register ("setAutoSalesTrackerEnabled", "(ZLcom/atinternet/tracker/SetConfigCallback;[Z)V", "GetSetAutoSalesTrackerEnabled_ZLcom_atinternet_tracker_SetConfigCallback_arrayZHandler")]
		public virtual unsafe void SetAutoSalesTrackerEnabled (bool enabled, global::Com.Atinternet.Tracker.ISetConfigCallback setConfigCallback, params bool[] sync)
		{
			const string __id = "setAutoSalesTrackerEnabled.(ZLcom/atinternet/tracker/SetConfigCallback;[Z)V";
			IntPtr native_sync = JNIEnv.NewArray (sync);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (enabled);
				__args [1] = new JniArgumentValue ((setConfigCallback == null) ? IntPtr.Zero : ((global::Java.Lang.Object) setConfigCallback).Handle);
				__args [2] = new JniArgumentValue (native_sync);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
				if (sync != null) {
					JNIEnv.CopyArray (native_sync, sync);
					JNIEnv.DeleteLocalRef (native_sync);
				}
			}
		}

		static Delegate cb_setCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZ;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZHandler ()
		{
			if (cb_setCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZ == null)
				cb_setCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_SetCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZ);
			return cb_setCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZ;
		}

		[Obsolete]
		static void n_SetCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZ (IntPtr jnienv, IntPtr native__this, IntPtr native_domain, IntPtr native_setConfigCallback, IntPtr native_sync)
		{
			global::Com.Atinternet.Tracker.ECommerce __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ECommerce> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string domain = JNIEnv.GetString (native_domain, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.ISetConfigCallback setConfigCallback = (global::Com.Atinternet.Tracker.ISetConfigCallback)global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ISetConfigCallback> (native_setConfigCallback, JniHandleOwnership.DoNotTransfer);
			bool[] sync = (bool[]) JNIEnv.GetArray (native_sync, JniHandleOwnership.DoNotTransfer, typeof (bool));
			__this.SetCollectDomain (domain, setConfigCallback, sync);
			if (sync != null)
				JNIEnv.CopyArray (sync, native_sync);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ECommerce']/method[@name='setCollectDomain' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='com.atinternet.tracker.SetConfigCallback'] and parameter[3][@type='boolean...']]"
		[Obsolete (@"deprecated")]
		[Register ("setCollectDomain", "(Ljava/lang/String;Lcom/atinternet/tracker/SetConfigCallback;[Z)V", "GetSetCollectDomain_Ljava_lang_String_Lcom_atinternet_tracker_SetConfigCallback_arrayZHandler")]
		public virtual unsafe void SetCollectDomain (string domain, global::Com.Atinternet.Tracker.ISetConfigCallback setConfigCallback, params bool[] sync)
		{
			const string __id = "setCollectDomain.(Ljava/lang/String;Lcom/atinternet/tracker/SetConfigCallback;[Z)V";
			IntPtr native_domain = JNIEnv.NewString (domain);
			IntPtr native_sync = JNIEnv.NewArray (sync);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_domain);
				__args [1] = new JniArgumentValue ((setConfigCallback == null) ? IntPtr.Zero : ((global::Java.Lang.Object) setConfigCallback).Handle);
				__args [2] = new JniArgumentValue (native_sync);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_domain);
				if (sync != null) {
					JNIEnv.CopyArray (native_sync, sync);
					JNIEnv.DeleteLocalRef (native_sync);
				}
			}
		}

	}
}
