using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker.Ecommerce {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='PaymentCheckout']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/ecommerce/PaymentCheckout", DoNotGenerateAcw=true)]
	public partial class PaymentCheckout : global::Com.Atinternet.Tracker.Event {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/ecommerce/PaymentCheckout", typeof (PaymentCheckout));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected PaymentCheckout (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_Cart;
#pragma warning disable 0169
		static Delegate GetCartHandler ()
		{
			if (cb_Cart == null)
				cb_Cart = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Cart);
			return cb_Cart;
		}

		static IntPtr n_Cart (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.PaymentCheckout __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.PaymentCheckout> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Cart ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='PaymentCheckout']/method[@name='Cart' and count(parameter)=0]"
		[Register ("Cart", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceCart;", "GetCartHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceCart Cart ()
		{
			const string __id = "Cart.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceCart;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceCart> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Shipping;
#pragma warning disable 0169
		static Delegate GetShippingHandler ()
		{
			if (cb_Shipping == null)
				cb_Shipping = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Shipping);
			return cb_Shipping;
		}

		static IntPtr n_Shipping (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.PaymentCheckout __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.PaymentCheckout> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Shipping ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='PaymentCheckout']/method[@name='Shipping' and count(parameter)=0]"
		[Register ("Shipping", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceShipping;", "GetShippingHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceShipping Shipping ()
		{
			const string __id = "Shipping.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceShipping;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceShipping> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
