using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker.Ecommerce {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='TransactionConfirmation']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/ecommerce/TransactionConfirmation", DoNotGenerateAcw=true)]
	public partial class TransactionConfirmation : global::Com.Atinternet.Tracker.Event {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/ecommerce/TransactionConfirmation", typeof (TransactionConfirmation));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected TransactionConfirmation (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_Cart;
#pragma warning disable 0169
		static Delegate GetCartHandler ()
		{
			if (cb_Cart == null)
				cb_Cart = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Cart);
			return cb_Cart;
		}

		static IntPtr n_Cart (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Cart ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='TransactionConfirmation']/method[@name='Cart' and count(parameter)=0]"
		[Register ("Cart", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceCart;", "GetCartHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceCart Cart ()
		{
			const string __id = "Cart.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceCart;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceCart> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Payment;
#pragma warning disable 0169
		static Delegate GetPaymentHandler ()
		{
			if (cb_Payment == null)
				cb_Payment = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Payment);
			return cb_Payment;
		}

		static IntPtr n_Payment (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Payment ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='TransactionConfirmation']/method[@name='Payment' and count(parameter)=0]"
		[Register ("Payment", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommercePayment;", "GetPaymentHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommercePayment Payment ()
		{
			const string __id = "Payment.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommercePayment;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommercePayment> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Products;
#pragma warning disable 0169
		static Delegate GetProductsHandler ()
		{
			if (cb_Products == null)
				cb_Products = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Products);
			return cb_Products;
		}

		static IntPtr n_Products (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return global::Android.Runtime.JavaList<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceProduct>.ToLocalJniHandle (__this.Products ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='TransactionConfirmation']/method[@name='Products' and count(parameter)=0]"
		[Register ("Products", "()Ljava/util/List;", "GetProductsHandler")]
		public virtual unsafe global::System.Collections.Generic.IList<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceProduct> Products ()
		{
			const string __id = "Products.()Ljava/util/List;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Android.Runtime.JavaList<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceProduct>.FromJniHandle (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Shipping;
#pragma warning disable 0169
		static Delegate GetShippingHandler ()
		{
			if (cb_Shipping == null)
				cb_Shipping = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Shipping);
			return cb_Shipping;
		}

		static IntPtr n_Shipping (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Shipping ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='TransactionConfirmation']/method[@name='Shipping' and count(parameter)=0]"
		[Register ("Shipping", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceShipping;", "GetShippingHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceShipping Shipping ()
		{
			const string __id = "Shipping.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceShipping;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceShipping> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Transaction;
#pragma warning disable 0169
		static Delegate GetTransactionHandler ()
		{
			if (cb_Transaction == null)
				cb_Transaction = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Transaction);
			return cb_Transaction;
		}

		static IntPtr n_Transaction (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.TransactionConfirmation> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Transaction ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='TransactionConfirmation']/method[@name='Transaction' and count(parameter)=0]"
		[Register ("Transaction", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceTransaction;", "GetTransactionHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceTransaction Transaction ()
		{
			const string __id = "Transaction.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceTransaction;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceTransaction> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
