using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Event", DoNotGenerateAcw=true)]
	public partial class Event : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Event", typeof (Event));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Event (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']/constructor[@name='Event' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register (".ctor", "(Ljava/lang/String;)V", "")]
		public unsafe Event (string name)
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			const string __id = "(Ljava/lang/String;)V";

			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_name);
				var __r = _members.InstanceMethods.StartCreateInstance (__id, ((object) this).GetType (), __args);
				SetHandle (__r.Handle, JniHandleOwnership.TransferLocalRef);
				_members.InstanceMethods.FinishCreateInstance (__id, this, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

		static Delegate cb_getAdditionalEvents;
#pragma warning disable 0169
		static Delegate GetGetAdditionalEventsHandler ()
		{
			if (cb_getAdditionalEvents == null)
				cb_getAdditionalEvents = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetAdditionalEvents);
			return cb_getAdditionalEvents;
		}

		static IntPtr n_GetAdditionalEvents (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Event __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return global::Android.Runtime.JavaList<global::Com.Atinternet.Tracker.Event>.ToLocalJniHandle (__this.AdditionalEvents);
		}
#pragma warning restore 0169

		protected virtual unsafe global::System.Collections.Generic.IList<global::Com.Atinternet.Tracker.Event> AdditionalEvents {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']/method[@name='getAdditionalEvents' and count(parameter)=0]"
			[Register ("getAdditionalEvents", "()Ljava/util/List;", "GetGetAdditionalEventsHandler")]
			get {
				const string __id = "getAdditionalEvents.()Ljava/util/List;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return global::Android.Runtime.JavaList<global::Com.Atinternet.Tracker.Event>.FromJniHandle (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getData;
#pragma warning disable 0169
		static Delegate GetGetDataHandler ()
		{
			if (cb_getData == null)
				cb_getData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetData);
			return cb_getData;
		}

		static IntPtr n_GetData (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Event __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.ToLocalJniHandle (__this.Data);
		}
#pragma warning restore 0169

		protected virtual unsafe global::System.Collections.Generic.IDictionary<string, global::Java.Lang.Object> Data {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']/method[@name='getData' and count(parameter)=0]"
			[Register ("getData", "()Ljava/util/Map;", "GetGetDataHandler")]
			get {
				const string __id = "getData.()Ljava/util/Map;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.FromJniHandle (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getName;
#pragma warning disable 0169
		static Delegate GetGetNameHandler ()
		{
			if (cb_getName == null)
				cb_getName = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetName);
			return cb_getName;
		}

		static IntPtr n_GetName (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Event __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Name);
		}
#pragma warning restore 0169

		protected virtual unsafe string Name {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']/method[@name='getName' and count(parameter)=0]"
			[Register ("getName", "()Ljava/lang/String;", "GetGetNameHandler")]
			get {
				const string __id = "getName.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_setData_Ljava_util_Map_;
#pragma warning disable 0169
		static Delegate GetSetData_Ljava_util_Map_Handler ()
		{
			if (cb_setData_Ljava_util_Map_ == null)
				cb_setData_Ljava_util_Map_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetData_Ljava_util_Map_);
			return cb_setData_Ljava_util_Map_;
		}

		static IntPtr n_SetData_Ljava_util_Map_ (IntPtr jnienv, IntPtr native__this, IntPtr native_data)
		{
			global::Com.Atinternet.Tracker.Event __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			var data = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.FromJniHandle (native_data, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetData (data));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']/method[@name='setData' and count(parameter)=1 and parameter[1][@type='java.util.Map&lt;java.lang.String, java.lang.Object&gt;']]"
		[Register ("setData", "(Ljava/util/Map;)Lcom/atinternet/tracker/Event;", "GetSetData_Ljava_util_Map_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Event SetData (global::System.Collections.Generic.IDictionary<string, global::Java.Lang.Object> data)
		{
			const string __id = "setData.(Ljava/util/Map;)Lcom/atinternet/tracker/Event;";
			IntPtr native_data = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.ToLocalJniHandle (data);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_data);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_data);
			}
		}

		static Delegate cb_setName_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetName_Ljava_lang_String_Handler ()
		{
			if (cb_setName_Ljava_lang_String_ == null)
				cb_setName_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetName_Ljava_lang_String_);
			return cb_setName_Ljava_lang_String_;
		}

		static IntPtr n_SetName_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name)
		{
			global::Com.Atinternet.Tracker.Event __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetName (name));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Event']/method[@name='setName' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setName", "(Ljava/lang/String;)Lcom/atinternet/tracker/Event;", "GetSetName_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Event SetName (string name)
		{
			const string __id = "setName.(Ljava/lang/String;)Lcom/atinternet/tracker/Event;";
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_name);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

	}
}
