using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerListener.HitStatus']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/TrackerListener$HitStatus", DoNotGenerateAcw=true)]
	public sealed partial class TrackerListenerHitStatus : global::Java.Lang.Enum {



		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerListener.HitStatus']/field[@name='Failed']"
		[Register ("Failed")]
		public static global::Com.Atinternet.Tracker.TrackerListenerHitStatus Failed {
			get {
				const string __id = "Failed.Lcom/atinternet/tracker/TrackerListener$HitStatus;";

				var __v = _members.StaticFields.GetObjectValue (__id);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.TrackerListenerHitStatus> (__v.Handle, JniHandleOwnership.TransferLocalRef);
			}
		}


		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerListener.HitStatus']/field[@name='Success']"
		[Register ("Success")]
		public static global::Com.Atinternet.Tracker.TrackerListenerHitStatus Success {
			get {
				const string __id = "Success.Lcom/atinternet/tracker/TrackerListener$HitStatus;";

				var __v = _members.StaticFields.GetObjectValue (__id);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.TrackerListenerHitStatus> (__v.Handle, JniHandleOwnership.TransferLocalRef);
			}
		}
		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/TrackerListener$HitStatus", typeof (TrackerListenerHitStatus));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		internal TrackerListenerHitStatus (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerListener.HitStatus']/method[@name='valueOf' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("valueOf", "(Ljava/lang/String;)Lcom/atinternet/tracker/TrackerListener$HitStatus;", "")]
		public static unsafe global::Com.Atinternet.Tracker.TrackerListenerHitStatus ValueOf (string name)
		{
			const string __id = "valueOf.(Ljava/lang/String;)Lcom/atinternet/tracker/TrackerListener$HitStatus;";
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_name);
				var __rm = _members.StaticMethods.InvokeObjectMethod (__id, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.TrackerListenerHitStatus> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerListener.HitStatus']/method[@name='values' and count(parameter)=0]"
		[Register ("values", "()[Lcom/atinternet/tracker/TrackerListener$HitStatus;", "")]
		public static unsafe global::Com.Atinternet.Tracker.TrackerListenerHitStatus[] Values ()
		{
			const string __id = "values.()[Lcom/atinternet/tracker/TrackerListener$HitStatus;";
			try {
				var __rm = _members.StaticMethods.InvokeObjectMethod (__id, null);
				return (global::Com.Atinternet.Tracker.TrackerListenerHitStatus[]) JNIEnv.GetArray (__rm.Handle, JniHandleOwnership.TransferLocalRef, typeof (global::Com.Atinternet.Tracker.TrackerListenerHitStatus));
			} finally {
			}
		}

	}

	// Metadata.xml XPath interface reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']"
	[Register ("com/atinternet/tracker/TrackerListener", "", "Com.Atinternet.Tracker.ITrackerListenerInvoker")]
	public partial interface ITrackerListener : IJavaObject, IJavaPeerable {

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='buildDidEnd' and count(parameter)=2 and parameter[1][@type='com.atinternet.tracker.TrackerListener.HitStatus'] and parameter[2][@type='java.lang.String']]"
		[Register ("buildDidEnd", "(Lcom/atinternet/tracker/TrackerListener$HitStatus;Ljava/lang/String;)V", "GetBuildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void BuildDidEnd (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='didCallPartner' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("didCallPartner", "(Ljava/lang/String;)V", "GetDidCallPartner_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void DidCallPartner (string p0);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='errorDidOccur' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("errorDidOccur", "(Ljava/lang/String;)V", "GetErrorDidOccur_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void ErrorDidOccur (string p0);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='saveDidEnd' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("saveDidEnd", "(Ljava/lang/String;)V", "GetSaveDidEnd_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void SaveDidEnd (string p0);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='sendDidEnd' and count(parameter)=2 and parameter[1][@type='com.atinternet.tracker.TrackerListener.HitStatus'] and parameter[2][@type='java.lang.String']]"
		[Register ("sendDidEnd", "(Lcom/atinternet/tracker/TrackerListener$HitStatus;Ljava/lang/String;)V", "GetSendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void SendDidEnd (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='trackerNeedsFirstLaunchApproval' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("trackerNeedsFirstLaunchApproval", "(Ljava/lang/String;)V", "GetTrackerNeedsFirstLaunchApproval_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void TrackerNeedsFirstLaunchApproval (string p0);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='TrackerListener']/method[@name='warningDidOccur' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("warningDidOccur", "(Ljava/lang/String;)V", "GetWarningDidOccur_Ljava_lang_String_Handler:Com.Atinternet.Tracker.ITrackerListenerInvoker, ATInternet.Android")]
		void WarningDidOccur (string p0);

	}

	[global::Android.Runtime.Register ("com/atinternet/tracker/TrackerListener", DoNotGenerateAcw=true)]
	internal partial class ITrackerListenerInvoker : global::Java.Lang.Object, ITrackerListener {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/TrackerListener", typeof (ITrackerListenerInvoker));

		static IntPtr java_class_ref {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		IntPtr class_ref;

		public static ITrackerListener GetObject (IntPtr handle, JniHandleOwnership transfer)
		{
			return global::Java.Lang.Object.GetObject<ITrackerListener> (handle, transfer);
		}

		static IntPtr Validate (IntPtr handle)
		{
			if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
				throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
							JNIEnv.GetClassNameFromInstance (handle), "com.atinternet.tracker.TrackerListener"));
			return handle;
		}

		protected override void Dispose (bool disposing)
		{
			if (this.class_ref != IntPtr.Zero)
				JNIEnv.DeleteGlobalRef (this.class_ref);
			this.class_ref = IntPtr.Zero;
			base.Dispose (disposing);
		}

		public ITrackerListenerInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
		{
			IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
			this.class_ref = JNIEnv.NewGlobalRef (local_ref);
			JNIEnv.DeleteLocalRef (local_ref);
		}

		static Delegate cb_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetBuildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_Handler ()
		{
			if (cb_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ == null)
				cb_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr>) n_BuildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_);
			return cb_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_;
		}

		static void n_BuildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0 = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.TrackerListenerHitStatus> (native_p0, JniHandleOwnership.DoNotTransfer);
			string p1 = JNIEnv.GetString (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.BuildDidEnd (p0, p1);
		}
#pragma warning restore 0169

		IntPtr id_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_;
		public unsafe void BuildDidEnd (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1)
		{
			if (id_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ == IntPtr.Zero)
				id_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "buildDidEnd", "(Lcom/atinternet/tracker/TrackerListener$HitStatus;Ljava/lang/String;)V");
			IntPtr native_p1 = JNIEnv.NewString (p1);
			JValue* __args = stackalloc JValue [2];
			__args [0] = new JValue ((p0 == null) ? IntPtr.Zero : ((global::Java.Lang.Object) p0).Handle);
			__args [1] = new JValue (native_p1);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_buildDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p1);
		}

		static Delegate cb_didCallPartner_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetDidCallPartner_Ljava_lang_String_Handler ()
		{
			if (cb_didCallPartner_Ljava_lang_String_ == null)
				cb_didCallPartner_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_DidCallPartner_Ljava_lang_String_);
			return cb_didCallPartner_Ljava_lang_String_;
		}

		static void n_DidCallPartner_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.DidCallPartner (p0);
		}
#pragma warning restore 0169

		IntPtr id_didCallPartner_Ljava_lang_String_;
		public unsafe void DidCallPartner (string p0)
		{
			if (id_didCallPartner_Ljava_lang_String_ == IntPtr.Zero)
				id_didCallPartner_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "didCallPartner", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (native_p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_didCallPartner_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p0);
		}

		static Delegate cb_errorDidOccur_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetErrorDidOccur_Ljava_lang_String_Handler ()
		{
			if (cb_errorDidOccur_Ljava_lang_String_ == null)
				cb_errorDidOccur_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_ErrorDidOccur_Ljava_lang_String_);
			return cb_errorDidOccur_Ljava_lang_String_;
		}

		static void n_ErrorDidOccur_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.ErrorDidOccur (p0);
		}
#pragma warning restore 0169

		IntPtr id_errorDidOccur_Ljava_lang_String_;
		public unsafe void ErrorDidOccur (string p0)
		{
			if (id_errorDidOccur_Ljava_lang_String_ == IntPtr.Zero)
				id_errorDidOccur_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "errorDidOccur", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (native_p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_errorDidOccur_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p0);
		}

		static Delegate cb_saveDidEnd_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSaveDidEnd_Ljava_lang_String_Handler ()
		{
			if (cb_saveDidEnd_Ljava_lang_String_ == null)
				cb_saveDidEnd_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SaveDidEnd_Ljava_lang_String_);
			return cb_saveDidEnd_Ljava_lang_String_;
		}

		static void n_SaveDidEnd_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.SaveDidEnd (p0);
		}
#pragma warning restore 0169

		IntPtr id_saveDidEnd_Ljava_lang_String_;
		public unsafe void SaveDidEnd (string p0)
		{
			if (id_saveDidEnd_Ljava_lang_String_ == IntPtr.Zero)
				id_saveDidEnd_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "saveDidEnd", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (native_p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_saveDidEnd_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p0);
		}

		static Delegate cb_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_Handler ()
		{
			if (cb_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ == null)
				cb_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr>) n_SendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_);
			return cb_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_;
		}

		static void n_SendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0 = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.TrackerListenerHitStatus> (native_p0, JniHandleOwnership.DoNotTransfer);
			string p1 = JNIEnv.GetString (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.SendDidEnd (p0, p1);
		}
#pragma warning restore 0169

		IntPtr id_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_;
		public unsafe void SendDidEnd (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1)
		{
			if (id_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ == IntPtr.Zero)
				id_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "sendDidEnd", "(Lcom/atinternet/tracker/TrackerListener$HitStatus;Ljava/lang/String;)V");
			IntPtr native_p1 = JNIEnv.NewString (p1);
			JValue* __args = stackalloc JValue [2];
			__args [0] = new JValue ((p0 == null) ? IntPtr.Zero : ((global::Java.Lang.Object) p0).Handle);
			__args [1] = new JValue (native_p1);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_sendDidEnd_Lcom_atinternet_tracker_TrackerListener_HitStatus_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p1);
		}

		static Delegate cb_trackerNeedsFirstLaunchApproval_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetTrackerNeedsFirstLaunchApproval_Ljava_lang_String_Handler ()
		{
			if (cb_trackerNeedsFirstLaunchApproval_Ljava_lang_String_ == null)
				cb_trackerNeedsFirstLaunchApproval_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_TrackerNeedsFirstLaunchApproval_Ljava_lang_String_);
			return cb_trackerNeedsFirstLaunchApproval_Ljava_lang_String_;
		}

		static void n_TrackerNeedsFirstLaunchApproval_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.TrackerNeedsFirstLaunchApproval (p0);
		}
#pragma warning restore 0169

		IntPtr id_trackerNeedsFirstLaunchApproval_Ljava_lang_String_;
		public unsafe void TrackerNeedsFirstLaunchApproval (string p0)
		{
			if (id_trackerNeedsFirstLaunchApproval_Ljava_lang_String_ == IntPtr.Zero)
				id_trackerNeedsFirstLaunchApproval_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "trackerNeedsFirstLaunchApproval", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (native_p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_trackerNeedsFirstLaunchApproval_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p0);
		}

		static Delegate cb_warningDidOccur_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetWarningDidOccur_Ljava_lang_String_Handler ()
		{
			if (cb_warningDidOccur_Ljava_lang_String_ == null)
				cb_warningDidOccur_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_WarningDidOccur_Ljava_lang_String_);
			return cb_warningDidOccur_Ljava_lang_String_;
		}

		static void n_WarningDidOccur_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Atinternet.Tracker.ITrackerListener __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ITrackerListener> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.WarningDidOccur (p0);
		}
#pragma warning restore 0169

		IntPtr id_warningDidOccur_Ljava_lang_String_;
		public unsafe void WarningDidOccur (string p0)
		{
			if (id_warningDidOccur_Ljava_lang_String_ == IntPtr.Zero)
				id_warningDidOccur_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "warningDidOccur", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (native_p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_warningDidOccur_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p0);
		}

	}

	// event args for com.atinternet.tracker.TrackerListener.buildDidEnd
	public partial class BuildDidEndEventArgs : global::System.EventArgs {

		public BuildDidEndEventArgs (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1)
		{
			this.p0 = p0;
			this.p1 = p1;
		}

		global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0;
		public global::Com.Atinternet.Tracker.TrackerListenerHitStatus P0 {
			get { return p0; }
		}

		string p1;
		public string P1 {
			get { return p1; }
		}
	}

	// event args for com.atinternet.tracker.TrackerListener.didCallPartner
	public partial class DidCallPartnerEventArgs : global::System.EventArgs {

		public DidCallPartnerEventArgs (string p0)
		{
			this.p0 = p0;
		}

		string p0;
		public string P0 {
			get { return p0; }
		}
	}

	// event args for com.atinternet.tracker.TrackerListener.errorDidOccur
	public partial class ErrorDidOccurEventArgs : global::System.EventArgs {

		public ErrorDidOccurEventArgs (string p0)
		{
			this.p0 = p0;
		}

		string p0;
		public string P0 {
			get { return p0; }
		}
	}

	// event args for com.atinternet.tracker.TrackerListener.saveDidEnd
	public partial class SaveDidEndEventArgs : global::System.EventArgs {

		public SaveDidEndEventArgs (string p0)
		{
			this.p0 = p0;
		}

		string p0;
		public string P0 {
			get { return p0; }
		}
	}

	// event args for com.atinternet.tracker.TrackerListener.sendDidEnd
	public partial class SendDidEndEventArgs : global::System.EventArgs {

		public SendDidEndEventArgs (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1)
		{
			this.p0 = p0;
			this.p1 = p1;
		}

		global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0;
		public global::Com.Atinternet.Tracker.TrackerListenerHitStatus P0 {
			get { return p0; }
		}

		string p1;
		public string P1 {
			get { return p1; }
		}
	}

	// event args for com.atinternet.tracker.TrackerListener.trackerNeedsFirstLaunchApproval
	public partial class TrackerNeedsFirstLaunchApprovalEventArgs : global::System.EventArgs {

		public TrackerNeedsFirstLaunchApprovalEventArgs (string p0)
		{
			this.p0 = p0;
		}

		string p0;
		public string P0 {
			get { return p0; }
		}
	}

	// event args for com.atinternet.tracker.TrackerListener.warningDidOccur
	public partial class WarningDidOccurEventArgs : global::System.EventArgs {

		public WarningDidOccurEventArgs (string p0)
		{
			this.p0 = p0;
		}

		string p0;
		public string P0 {
			get { return p0; }
		}
	}

	[global::Android.Runtime.Register ("mono/com/atinternet/tracker/TrackerListenerImplementor")]
	internal sealed partial class ITrackerListenerImplementor : global::Java.Lang.Object, ITrackerListener {

		object sender;

		public ITrackerListenerImplementor (object sender)
			: base (
				global::Android.Runtime.JNIEnv.StartCreateInstance ("mono/com/atinternet/tracker/TrackerListenerImplementor", "()V"),
				JniHandleOwnership.TransferLocalRef)
		{
			global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
			this.sender = sender;
		}

#pragma warning disable 0649
		public EventHandler<BuildDidEndEventArgs> BuildDidEndHandler;
#pragma warning restore 0649

		public void BuildDidEnd (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1)
		{
			var __h = BuildDidEndHandler;
			if (__h != null)
				__h (sender, new BuildDidEndEventArgs (p0, p1));
		}
#pragma warning disable 0649
		public EventHandler<DidCallPartnerEventArgs> DidCallPartnerHandler;
#pragma warning restore 0649

		public void DidCallPartner (string p0)
		{
			var __h = DidCallPartnerHandler;
			if (__h != null)
				__h (sender, new DidCallPartnerEventArgs (p0));
		}
#pragma warning disable 0649
		public EventHandler<ErrorDidOccurEventArgs> ErrorDidOccurHandler;
#pragma warning restore 0649

		public void ErrorDidOccur (string p0)
		{
			var __h = ErrorDidOccurHandler;
			if (__h != null)
				__h (sender, new ErrorDidOccurEventArgs (p0));
		}
#pragma warning disable 0649
		public EventHandler<SaveDidEndEventArgs> SaveDidEndHandler;
#pragma warning restore 0649

		public void SaveDidEnd (string p0)
		{
			var __h = SaveDidEndHandler;
			if (__h != null)
				__h (sender, new SaveDidEndEventArgs (p0));
		}
#pragma warning disable 0649
		public EventHandler<SendDidEndEventArgs> SendDidEndHandler;
#pragma warning restore 0649

		public void SendDidEnd (global::Com.Atinternet.Tracker.TrackerListenerHitStatus p0, string p1)
		{
			var __h = SendDidEndHandler;
			if (__h != null)
				__h (sender, new SendDidEndEventArgs (p0, p1));
		}
#pragma warning disable 0649
		public EventHandler<TrackerNeedsFirstLaunchApprovalEventArgs> TrackerNeedsFirstLaunchApprovalHandler;
#pragma warning restore 0649

		public void TrackerNeedsFirstLaunchApproval (string p0)
		{
			var __h = TrackerNeedsFirstLaunchApprovalHandler;
			if (__h != null)
				__h (sender, new TrackerNeedsFirstLaunchApprovalEventArgs (p0));
		}
#pragma warning disable 0649
		public EventHandler<WarningDidOccurEventArgs> WarningDidOccurHandler;
#pragma warning restore 0649

		public void WarningDidOccur (string p0)
		{
			var __h = WarningDidOccurHandler;
			if (__h != null)
				__h (sender, new WarningDidOccurEventArgs (p0));
		}

		internal static bool __IsEmpty (ITrackerListenerImplementor value)
		{
			return value.BuildDidEndHandler == null && value.DidCallPartnerHandler == null && value.ErrorDidOccurHandler == null && value.SaveDidEndHandler == null && value.SendDidEndHandler == null && value.TrackerNeedsFirstLaunchApprovalHandler == null && value.WarningDidOccurHandler == null;
		}
	}

}
