using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='IdentifiedVisitor']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/IdentifiedVisitor", DoNotGenerateAcw=true)]
	public partial class IdentifiedVisitor : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/IdentifiedVisitor", typeof (IdentifiedVisitor));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected IdentifiedVisitor (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_set_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSet_Ljava_lang_String_Handler ()
		{
			if (cb_set_Ljava_lang_String_ == null)
				cb_set_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Set_Ljava_lang_String_);
			return cb_set_Ljava_lang_String_;
		}

		static IntPtr n_Set_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_visitorId)
		{
			global::Com.Atinternet.Tracker.IdentifiedVisitor __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.IdentifiedVisitor> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string visitorId = JNIEnv.GetString (native_visitorId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Set (visitorId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='IdentifiedVisitor']/method[@name='set' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("set", "(Ljava/lang/String;)Lcom/atinternet/tracker/Tracker;", "GetSet_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Tracker Set (string visitorId)
		{
			const string __id = "set.(Ljava/lang/String;)Lcom/atinternet/tracker/Tracker;";
			IntPtr native_visitorId = JNIEnv.NewString (visitorId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_visitorId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_visitorId);
			}
		}

		static Delegate cb_set_Ljava_lang_String_I;
#pragma warning disable 0169
		static Delegate GetSet_Ljava_lang_String_IHandler ()
		{
			if (cb_set_Ljava_lang_String_I == null)
				cb_set_Ljava_lang_String_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, int, IntPtr>) n_Set_Ljava_lang_String_I);
			return cb_set_Ljava_lang_String_I;
		}

		static IntPtr n_Set_Ljava_lang_String_I (IntPtr jnienv, IntPtr native__this, IntPtr native_visitorId, int visitorCategory)
		{
			global::Com.Atinternet.Tracker.IdentifiedVisitor __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.IdentifiedVisitor> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string visitorId = JNIEnv.GetString (native_visitorId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Set (visitorId, visitorCategory));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='IdentifiedVisitor']/method[@name='set' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='int']]"
		[Register ("set", "(Ljava/lang/String;I)Lcom/atinternet/tracker/Tracker;", "GetSet_Ljava_lang_String_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Tracker Set (string visitorId, int visitorCategory)
		{
			const string __id = "set.(Ljava/lang/String;I)Lcom/atinternet/tracker/Tracker;";
			IntPtr native_visitorId = JNIEnv.NewString (visitorId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_visitorId);
				__args [1] = new JniArgumentValue (visitorCategory);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_visitorId);
			}
		}

		static Delegate cb_set_J;
#pragma warning disable 0169
		static Delegate GetSet_JHandler ()
		{
			if (cb_set_J == null)
				cb_set_J = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, long, IntPtr>) n_Set_J);
			return cb_set_J;
		}

		static IntPtr n_Set_J (IntPtr jnienv, IntPtr native__this, long visitorId)
		{
			global::Com.Atinternet.Tracker.IdentifiedVisitor __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.IdentifiedVisitor> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Set (visitorId));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='IdentifiedVisitor']/method[@name='set' and count(parameter)=1 and parameter[1][@type='long']]"
		[Register ("set", "(J)Lcom/atinternet/tracker/Tracker;", "GetSet_JHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Tracker Set (long visitorId)
		{
			const string __id = "set.(J)Lcom/atinternet/tracker/Tracker;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (visitorId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_set_JI;
#pragma warning disable 0169
		static Delegate GetSet_JIHandler ()
		{
			if (cb_set_JI == null)
				cb_set_JI = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, long, int, IntPtr>) n_Set_JI);
			return cb_set_JI;
		}

		static IntPtr n_Set_JI (IntPtr jnienv, IntPtr native__this, long visitorId, int visitorCategory)
		{
			global::Com.Atinternet.Tracker.IdentifiedVisitor __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.IdentifiedVisitor> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Set (visitorId, visitorCategory));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='IdentifiedVisitor']/method[@name='set' and count(parameter)=2 and parameter[1][@type='long'] and parameter[2][@type='int']]"
		[Register ("set", "(JI)Lcom/atinternet/tracker/Tracker;", "GetSet_JIHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Tracker Set (long visitorId, int visitorCategory)
		{
			const string __id = "set.(JI)Lcom/atinternet/tracker/Tracker;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (visitorId);
				__args [1] = new JniArgumentValue (visitorCategory);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_unset;
#pragma warning disable 0169
		static Delegate GetUnsetHandler ()
		{
			if (cb_unset == null)
				cb_unset = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Unset);
			return cb_unset;
		}

		static void n_Unset (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.IdentifiedVisitor __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.IdentifiedVisitor> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Unset ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='IdentifiedVisitor']/method[@name='unset' and count(parameter)=0]"
		[Register ("unset", "()V", "GetUnsetHandler")]
		public virtual unsafe void Unset ()
		{
			const string __id = "unset.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
