using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/LiveAudio", DoNotGenerateAcw=true)]
	public partial class LiveAudio : global::Com.Atinternet.Tracker.RichMedia {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/LiveAudio", typeof (LiveAudio));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected LiveAudio (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_setAction_Lcom_atinternet_tracker_RichMedia_Action_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetAction_Lcom_atinternet_tracker_RichMedia_Action_Handler ()
		{
			if (cb_setAction_Lcom_atinternet_tracker_RichMedia_Action_ == null)
				cb_setAction_Lcom_atinternet_tracker_RichMedia_Action_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetAction_Lcom_atinternet_tracker_RichMedia_Action_);
			return cb_setAction_Lcom_atinternet_tracker_RichMedia_Action_;
		}

		[Obsolete]
		static IntPtr n_SetAction_Lcom_atinternet_tracker_RichMedia_Action_ (IntPtr jnienv, IntPtr native__this, IntPtr native_action)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.RichMedia.Action action = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.RichMedia.Action> (native_action, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetAction (action));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setAction' and count(parameter)=1 and parameter[1][@type='com.atinternet.tracker.RichMedia.Action']]"
		[Obsolete (@"deprecated")]
		[Register ("setAction", "(Lcom/atinternet/tracker/RichMedia$Action;)Lcom/atinternet/tracker/LiveAudio;", "GetSetAction_Lcom_atinternet_tracker_RichMedia_Action_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetAction (global::Com.Atinternet.Tracker.RichMedia.Action action)
		{
			const string __id = "setAction.(Lcom/atinternet/tracker/RichMedia$Action;)Lcom/atinternet/tracker/LiveAudio;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((action == null) ? IntPtr.Zero : ((global::Java.Lang.Object) action).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setBuffering_Z;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetBuffering_ZHandler ()
		{
			if (cb_setBuffering_Z == null)
				cb_setBuffering_Z = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool, IntPtr>) n_SetBuffering_Z);
			return cb_setBuffering_Z;
		}

		[Obsolete]
		static IntPtr n_SetBuffering_Z (IntPtr jnienv, IntPtr native__this, bool isBuffering)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetBuffering (isBuffering));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setBuffering' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Obsolete (@"deprecated")]
		[Register ("setBuffering", "(Z)Lcom/atinternet/tracker/LiveAudio;", "GetSetBuffering_ZHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetBuffering (bool isBuffering)
		{
			const string __id = "setBuffering.(Z)Lcom/atinternet/tracker/LiveAudio;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (isBuffering);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setChapter1_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetChapter1_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter1_Ljava_lang_String_ == null)
				cb_setChapter1_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter1_Ljava_lang_String_);
			return cb_setChapter1_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_SetChapter1_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaTheme1)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaTheme1 = JNIEnv.GetString (native_mediaTheme1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter1 (mediaTheme1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setChapter1' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("setChapter1", "(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;", "GetSetChapter1_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetChapter1 (string mediaTheme1)
		{
			const string __id = "setChapter1.(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;";
			IntPtr native_mediaTheme1 = JNIEnv.NewString (mediaTheme1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaTheme1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaTheme1);
			}
		}

		static Delegate cb_setChapter2_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetChapter2_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter2_Ljava_lang_String_ == null)
				cb_setChapter2_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter2_Ljava_lang_String_);
			return cb_setChapter2_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_SetChapter2_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaTheme2)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaTheme2 = JNIEnv.GetString (native_mediaTheme2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter2 (mediaTheme2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setChapter2' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("setChapter2", "(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;", "GetSetChapter2_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetChapter2 (string mediaTheme2)
		{
			const string __id = "setChapter2.(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;";
			IntPtr native_mediaTheme2 = JNIEnv.NewString (mediaTheme2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaTheme2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaTheme2);
			}
		}

		static Delegate cb_setChapter3_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetChapter3_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter3_Ljava_lang_String_ == null)
				cb_setChapter3_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter3_Ljava_lang_String_);
			return cb_setChapter3_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_SetChapter3_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaTheme3)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaTheme3 = JNIEnv.GetString (native_mediaTheme3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter3 (mediaTheme3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setChapter3' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("setChapter3", "(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;", "GetSetChapter3_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetChapter3 (string mediaTheme3)
		{
			const string __id = "setChapter3.(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;";
			IntPtr native_mediaTheme3 = JNIEnv.NewString (mediaTheme3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaTheme3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaTheme3);
			}
		}

		static Delegate cb_setLevel2_I;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetLevel2_IHandler ()
		{
			if (cb_setLevel2_I == null)
				cb_setLevel2_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetLevel2_I);
			return cb_setLevel2_I;
		}

		[Obsolete]
		static IntPtr n_SetLevel2_I (IntPtr jnienv, IntPtr native__this, int mediaLevel2)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetLevel2 (mediaLevel2));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setLevel2' and count(parameter)=1 and parameter[1][@type='int']]"
		[Obsolete (@"deprecated")]
		[Register ("setLevel2", "(I)Lcom/atinternet/tracker/LiveAudio;", "GetSetLevel2_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetLevel2 (int mediaLevel2)
		{
			const string __id = "setLevel2.(I)Lcom/atinternet/tracker/LiveAudio;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (mediaLevel2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setMediaLabel_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetMediaLabel_Ljava_lang_String_Handler ()
		{
			if (cb_setMediaLabel_Ljava_lang_String_ == null)
				cb_setMediaLabel_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetMediaLabel_Ljava_lang_String_);
			return cb_setMediaLabel_Ljava_lang_String_;
		}

		static IntPtr n_SetMediaLabel_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetMediaLabel (mediaLabel));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setMediaLabel' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setMediaLabel", "(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;", "GetSetMediaLabel_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetMediaLabel (string mediaLabel)
		{
			const string __id = "setMediaLabel.(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
			}
		}

		static Delegate cb_setName_Ljava_lang_String_;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetName_Ljava_lang_String_Handler ()
		{
			if (cb_setName_Ljava_lang_String_ == null)
				cb_setName_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetName_Ljava_lang_String_);
			return cb_setName_Ljava_lang_String_;
		}

		[Obsolete]
		static IntPtr n_SetName_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel)
		{
			global::Com.Atinternet.Tracker.LiveAudio __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetName (mediaLabel));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='LiveAudio']/method[@name='setName' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Obsolete (@"deprecated")]
		[Register ("setName", "(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;", "GetSetName_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudio SetName (string mediaLabel)
		{
			const string __id = "setName.(Ljava/lang/String;)Lcom/atinternet/tracker/LiveAudio;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudio> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
			}
		}

	}
}
