using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Location']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Location", DoNotGenerateAcw=true)]
	public partial class Location : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Location", typeof (Location));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Location (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getLatitude;
#pragma warning disable 0169
		static Delegate GetGetLatitudeHandler ()
		{
			if (cb_getLatitude == null)
				cb_getLatitude = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetLatitude);
			return cb_getLatitude;
		}

		static double n_GetLatitude (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Location __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Location> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Latitude;
		}
#pragma warning restore 0169

		public virtual unsafe double Latitude {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Location']/method[@name='getLatitude' and count(parameter)=0]"
			[Register ("getLatitude", "()D", "GetGetLatitudeHandler")]
			get {
				const string __id = "getLatitude.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getLongitude;
#pragma warning disable 0169
		static Delegate GetGetLongitudeHandler ()
		{
			if (cb_getLongitude == null)
				cb_getLongitude = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetLongitude);
			return cb_getLongitude;
		}

		static double n_GetLongitude (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Location __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Location> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Longitude;
		}
#pragma warning restore 0169

		public virtual unsafe double Longitude {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Location']/method[@name='getLongitude' and count(parameter)=0]"
			[Register ("getLongitude", "()D", "GetGetLongitudeHandler")]
			get {
				const string __id = "getLongitude.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_setLatitude_D;
#pragma warning disable 0169
		static Delegate GetSetLatitude_DHandler ()
		{
			if (cb_setLatitude_D == null)
				cb_setLatitude_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetLatitude_D);
			return cb_setLatitude_D;
		}

		static IntPtr n_SetLatitude_D (IntPtr jnienv, IntPtr native__this, double latitude)
		{
			global::Com.Atinternet.Tracker.Location __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Location> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetLatitude (latitude));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Location']/method[@name='setLatitude' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setLatitude", "(D)Lcom/atinternet/tracker/Location;", "GetSetLatitude_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Location SetLatitude (double latitude)
		{
			const string __id = "setLatitude.(D)Lcom/atinternet/tracker/Location;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (latitude);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Location> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setLongitude_D;
#pragma warning disable 0169
		static Delegate GetSetLongitude_DHandler ()
		{
			if (cb_setLongitude_D == null)
				cb_setLongitude_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetLongitude_D);
			return cb_setLongitude_D;
		}

		static IntPtr n_SetLongitude_D (IntPtr jnienv, IntPtr native__this, double longitude)
		{
			global::Com.Atinternet.Tracker.Location __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Location> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetLongitude (longitude));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Location']/method[@name='setLongitude' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setLongitude", "(D)Lcom/atinternet/tracker/Location;", "GetSetLongitude_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Location SetLongitude (double longitude)
		{
			const string __id = "setLongitude.(D)Lcom/atinternet/tracker/Location;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (longitude);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Location> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
