using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/MediaPlayer", DoNotGenerateAcw=true)]
	public partial class MediaPlayer : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/MediaPlayer", typeof (MediaPlayer));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected MediaPlayer (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getPlayerId;
#pragma warning disable 0169
		static Delegate GetGetPlayerIdHandler ()
		{
			if (cb_getPlayerId == null)
				cb_getPlayerId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetPlayerId);
			return cb_getPlayerId;
		}

		static int n_GetPlayerId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.PlayerId;
		}
#pragma warning restore 0169

		public virtual unsafe int PlayerId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='getPlayerId' and count(parameter)=0]"
			[Register ("getPlayerId", "()I", "GetGetPlayerIdHandler")]
			get {
				const string __id = "getPlayerId.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_Audios;
#pragma warning disable 0169
		static Delegate GetAudiosHandler ()
		{
			if (cb_Audios == null)
				cb_Audios = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Audios);
			return cb_Audios;
		}

		static IntPtr n_Audios (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Audios ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='Audios' and count(parameter)=0]"
		[Register ("Audios", "()Lcom/atinternet/tracker/Audios;", "GetAudiosHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Audios Audios ()
		{
			const string __id = "Audios.()Lcom/atinternet/tracker/Audios;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Audios> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_LiveAudios;
#pragma warning disable 0169
		static Delegate GetLiveAudiosHandler ()
		{
			if (cb_LiveAudios == null)
				cb_LiveAudios = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_LiveAudios);
			return cb_LiveAudios;
		}

		static IntPtr n_LiveAudios (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.LiveAudios ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='LiveAudios' and count(parameter)=0]"
		[Register ("LiveAudios", "()Lcom/atinternet/tracker/LiveAudios;", "GetLiveAudiosHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveAudios LiveAudios ()
		{
			const string __id = "LiveAudios.()Lcom/atinternet/tracker/LiveAudios;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveAudios> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_LiveMedia;
#pragma warning disable 0169
		static Delegate GetLiveMediaHandler ()
		{
			if (cb_LiveMedia == null)
				cb_LiveMedia = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_LiveMedia);
			return cb_LiveMedia;
		}

		static IntPtr n_LiveMedia (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.LiveMedia ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='LiveMedia' and count(parameter)=0]"
		[Register ("LiveMedia", "()Lcom/atinternet/tracker/LiveMedia;", "GetLiveMediaHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveMedia LiveMedia ()
		{
			const string __id = "LiveMedia.()Lcom/atinternet/tracker/LiveMedia;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveMedia> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_LiveVideos;
#pragma warning disable 0169
		static Delegate GetLiveVideosHandler ()
		{
			if (cb_LiveVideos == null)
				cb_LiveVideos = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_LiveVideos);
			return cb_LiveVideos;
		}

		static IntPtr n_LiveVideos (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.LiveVideos ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='LiveVideos' and count(parameter)=0]"
		[Register ("LiveVideos", "()Lcom/atinternet/tracker/LiveVideos;", "GetLiveVideosHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.LiveVideos LiveVideos ()
		{
			const string __id = "LiveVideos.()Lcom/atinternet/tracker/LiveVideos;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.LiveVideos> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Media;
#pragma warning disable 0169
		static Delegate GetMediaHandler ()
		{
			if (cb_Media == null)
				cb_Media = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Media);
			return cb_Media;
		}

		static IntPtr n_Media (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Media ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='Media' and count(parameter)=0]"
		[Register ("Media", "()Lcom/atinternet/tracker/Media;", "GetMediaHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Media Media ()
		{
			const string __id = "Media.()Lcom/atinternet/tracker/Media;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Videos;
#pragma warning disable 0169
		static Delegate GetVideosHandler ()
		{
			if (cb_Videos == null)
				cb_Videos = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Videos);
			return cb_Videos;
		}

		static IntPtr n_Videos (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Videos ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='Videos' and count(parameter)=0]"
		[Register ("Videos", "()Lcom/atinternet/tracker/Videos;", "GetVideosHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Videos Videos ()
		{
			const string __id = "Videos.()Lcom/atinternet/tracker/Videos;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Videos> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setPlayerId_I;
#pragma warning disable 0169
		static Delegate GetSetPlayerId_IHandler ()
		{
			if (cb_setPlayerId_I == null)
				cb_setPlayerId_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetPlayerId_I);
			return cb_setPlayerId_I;
		}

		static IntPtr n_SetPlayerId_I (IntPtr jnienv, IntPtr native__this, int playerId)
		{
			global::Com.Atinternet.Tracker.MediaPlayer __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetPlayerId (playerId));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayer']/method[@name='setPlayerId' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setPlayerId", "(I)Lcom/atinternet/tracker/MediaPlayer;", "GetSetPlayerId_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MediaPlayer SetPlayerId (int playerId)
		{
			const string __id = "setPlayerId.(I)Lcom/atinternet/tracker/MediaPlayer;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (playerId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
