using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayers']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/MediaPlayers", DoNotGenerateAcw=true)]
	public partial class MediaPlayers : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/MediaPlayers", typeof (MediaPlayers));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected MediaPlayers (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add;
#pragma warning disable 0169
		static Delegate GetAddHandler ()
		{
			if (cb_add == null)
				cb_add = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Add);
			return cb_add;
		}

		static IntPtr n_Add (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayers __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayers> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Add ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayers']/method[@name='add' and count(parameter)=0]"
		[Register ("add", "()Lcom/atinternet/tracker/MediaPlayer;", "GetAddHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MediaPlayer Add ()
		{
			const string __id = "add.()Lcom/atinternet/tracker/MediaPlayer;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_I;
#pragma warning disable 0169
		static Delegate GetAdd_IHandler ()
		{
			if (cb_add_I == null)
				cb_add_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_Add_I);
			return cb_add_I;
		}

		static IntPtr n_Add_I (IntPtr jnienv, IntPtr native__this, int playerId)
		{
			global::Com.Atinternet.Tracker.MediaPlayers __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayers> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Add (playerId));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayers']/method[@name='add' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("add", "(I)Lcom/atinternet/tracker/MediaPlayer;", "GetAdd_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MediaPlayer Add (int playerId)
		{
			const string __id = "add.(I)Lcom/atinternet/tracker/MediaPlayer;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (playerId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayer> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_remove_I;
#pragma warning disable 0169
		static Delegate GetRemove_IHandler ()
		{
			if (cb_remove_I == null)
				cb_remove_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_Remove_I);
			return cb_remove_I;
		}

		static void n_Remove_I (IntPtr jnienv, IntPtr native__this, int playerId)
		{
			global::Com.Atinternet.Tracker.MediaPlayers __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayers> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Remove (playerId);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayers']/method[@name='remove' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("remove", "(I)V", "GetRemove_IHandler")]
		public virtual unsafe void Remove (int playerId)
		{
			const string __id = "remove.(I)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (playerId);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
			}
		}

		static Delegate cb_removeAll;
#pragma warning disable 0169
		static Delegate GetRemoveAllHandler ()
		{
			if (cb_removeAll == null)
				cb_removeAll = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_RemoveAll);
			return cb_removeAll;
		}

		static void n_RemoveAll (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MediaPlayers __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MediaPlayers> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RemoveAll ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MediaPlayers']/method[@name='removeAll' and count(parameter)=0]"
		[Register ("removeAll", "()V", "GetRemoveAllHandler")]
		public virtual unsafe void RemoveAll ()
		{
			const string __id = "removeAll.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
