using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Medium']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Medium", DoNotGenerateAcw=true)]
	public partial class Medium : global::Com.Atinternet.Tracker.RichMedia {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Medium", typeof (Medium));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Medium (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_setDuration_I;
#pragma warning disable 0169
		static Delegate GetSetDuration_IHandler ()
		{
			if (cb_setDuration_I == null)
				cb_setDuration_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetDuration_I);
			return cb_setDuration_I;
		}

		static IntPtr n_SetDuration_I (IntPtr jnienv, IntPtr native__this, int duration)
		{
			global::Com.Atinternet.Tracker.Medium __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetDuration (duration));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Medium']/method[@name='setDuration' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setDuration", "(I)Lcom/atinternet/tracker/Medium;", "GetSetDuration_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium SetDuration (int duration)
		{
			const string __id = "setDuration.(I)Lcom/atinternet/tracker/Medium;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (duration);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setMediaLabel_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetMediaLabel_Ljava_lang_String_Handler ()
		{
			if (cb_setMediaLabel_Ljava_lang_String_ == null)
				cb_setMediaLabel_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetMediaLabel_Ljava_lang_String_);
			return cb_setMediaLabel_Ljava_lang_String_;
		}

		static IntPtr n_SetMediaLabel_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel)
		{
			global::Com.Atinternet.Tracker.Medium __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetMediaLabel (mediaLabel));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Medium']/method[@name='setMediaLabel' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setMediaLabel", "(Ljava/lang/String;)Lcom/atinternet/tracker/Medium;", "GetSetMediaLabel_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium SetMediaLabel (string mediaLabel)
		{
			const string __id = "setMediaLabel.(Ljava/lang/String;)Lcom/atinternet/tracker/Medium;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
			}
		}

		static Delegate cb_setMediaType_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetMediaType_Ljava_lang_String_Handler ()
		{
			if (cb_setMediaType_Ljava_lang_String_ == null)
				cb_setMediaType_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetMediaType_Ljava_lang_String_);
			return cb_setMediaType_Ljava_lang_String_;
		}

		static IntPtr n_SetMediaType_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaType)
		{
			global::Com.Atinternet.Tracker.Medium __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaType = JNIEnv.GetString (native_mediaType, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetMediaType (mediaType));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Medium']/method[@name='setMediaType' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setMediaType", "(Ljava/lang/String;)Lcom/atinternet/tracker/Medium;", "GetSetMediaType_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium SetMediaType (string mediaType)
		{
			const string __id = "setMediaType.(Ljava/lang/String;)Lcom/atinternet/tracker/Medium;";
			IntPtr native_mediaType = JNIEnv.NewString (mediaType);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaType);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaType);
			}
		}

	}
}
