using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/MvTesting", DoNotGenerateAcw=true)]
	public partial class MvTesting : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/MvTesting", typeof (MvTesting));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected MvTesting (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getCreation;
#pragma warning disable 0169
		static Delegate GetGetCreationHandler ()
		{
			if (cb_getCreation == null)
				cb_getCreation = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCreation);
			return cb_getCreation;
		}

		static IntPtr n_GetCreation (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Creation);
		}
#pragma warning restore 0169

		public virtual unsafe string Creation {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='getCreation' and count(parameter)=0]"
			[Register ("getCreation", "()Ljava/lang/String;", "GetGetCreationHandler")]
			get {
				const string __id = "getCreation.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getTest;
#pragma warning disable 0169
		static Delegate GetGetTestHandler ()
		{
			if (cb_getTest == null)
				cb_getTest = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetTest);
			return cb_getTest;
		}

		static IntPtr n_GetTest (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Test);
		}
#pragma warning restore 0169

		public virtual unsafe string Test {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='getTest' and count(parameter)=0]"
			[Register ("getTest", "()Ljava/lang/String;", "GetGetTestHandler")]
			get {
				const string __id = "getTest.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getWaveId;
#pragma warning disable 0169
		static Delegate GetGetWaveIdHandler ()
		{
			if (cb_getWaveId == null)
				cb_getWaveId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetWaveId);
			return cb_getWaveId;
		}

		static int n_GetWaveId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.WaveId;
		}
#pragma warning restore 0169

		public virtual unsafe int WaveId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='getWaveId' and count(parameter)=0]"
			[Register ("getWaveId", "()I", "GetGetWaveIdHandler")]
			get {
				const string __id = "getWaveId.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_Variables;
#pragma warning disable 0169
		static Delegate GetVariablesHandler ()
		{
			if (cb_Variables == null)
				cb_Variables = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Variables);
			return cb_Variables;
		}

		static IntPtr n_Variables (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Variables ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='Variables' and count(parameter)=0]"
		[Register ("Variables", "()Lcom/atinternet/tracker/MvTestingVars;", "GetVariablesHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MvTestingVars Variables ()
		{
			const string __id = "Variables.()Lcom/atinternet/tracker/MvTestingVars;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTestingVars> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_send;
#pragma warning disable 0169
		static Delegate GetSendHandler ()
		{
			if (cb_send == null)
				cb_send = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Send);
			return cb_send;
		}

		static void n_Send (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Send ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='send' and count(parameter)=0]"
		[Register ("send", "()V", "GetSendHandler")]
		public virtual unsafe void Send ()
		{
			const string __id = "send.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

		static Delegate cb_setCreation_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCreation_Ljava_lang_String_Handler ()
		{
			if (cb_setCreation_Ljava_lang_String_ == null)
				cb_setCreation_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetCreation_Ljava_lang_String_);
			return cb_setCreation_Ljava_lang_String_;
		}

		static IntPtr n_SetCreation_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_creation)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string creation = JNIEnv.GetString (native_creation, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetCreation (creation));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='setCreation' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setCreation", "(Ljava/lang/String;)Lcom/atinternet/tracker/MvTesting;", "GetSetCreation_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MvTesting SetCreation (string creation)
		{
			const string __id = "setCreation.(Ljava/lang/String;)Lcom/atinternet/tracker/MvTesting;";
			IntPtr native_creation = JNIEnv.NewString (creation);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_creation);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_creation);
			}
		}

		static Delegate cb_setTest_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetTest_Ljava_lang_String_Handler ()
		{
			if (cb_setTest_Ljava_lang_String_ == null)
				cb_setTest_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetTest_Ljava_lang_String_);
			return cb_setTest_Ljava_lang_String_;
		}

		static IntPtr n_SetTest_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_test)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string test = JNIEnv.GetString (native_test, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetTest (test));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='setTest' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setTest", "(Ljava/lang/String;)Lcom/atinternet/tracker/MvTesting;", "GetSetTest_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MvTesting SetTest (string test)
		{
			const string __id = "setTest.(Ljava/lang/String;)Lcom/atinternet/tracker/MvTesting;";
			IntPtr native_test = JNIEnv.NewString (test);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_test);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_test);
			}
		}

		static Delegate cb_setWaveId_I;
#pragma warning disable 0169
		static Delegate GetSetWaveId_IHandler ()
		{
			if (cb_setWaveId_I == null)
				cb_setWaveId_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetWaveId_I);
			return cb_setWaveId_I;
		}

		static IntPtr n_SetWaveId_I (IntPtr jnienv, IntPtr native__this, int waveId)
		{
			global::Com.Atinternet.Tracker.MvTesting __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetWaveId (waveId));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTesting']/method[@name='setWaveId' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setWaveId", "(I)Lcom/atinternet/tracker/MvTesting;", "GetSetWaveId_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MvTesting SetWaveId (int waveId)
		{
			const string __id = "setWaveId.(I)Lcom/atinternet/tracker/MvTesting;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (waveId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
