using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTestings']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/MvTestings", DoNotGenerateAcw=true)]
	public partial class MvTestings : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/MvTestings", typeof (MvTestings));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected MvTestings (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Ljava_lang_String_ILjava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_ILjava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_ILjava_lang_String_ == null)
				cb_add_Ljava_lang_String_ILjava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, int, IntPtr, IntPtr>) n_Add_Ljava_lang_String_ILjava_lang_String_);
			return cb_add_Ljava_lang_String_ILjava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_ILjava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_test, int waveId, IntPtr native_creation)
		{
			global::Com.Atinternet.Tracker.MvTestings __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTestings> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string test = JNIEnv.GetString (native_test, JniHandleOwnership.DoNotTransfer);
			string creation = JNIEnv.GetString (native_creation, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (test, waveId, creation));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='MvTestings']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='int'] and parameter[3][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;ILjava/lang/String;)Lcom/atinternet/tracker/MvTesting;", "GetAdd_Ljava_lang_String_ILjava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.MvTesting Add (string test, int waveId, string creation)
		{
			const string __id = "add.(Ljava/lang/String;ILjava/lang/String;)Lcom/atinternet/tracker/MvTesting;";
			IntPtr native_test = JNIEnv.NewString (test);
			IntPtr native_creation = JNIEnv.NewString (creation);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_test);
				__args [1] = new JniArgumentValue (waveId);
				__args [2] = new JniArgumentValue (native_creation);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.MvTesting> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_test);
				JNIEnv.DeleteLocalRef (native_creation);
			}
		}

	}
}
