using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Offline", DoNotGenerateAcw=true)]
	public partial class Offline : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Offline", typeof (Offline));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Offline (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_count;
#pragma warning disable 0169
		static Delegate GetCountHandler ()
		{
			if (cb_count == null)
				cb_count = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_Count);
			return cb_count;
		}

		static int n_Count (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Count ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='count' and count(parameter)=0]"
		[Register ("count", "()I", "GetCountHandler")]
		public virtual unsafe int Count ()
		{
			const string __id = "count.()I";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
				return __rm;
			} finally {
			}
		}

		static Delegate cb_delete;
#pragma warning disable 0169
		static Delegate GetDeleteHandler ()
		{
			if (cb_delete == null)
				cb_delete = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Delete);
			return cb_delete;
		}

		static void n_Delete (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Delete ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='delete' and count(parameter)=0]"
		[Register ("delete", "()V", "GetDeleteHandler")]
		public virtual unsafe void Delete ()
		{
			const string __id = "delete.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

		static Delegate cb_delete_I;
#pragma warning disable 0169
		static Delegate GetDelete_IHandler ()
		{
			if (cb_delete_I == null)
				cb_delete_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_Delete_I);
			return cb_delete_I;
		}

		static void n_Delete_I (IntPtr jnienv, IntPtr native__this, int daysCount)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Delete (daysCount);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='delete' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("delete", "(I)V", "GetDelete_IHandler")]
		public virtual unsafe void Delete (int daysCount)
		{
			const string __id = "delete.(I)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (daysCount);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
			}
		}

		static Delegate cb_delete_Ljava_util_Date_;
#pragma warning disable 0169
		static Delegate GetDelete_Ljava_util_Date_Handler ()
		{
			if (cb_delete_Ljava_util_Date_ == null)
				cb_delete_Ljava_util_Date_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_Delete_Ljava_util_Date_);
			return cb_delete_Ljava_util_Date_;
		}

		static void n_Delete_Ljava_util_Date_ (IntPtr jnienv, IntPtr native__this, IntPtr native_date)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date date = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_date, JniHandleOwnership.DoNotTransfer);
			__this.Delete (date);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='delete' and count(parameter)=1 and parameter[1][@type='java.util.Date']]"
		[Register ("delete", "(Ljava/util/Date;)V", "GetDelete_Ljava_util_Date_Handler")]
		public virtual unsafe void Delete (global::Java.Util.Date date)
		{
			const string __id = "delete.(Ljava/util/Date;)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((date == null) ? IntPtr.Zero : ((global::Java.Lang.Object) date).Handle);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
			}
		}

		static Delegate cb_dispatch;
#pragma warning disable 0169
		static Delegate GetDispatchHandler ()
		{
			if (cb_dispatch == null)
				cb_dispatch = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Dispatch);
			return cb_dispatch;
		}

		static void n_Dispatch (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Dispatch ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='dispatch' and count(parameter)=0]"
		[Register ("dispatch", "()V", "GetDispatchHandler")]
		public virtual unsafe void Dispatch ()
		{
			const string __id = "dispatch.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

		static Delegate cb_get;
#pragma warning disable 0169
		static Delegate GetGetHandler ()
		{
			if (cb_get == null)
				cb_get = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Get);
			return cb_get;
		}

		static IntPtr n_Get (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return global::Android.Runtime.JavaList<global::Com.Atinternet.Tracker.Hit>.ToLocalJniHandle (__this.Get ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='get' and count(parameter)=0]"
		[Register ("get", "()Ljava/util/ArrayList;", "GetGetHandler")]
		public virtual unsafe global::System.Collections.Generic.IList<global::Com.Atinternet.Tracker.Hit> Get ()
		{
			const string __id = "get.()Ljava/util/ArrayList;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Android.Runtime.JavaList<global::Com.Atinternet.Tracker.Hit>.FromJniHandle (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_latest;
#pragma warning disable 0169
		static Delegate GetLatestHandler ()
		{
			if (cb_latest == null)
				cb_latest = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Latest);
			return cb_latest;
		}

		static IntPtr n_Latest (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Latest ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='latest' and count(parameter)=0]"
		[Register ("latest", "()Lcom/atinternet/tracker/Hit;", "GetLatestHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Hit Latest ()
		{
			const string __id = "latest.()Lcom/atinternet/tracker/Hit;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Hit> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_oldest;
#pragma warning disable 0169
		static Delegate GetOldestHandler ()
		{
			if (cb_oldest == null)
				cb_oldest = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Oldest);
			return cb_oldest;
		}

		static IntPtr n_Oldest (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Offline __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Offline> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Oldest ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Offline']/method[@name='oldest' and count(parameter)=0]"
		[Register ("oldest", "()Lcom/atinternet/tracker/Hit;", "GetOldestHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Hit Oldest ()
		{
			const string __id = "oldest.()Lcom/atinternet/tracker/Hit;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Hit> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
