using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Order", DoNotGenerateAcw=true)]
	public partial class Order : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Order", typeof (Order));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Order (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_isConfirmationRequired;
#pragma warning disable 0169
		static Delegate GetIsConfirmationRequiredHandler ()
		{
			if (cb_isConfirmationRequired == null)
				cb_isConfirmationRequired = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_IsConfirmationRequired);
			return cb_isConfirmationRequired;
		}

		static bool n_IsConfirmationRequired (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.IsConfirmationRequired;
		}
#pragma warning restore 0169

		public virtual unsafe bool IsConfirmationRequired {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='isConfirmationRequired' and count(parameter)=0]"
			[Register ("isConfirmationRequired", "()Z", "GetIsConfirmationRequiredHandler")]
			get {
				const string __id = "isConfirmationRequired.()Z";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualBooleanMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_isNewCustomer;
#pragma warning disable 0169
		static Delegate GetIsNewCustomerHandler ()
		{
			if (cb_isNewCustomer == null)
				cb_isNewCustomer = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_IsNewCustomer);
			return cb_isNewCustomer;
		}

		static bool n_IsNewCustomer (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.IsNewCustomer;
		}
#pragma warning restore 0169

		public virtual unsafe bool IsNewCustomer {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='isNewCustomer' and count(parameter)=0]"
			[Register ("isNewCustomer", "()Z", "GetIsNewCustomerHandler")]
			get {
				const string __id = "isNewCustomer.()Z";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualBooleanMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getOrderId;
#pragma warning disable 0169
		static Delegate GetGetOrderIdHandler ()
		{
			if (cb_getOrderId == null)
				cb_getOrderId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetOrderId);
			return cb_getOrderId;
		}

		static IntPtr n_GetOrderId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.OrderId);
		}
#pragma warning restore 0169

		public virtual unsafe string OrderId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='getOrderId' and count(parameter)=0]"
			[Register ("getOrderId", "()Ljava/lang/String;", "GetGetOrderIdHandler")]
			get {
				const string __id = "getOrderId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getPaymentMethod;
#pragma warning disable 0169
		static Delegate GetGetPaymentMethodHandler ()
		{
			if (cb_getPaymentMethod == null)
				cb_getPaymentMethod = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetPaymentMethod);
			return cb_getPaymentMethod;
		}

		static int n_GetPaymentMethod (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.PaymentMethod;
		}
#pragma warning restore 0169

		public virtual unsafe int PaymentMethod {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='getPaymentMethod' and count(parameter)=0]"
			[Register ("getPaymentMethod", "()I", "GetGetPaymentMethodHandler")]
			get {
				const string __id = "getPaymentMethod.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getStatus;
#pragma warning disable 0169
		static Delegate GetGetStatusHandler ()
		{
			if (cb_getStatus == null)
				cb_getStatus = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetStatus);
			return cb_getStatus;
		}

		static int n_GetStatus (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Status;
		}
#pragma warning restore 0169

		public virtual unsafe int Status {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='getStatus' and count(parameter)=0]"
			[Register ("getStatus", "()I", "GetGetStatusHandler")]
			get {
				const string __id = "getStatus.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getTurnover;
#pragma warning disable 0169
		static Delegate GetGetTurnoverHandler ()
		{
			if (cb_getTurnover == null)
				cb_getTurnover = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetTurnover);
			return cb_getTurnover;
		}

		static double n_GetTurnover (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Turnover;
		}
#pragma warning restore 0169

		public virtual unsafe double Turnover {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='getTurnover' and count(parameter)=0]"
			[Register ("getTurnover", "()D", "GetGetTurnoverHandler")]
			get {
				const string __id = "getTurnover.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_Amount;
#pragma warning disable 0169
		static Delegate GetAmountHandler ()
		{
			if (cb_Amount == null)
				cb_Amount = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Amount);
			return cb_Amount;
		}

		static IntPtr n_Amount (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Amount ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='Amount' and count(parameter)=0]"
		[Register ("Amount", "()Lcom/atinternet/tracker/OrderAmount;", "GetAmountHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderAmount Amount ()
		{
			const string __id = "Amount.()Lcom/atinternet/tracker/OrderAmount;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_CustomVars;
#pragma warning disable 0169
		static Delegate GetCustomVarsHandler ()
		{
			if (cb_CustomVars == null)
				cb_CustomVars = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_CustomVars);
			return cb_CustomVars;
		}

		static IntPtr n_CustomVars (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CustomVars ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='CustomVars' and count(parameter)=0]"
		[Register ("CustomVars", "()Lcom/atinternet/tracker/OrderCustomVars;", "GetCustomVarsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderCustomVars CustomVars ()
		{
			const string __id = "CustomVars.()Lcom/atinternet/tracker/OrderCustomVars;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderCustomVars> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Delivery;
#pragma warning disable 0169
		static Delegate GetDeliveryHandler ()
		{
			if (cb_Delivery == null)
				cb_Delivery = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Delivery);
			return cb_Delivery;
		}

		static IntPtr n_Delivery (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Delivery ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='Delivery' and count(parameter)=0]"
		[Register ("Delivery", "()Lcom/atinternet/tracker/OrderDelivery;", "GetDeliveryHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDelivery Delivery ()
		{
			const string __id = "Delivery.()Lcom/atinternet/tracker/OrderDelivery;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Discount;
#pragma warning disable 0169
		static Delegate GetDiscountHandler ()
		{
			if (cb_Discount == null)
				cb_Discount = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Discount);
			return cb_Discount;
		}

		static IntPtr n_Discount (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Discount ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='Discount' and count(parameter)=0]"
		[Register ("Discount", "()Lcom/atinternet/tracker/OrderDiscount;", "GetDiscountHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDiscount Discount ()
		{
			const string __id = "Discount.()Lcom/atinternet/tracker/OrderDiscount;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setConfirmationRequired_Z;
#pragma warning disable 0169
		static Delegate GetSetConfirmationRequired_ZHandler ()
		{
			if (cb_setConfirmationRequired_Z == null)
				cb_setConfirmationRequired_Z = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool, IntPtr>) n_SetConfirmationRequired_Z);
			return cb_setConfirmationRequired_Z;
		}

		static IntPtr n_SetConfirmationRequired_Z (IntPtr jnienv, IntPtr native__this, bool confirmationRequired)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetConfirmationRequired (confirmationRequired));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='setConfirmationRequired' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setConfirmationRequired", "(Z)Lcom/atinternet/tracker/Order;", "GetSetConfirmationRequired_ZHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order SetConfirmationRequired (bool confirmationRequired)
		{
			const string __id = "setConfirmationRequired.(Z)Lcom/atinternet/tracker/Order;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (confirmationRequired);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setNewCustomer_Z;
#pragma warning disable 0169
		static Delegate GetSetNewCustomer_ZHandler ()
		{
			if (cb_setNewCustomer_Z == null)
				cb_setNewCustomer_Z = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool, IntPtr>) n_SetNewCustomer_Z);
			return cb_setNewCustomer_Z;
		}

		static IntPtr n_SetNewCustomer_Z (IntPtr jnienv, IntPtr native__this, bool newCustomer)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetNewCustomer (newCustomer));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='setNewCustomer' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setNewCustomer", "(Z)Lcom/atinternet/tracker/Order;", "GetSetNewCustomer_ZHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order SetNewCustomer (bool newCustomer)
		{
			const string __id = "setNewCustomer.(Z)Lcom/atinternet/tracker/Order;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (newCustomer);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setOrderId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetOrderId_Ljava_lang_String_Handler ()
		{
			if (cb_setOrderId_Ljava_lang_String_ == null)
				cb_setOrderId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetOrderId_Ljava_lang_String_);
			return cb_setOrderId_Ljava_lang_String_;
		}

		static IntPtr n_SetOrderId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_orderId)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string orderId = JNIEnv.GetString (native_orderId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetOrderId (orderId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='setOrderId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setOrderId", "(Ljava/lang/String;)Lcom/atinternet/tracker/Order;", "GetSetOrderId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order SetOrderId (string orderId)
		{
			const string __id = "setOrderId.(Ljava/lang/String;)Lcom/atinternet/tracker/Order;";
			IntPtr native_orderId = JNIEnv.NewString (orderId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_orderId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_orderId);
			}
		}

		static Delegate cb_setPaymentMethod_I;
#pragma warning disable 0169
		static Delegate GetSetPaymentMethod_IHandler ()
		{
			if (cb_setPaymentMethod_I == null)
				cb_setPaymentMethod_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetPaymentMethod_I);
			return cb_setPaymentMethod_I;
		}

		static IntPtr n_SetPaymentMethod_I (IntPtr jnienv, IntPtr native__this, int paymentMethod)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetPaymentMethod (paymentMethod));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='setPaymentMethod' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setPaymentMethod", "(I)Lcom/atinternet/tracker/Order;", "GetSetPaymentMethod_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order SetPaymentMethod (int paymentMethod)
		{
			const string __id = "setPaymentMethod.(I)Lcom/atinternet/tracker/Order;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (paymentMethod);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setStatus_I;
#pragma warning disable 0169
		static Delegate GetSetStatus_IHandler ()
		{
			if (cb_setStatus_I == null)
				cb_setStatus_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetStatus_I);
			return cb_setStatus_I;
		}

		static IntPtr n_SetStatus_I (IntPtr jnienv, IntPtr native__this, int status)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetStatus (status));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='setStatus' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setStatus", "(I)Lcom/atinternet/tracker/Order;", "GetSetStatus_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order SetStatus (int status)
		{
			const string __id = "setStatus.(I)Lcom/atinternet/tracker/Order;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (status);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setTurnover_D;
#pragma warning disable 0169
		static Delegate GetSetTurnover_DHandler ()
		{
			if (cb_setTurnover_D == null)
				cb_setTurnover_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetTurnover_D);
			return cb_setTurnover_D;
		}

		static IntPtr n_SetTurnover_D (IntPtr jnienv, IntPtr native__this, double turnover)
		{
			global::Com.Atinternet.Tracker.Order __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetTurnover (turnover));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Order']/method[@name='setTurnover' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setTurnover", "(D)Lcom/atinternet/tracker/Order;", "GetSetTurnover_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order SetTurnover (double turnover)
		{
			const string __id = "setTurnover.(D)Lcom/atinternet/tracker/Order;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (turnover);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
