using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/OrderDelivery", DoNotGenerateAcw=true)]
	public partial class OrderDelivery : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/OrderDelivery", typeof (OrderDelivery));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected OrderDelivery (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getDeliveryMethod;
#pragma warning disable 0169
		static Delegate GetGetDeliveryMethodHandler ()
		{
			if (cb_getDeliveryMethod == null)
				cb_getDeliveryMethod = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetDeliveryMethod);
			return cb_getDeliveryMethod;
		}

		static IntPtr n_GetDeliveryMethod (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.DeliveryMethod);
		}
#pragma warning restore 0169

		public virtual unsafe string DeliveryMethod {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='getDeliveryMethod' and count(parameter)=0]"
			[Register ("getDeliveryMethod", "()Ljava/lang/String;", "GetGetDeliveryMethodHandler")]
			get {
				const string __id = "getDeliveryMethod.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getShippingFeesTaxFree;
#pragma warning disable 0169
		static Delegate GetGetShippingFeesTaxFreeHandler ()
		{
			if (cb_getShippingFeesTaxFree == null)
				cb_getShippingFeesTaxFree = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetShippingFeesTaxFree);
			return cb_getShippingFeesTaxFree;
		}

		static double n_GetShippingFeesTaxFree (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.ShippingFeesTaxFree;
		}
#pragma warning restore 0169

		public virtual unsafe double ShippingFeesTaxFree {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='getShippingFeesTaxFree' and count(parameter)=0]"
			[Register ("getShippingFeesTaxFree", "()D", "GetGetShippingFeesTaxFreeHandler")]
			get {
				const string __id = "getShippingFeesTaxFree.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getShippingFeesTaxIncluded;
#pragma warning disable 0169
		static Delegate GetGetShippingFeesTaxIncludedHandler ()
		{
			if (cb_getShippingFeesTaxIncluded == null)
				cb_getShippingFeesTaxIncluded = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetShippingFeesTaxIncluded);
			return cb_getShippingFeesTaxIncluded;
		}

		static double n_GetShippingFeesTaxIncluded (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.ShippingFeesTaxIncluded;
		}
#pragma warning restore 0169

		public virtual unsafe double ShippingFeesTaxIncluded {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='getShippingFeesTaxIncluded' and count(parameter)=0]"
			[Register ("getShippingFeesTaxIncluded", "()D", "GetGetShippingFeesTaxIncludedHandler")]
			get {
				const string __id = "getShippingFeesTaxIncluded.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_set_DDLjava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSet_DDLjava_lang_String_Handler ()
		{
			if (cb_set_DDLjava_lang_String_ == null)
				cb_set_DDLjava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, double, IntPtr, IntPtr>) n_Set_DDLjava_lang_String_);
			return cb_set_DDLjava_lang_String_;
		}

		static IntPtr n_Set_DDLjava_lang_String_ (IntPtr jnienv, IntPtr native__this, double shippingFeesTaxFree, double shippingFeesTaxIncluded, IntPtr native_deliveryMethod)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string deliveryMethod = JNIEnv.GetString (native_deliveryMethod, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Set (shippingFeesTaxFree, shippingFeesTaxIncluded, deliveryMethod));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='set' and count(parameter)=3 and parameter[1][@type='double'] and parameter[2][@type='double'] and parameter[3][@type='java.lang.String']]"
		[Register ("set", "(DDLjava/lang/String;)Lcom/atinternet/tracker/Order;", "GetSet_DDLjava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order Set (double shippingFeesTaxFree, double shippingFeesTaxIncluded, string deliveryMethod)
		{
			const string __id = "set.(DDLjava/lang/String;)Lcom/atinternet/tracker/Order;";
			IntPtr native_deliveryMethod = JNIEnv.NewString (deliveryMethod);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (shippingFeesTaxFree);
				__args [1] = new JniArgumentValue (shippingFeesTaxIncluded);
				__args [2] = new JniArgumentValue (native_deliveryMethod);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_deliveryMethod);
			}
		}

		static Delegate cb_setDeliveryMethod_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetDeliveryMethod_Ljava_lang_String_Handler ()
		{
			if (cb_setDeliveryMethod_Ljava_lang_String_ == null)
				cb_setDeliveryMethod_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetDeliveryMethod_Ljava_lang_String_);
			return cb_setDeliveryMethod_Ljava_lang_String_;
		}

		static IntPtr n_SetDeliveryMethod_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_deliveryMethod)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string deliveryMethod = JNIEnv.GetString (native_deliveryMethod, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetDeliveryMethod (deliveryMethod));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='setDeliveryMethod' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setDeliveryMethod", "(Ljava/lang/String;)Lcom/atinternet/tracker/OrderDelivery;", "GetSetDeliveryMethod_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDelivery SetDeliveryMethod (string deliveryMethod)
		{
			const string __id = "setDeliveryMethod.(Ljava/lang/String;)Lcom/atinternet/tracker/OrderDelivery;";
			IntPtr native_deliveryMethod = JNIEnv.NewString (deliveryMethod);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_deliveryMethod);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_deliveryMethod);
			}
		}

		static Delegate cb_setShippingFeesTaxFree_D;
#pragma warning disable 0169
		static Delegate GetSetShippingFeesTaxFree_DHandler ()
		{
			if (cb_setShippingFeesTaxFree_D == null)
				cb_setShippingFeesTaxFree_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetShippingFeesTaxFree_D);
			return cb_setShippingFeesTaxFree_D;
		}

		static IntPtr n_SetShippingFeesTaxFree_D (IntPtr jnienv, IntPtr native__this, double shippingFeesTaxFree)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetShippingFeesTaxFree (shippingFeesTaxFree));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='setShippingFeesTaxFree' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setShippingFeesTaxFree", "(D)Lcom/atinternet/tracker/OrderDelivery;", "GetSetShippingFeesTaxFree_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDelivery SetShippingFeesTaxFree (double shippingFeesTaxFree)
		{
			const string __id = "setShippingFeesTaxFree.(D)Lcom/atinternet/tracker/OrderDelivery;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (shippingFeesTaxFree);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setShippingFeesTaxIncluded_D;
#pragma warning disable 0169
		static Delegate GetSetShippingFeesTaxIncluded_DHandler ()
		{
			if (cb_setShippingFeesTaxIncluded_D == null)
				cb_setShippingFeesTaxIncluded_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetShippingFeesTaxIncluded_D);
			return cb_setShippingFeesTaxIncluded_D;
		}

		static IntPtr n_SetShippingFeesTaxIncluded_D (IntPtr jnienv, IntPtr native__this, double shippingFeesTaxIncluded)
		{
			global::Com.Atinternet.Tracker.OrderDelivery __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetShippingFeesTaxIncluded (shippingFeesTaxIncluded));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDelivery']/method[@name='setShippingFeesTaxIncluded' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setShippingFeesTaxIncluded", "(D)Lcom/atinternet/tracker/OrderDelivery;", "GetSetShippingFeesTaxIncluded_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDelivery SetShippingFeesTaxIncluded (double shippingFeesTaxIncluded)
		{
			const string __id = "setShippingFeesTaxIncluded.(D)Lcom/atinternet/tracker/OrderDelivery;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (shippingFeesTaxIncluded);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDelivery> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
