using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Orders']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Orders", DoNotGenerateAcw=true)]
	public partial class Orders : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Orders", typeof (Orders));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Orders (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Ljava_lang_String_D;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_DHandler ()
		{
			if (cb_add_Ljava_lang_String_D == null)
				cb_add_Ljava_lang_String_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, double, IntPtr>) n_Add_Ljava_lang_String_D);
			return cb_add_Ljava_lang_String_D;
		}

		static IntPtr n_Add_Ljava_lang_String_D (IntPtr jnienv, IntPtr native__this, IntPtr native_orderId, double turnover)
		{
			global::Com.Atinternet.Tracker.Orders __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Orders> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string orderId = JNIEnv.GetString (native_orderId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (orderId, turnover));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Orders']/method[@name='add' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='double']]"
		[Register ("add", "(Ljava/lang/String;D)Lcom/atinternet/tracker/Order;", "GetAdd_Ljava_lang_String_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order Add (string orderId, double turnover)
		{
			const string __id = "add.(Ljava/lang/String;D)Lcom/atinternet/tracker/Order;";
			IntPtr native_orderId = JNIEnv.NewString (orderId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_orderId);
				__args [1] = new JniArgumentValue (turnover);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_orderId);
			}
		}

		static Delegate cb_add_Ljava_lang_String_DI;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_DIHandler ()
		{
			if (cb_add_Ljava_lang_String_DI == null)
				cb_add_Ljava_lang_String_DI = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, double, int, IntPtr>) n_Add_Ljava_lang_String_DI);
			return cb_add_Ljava_lang_String_DI;
		}

		static IntPtr n_Add_Ljava_lang_String_DI (IntPtr jnienv, IntPtr native__this, IntPtr native_orderId, double turnover, int status)
		{
			global::Com.Atinternet.Tracker.Orders __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Orders> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string orderId = JNIEnv.GetString (native_orderId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (orderId, turnover, status));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Orders']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='double'] and parameter[3][@type='int']]"
		[Register ("add", "(Ljava/lang/String;DI)Lcom/atinternet/tracker/Order;", "GetAdd_Ljava_lang_String_DIHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order Add (string orderId, double turnover, int status)
		{
			const string __id = "add.(Ljava/lang/String;DI)Lcom/atinternet/tracker/Order;";
			IntPtr native_orderId = JNIEnv.NewString (orderId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_orderId);
				__args [1] = new JniArgumentValue (turnover);
				__args [2] = new JniArgumentValue (status);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_orderId);
			}
		}

	}
}
