using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Products", DoNotGenerateAcw=true)]
	public partial class Products : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Products", typeof (Products));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Products (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Lcom_atinternet_tracker_Product_;
#pragma warning disable 0169
		static Delegate GetAdd_Lcom_atinternet_tracker_Product_Handler ()
		{
			if (cb_add_Lcom_atinternet_tracker_Product_ == null)
				cb_add_Lcom_atinternet_tracker_Product_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Lcom_atinternet_tracker_Product_);
			return cb_add_Lcom_atinternet_tracker_Product_;
		}

		static IntPtr n_Add_Lcom_atinternet_tracker_Product_ (IntPtr jnienv, IntPtr native__this, IntPtr native_product)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.Product product = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (native_product, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (product));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=1 and parameter[1][@type='com.atinternet.tracker.Product']]"
		[Register ("add", "(Lcom/atinternet/tracker/Product;)Lcom/atinternet/tracker/Product;", "GetAdd_Lcom_atinternet_tracker_Product_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (global::Com.Atinternet.Tracker.Product product)
		{
			const string __id = "add.(Lcom/atinternet/tracker/Product;)Lcom/atinternet/tracker/Product;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((product == null) ? IntPtr.Zero : ((global::Java.Lang.Object) product).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId)
		{
			const string __id = "add.(Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_productId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId, IntPtr native_category1)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			string category1 = JNIEnv.GetString (native_category1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId, category1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId, string category1)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			IntPtr native_category1 = JNIEnv.NewString (category1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_productId);
				__args [1] = new JniArgumentValue (native_category1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
				JNIEnv.DeleteLocalRef (native_category1);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId, IntPtr native_category1, IntPtr native_category2)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			string category1 = JNIEnv.GetString (native_category1, JniHandleOwnership.DoNotTransfer);
			string category2 = JNIEnv.GetString (native_category2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId, category1, category2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId, string category1, string category2)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			IntPtr native_category1 = JNIEnv.NewString (category1);
			IntPtr native_category2 = JNIEnv.NewString (category2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_productId);
				__args [1] = new JniArgumentValue (native_category1);
				__args [2] = new JniArgumentValue (native_category2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
				JNIEnv.DeleteLocalRef (native_category1);
				JNIEnv.DeleteLocalRef (native_category2);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId, IntPtr native_category1, IntPtr native_category2, IntPtr native_category3)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			string category1 = JNIEnv.GetString (native_category1, JniHandleOwnership.DoNotTransfer);
			string category2 = JNIEnv.GetString (native_category2, JniHandleOwnership.DoNotTransfer);
			string category3 = JNIEnv.GetString (native_category3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId, category1, category2, category3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=4 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId, string category1, string category2, string category3)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			IntPtr native_category1 = JNIEnv.NewString (category1);
			IntPtr native_category2 = JNIEnv.NewString (category2);
			IntPtr native_category3 = JNIEnv.NewString (category3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [4];
				__args [0] = new JniArgumentValue (native_productId);
				__args [1] = new JniArgumentValue (native_category1);
				__args [2] = new JniArgumentValue (native_category2);
				__args [3] = new JniArgumentValue (native_category3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
				JNIEnv.DeleteLocalRef (native_category1);
				JNIEnv.DeleteLocalRef (native_category2);
				JNIEnv.DeleteLocalRef (native_category3);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId, IntPtr native_category1, IntPtr native_category2, IntPtr native_category3, IntPtr native_category4)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			string category1 = JNIEnv.GetString (native_category1, JniHandleOwnership.DoNotTransfer);
			string category2 = JNIEnv.GetString (native_category2, JniHandleOwnership.DoNotTransfer);
			string category3 = JNIEnv.GetString (native_category3, JniHandleOwnership.DoNotTransfer);
			string category4 = JNIEnv.GetString (native_category4, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId, category1, category2, category3, category4));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=5 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId, string category1, string category2, string category3, string category4)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			IntPtr native_category1 = JNIEnv.NewString (category1);
			IntPtr native_category2 = JNIEnv.NewString (category2);
			IntPtr native_category3 = JNIEnv.NewString (category3);
			IntPtr native_category4 = JNIEnv.NewString (category4);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [5];
				__args [0] = new JniArgumentValue (native_productId);
				__args [1] = new JniArgumentValue (native_category1);
				__args [2] = new JniArgumentValue (native_category2);
				__args [3] = new JniArgumentValue (native_category3);
				__args [4] = new JniArgumentValue (native_category4);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
				JNIEnv.DeleteLocalRef (native_category1);
				JNIEnv.DeleteLocalRef (native_category2);
				JNIEnv.DeleteLocalRef (native_category3);
				JNIEnv.DeleteLocalRef (native_category4);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId, IntPtr native_category1, IntPtr native_category2, IntPtr native_category3, IntPtr native_category4, IntPtr native_category5)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			string category1 = JNIEnv.GetString (native_category1, JniHandleOwnership.DoNotTransfer);
			string category2 = JNIEnv.GetString (native_category2, JniHandleOwnership.DoNotTransfer);
			string category3 = JNIEnv.GetString (native_category3, JniHandleOwnership.DoNotTransfer);
			string category4 = JNIEnv.GetString (native_category4, JniHandleOwnership.DoNotTransfer);
			string category5 = JNIEnv.GetString (native_category5, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId, category1, category2, category3, category4, category5));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=6 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String'] and parameter[6][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId, string category1, string category2, string category3, string category4, string category5)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			IntPtr native_category1 = JNIEnv.NewString (category1);
			IntPtr native_category2 = JNIEnv.NewString (category2);
			IntPtr native_category3 = JNIEnv.NewString (category3);
			IntPtr native_category4 = JNIEnv.NewString (category4);
			IntPtr native_category5 = JNIEnv.NewString (category5);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [6];
				__args [0] = new JniArgumentValue (native_productId);
				__args [1] = new JniArgumentValue (native_category1);
				__args [2] = new JniArgumentValue (native_category2);
				__args [3] = new JniArgumentValue (native_category3);
				__args [4] = new JniArgumentValue (native_category4);
				__args [5] = new JniArgumentValue (native_category5);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
				JNIEnv.DeleteLocalRef (native_category1);
				JNIEnv.DeleteLocalRef (native_category2);
				JNIEnv.DeleteLocalRef (native_category3);
				JNIEnv.DeleteLocalRef (native_category4);
				JNIEnv.DeleteLocalRef (native_category5);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId, IntPtr native_category1, IntPtr native_category2, IntPtr native_category3, IntPtr native_category4, IntPtr native_category5, IntPtr native_category6)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			string category1 = JNIEnv.GetString (native_category1, JniHandleOwnership.DoNotTransfer);
			string category2 = JNIEnv.GetString (native_category2, JniHandleOwnership.DoNotTransfer);
			string category3 = JNIEnv.GetString (native_category3, JniHandleOwnership.DoNotTransfer);
			string category4 = JNIEnv.GetString (native_category4, JniHandleOwnership.DoNotTransfer);
			string category5 = JNIEnv.GetString (native_category5, JniHandleOwnership.DoNotTransfer);
			string category6 = JNIEnv.GetString (native_category6, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (productId, category1, category2, category3, category4, category5, category6));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='add' and count(parameter)=7 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String'] and parameter[6][@type='java.lang.String'] and parameter[7][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Product Add (string productId, string category1, string category2, string category3, string category4, string category5, string category6)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Product;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			IntPtr native_category1 = JNIEnv.NewString (category1);
			IntPtr native_category2 = JNIEnv.NewString (category2);
			IntPtr native_category3 = JNIEnv.NewString (category3);
			IntPtr native_category4 = JNIEnv.NewString (category4);
			IntPtr native_category5 = JNIEnv.NewString (category5);
			IntPtr native_category6 = JNIEnv.NewString (category6);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [7];
				__args [0] = new JniArgumentValue (native_productId);
				__args [1] = new JniArgumentValue (native_category1);
				__args [2] = new JniArgumentValue (native_category2);
				__args [3] = new JniArgumentValue (native_category3);
				__args [4] = new JniArgumentValue (native_category4);
				__args [5] = new JniArgumentValue (native_category5);
				__args [6] = new JniArgumentValue (native_category6);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Product> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
				JNIEnv.DeleteLocalRef (native_category1);
				JNIEnv.DeleteLocalRef (native_category2);
				JNIEnv.DeleteLocalRef (native_category3);
				JNIEnv.DeleteLocalRef (native_category4);
				JNIEnv.DeleteLocalRef (native_category5);
				JNIEnv.DeleteLocalRef (native_category6);
			}
		}

		static Delegate cb_remove_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetRemove_Ljava_lang_String_Handler ()
		{
			if (cb_remove_Ljava_lang_String_ == null)
				cb_remove_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_Remove_Ljava_lang_String_);
			return cb_remove_Ljava_lang_String_;
		}

		static void n_Remove_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			__this.Remove (productId);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='remove' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("remove", "(Ljava/lang/String;)V", "GetRemove_Ljava_lang_String_Handler")]
		public virtual unsafe void Remove (string productId)
		{
			const string __id = "remove.(Ljava/lang/String;)V";
			IntPtr native_productId = JNIEnv.NewString (productId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_productId);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
			}
		}

		static Delegate cb_removeAll;
#pragma warning disable 0169
		static Delegate GetRemoveAllHandler ()
		{
			if (cb_removeAll == null)
				cb_removeAll = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_RemoveAll);
			return cb_removeAll;
		}

		static void n_RemoveAll (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RemoveAll ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='removeAll' and count(parameter)=0]"
		[Register ("removeAll", "()V", "GetRemoveAllHandler")]
		public virtual unsafe void RemoveAll ()
		{
			const string __id = "removeAll.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

		static Delegate cb_sendViews;
#pragma warning disable 0169
		static Delegate GetSendViewsHandler ()
		{
			if (cb_sendViews == null)
				cb_sendViews = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_SendViews);
			return cb_sendViews;
		}

		static void n_SendViews (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Products __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.SendViews ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Products']/method[@name='sendViews' and count(parameter)=0]"
		[Register ("sendViews", "()V", "GetSendViewsHandler")]
		public virtual unsafe void SendViews ()
		{
			const string __id = "sendViews.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
