using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Publisher", DoNotGenerateAcw=true)]
	public partial class Publisher : global::Com.Atinternet.Tracker.OnAppAd {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Publisher", typeof (Publisher));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Publisher (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getAdvertiserId;
#pragma warning disable 0169
		static Delegate GetGetAdvertiserIdHandler ()
		{
			if (cb_getAdvertiserId == null)
				cb_getAdvertiserId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetAdvertiserId);
			return cb_getAdvertiserId;
		}

		static IntPtr n_GetAdvertiserId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.AdvertiserId);
		}
#pragma warning restore 0169

		public virtual unsafe string AdvertiserId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getAdvertiserId' and count(parameter)=0]"
			[Register ("getAdvertiserId", "()Ljava/lang/String;", "GetGetAdvertiserIdHandler")]
			get {
				const string __id = "getAdvertiserId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getCampaignId;
#pragma warning disable 0169
		static Delegate GetGetCampaignIdHandler ()
		{
			if (cb_getCampaignId == null)
				cb_getCampaignId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCampaignId);
			return cb_getCampaignId;
		}

		static IntPtr n_GetCampaignId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.CampaignId);
		}
#pragma warning restore 0169

		public virtual unsafe string CampaignId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getCampaignId' and count(parameter)=0]"
			[Register ("getCampaignId", "()Ljava/lang/String;", "GetGetCampaignIdHandler")]
			get {
				const string __id = "getCampaignId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getCreation;
#pragma warning disable 0169
		static Delegate GetGetCreationHandler ()
		{
			if (cb_getCreation == null)
				cb_getCreation = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCreation);
			return cb_getCreation;
		}

		static IntPtr n_GetCreation (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Creation);
		}
#pragma warning restore 0169

		public virtual unsafe string Creation {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getCreation' and count(parameter)=0]"
			[Register ("getCreation", "()Ljava/lang/String;", "GetGetCreationHandler")]
			get {
				const string __id = "getCreation.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getDetailedPlacement;
#pragma warning disable 0169
		static Delegate GetGetDetailedPlacementHandler ()
		{
			if (cb_getDetailedPlacement == null)
				cb_getDetailedPlacement = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetDetailedPlacement);
			return cb_getDetailedPlacement;
		}

		static IntPtr n_GetDetailedPlacement (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.DetailedPlacement);
		}
#pragma warning restore 0169

		public virtual unsafe string DetailedPlacement {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getDetailedPlacement' and count(parameter)=0]"
			[Register ("getDetailedPlacement", "()Ljava/lang/String;", "GetGetDetailedPlacementHandler")]
			get {
				const string __id = "getDetailedPlacement.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getFormat;
#pragma warning disable 0169
		static Delegate GetGetFormatHandler ()
		{
			if (cb_getFormat == null)
				cb_getFormat = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetFormat);
			return cb_getFormat;
		}

		static IntPtr n_GetFormat (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Format);
		}
#pragma warning restore 0169

		public virtual unsafe string Format {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getFormat' and count(parameter)=0]"
			[Register ("getFormat", "()Ljava/lang/String;", "GetGetFormatHandler")]
			get {
				const string __id = "getFormat.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getGeneralPlacement;
#pragma warning disable 0169
		static Delegate GetGetGeneralPlacementHandler ()
		{
			if (cb_getGeneralPlacement == null)
				cb_getGeneralPlacement = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetGeneralPlacement);
			return cb_getGeneralPlacement;
		}

		static IntPtr n_GetGeneralPlacement (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.GeneralPlacement);
		}
#pragma warning restore 0169

		public virtual unsafe string GeneralPlacement {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getGeneralPlacement' and count(parameter)=0]"
			[Register ("getGeneralPlacement", "()Ljava/lang/String;", "GetGetGeneralPlacementHandler")]
			get {
				const string __id = "getGeneralPlacement.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getUrl;
#pragma warning disable 0169
		static Delegate GetGetUrlHandler ()
		{
			if (cb_getUrl == null)
				cb_getUrl = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetUrl);
			return cb_getUrl;
		}

		static IntPtr n_GetUrl (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Url);
		}
#pragma warning restore 0169

		public virtual unsafe string Url {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getUrl' and count(parameter)=0]"
			[Register ("getUrl", "()Ljava/lang/String;", "GetGetUrlHandler")]
			get {
				const string __id = "getUrl.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getVariant;
#pragma warning disable 0169
		static Delegate GetGetVariantHandler ()
		{
			if (cb_getVariant == null)
				cb_getVariant = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetVariant);
			return cb_getVariant;
		}

		static IntPtr n_GetVariant (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Variant);
		}
#pragma warning restore 0169

		public virtual unsafe string Variant {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='getVariant' and count(parameter)=0]"
			[Register ("getVariant", "()Ljava/lang/String;", "GetGetVariantHandler")]
			get {
				const string __id = "getVariant.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_CustomObjects;
#pragma warning disable 0169
		static Delegate GetCustomObjectsHandler ()
		{
			if (cb_CustomObjects == null)
				cb_CustomObjects = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_CustomObjects);
			return cb_CustomObjects;
		}

		static IntPtr n_CustomObjects (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CustomObjects ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='CustomObjects' and count(parameter)=0]"
		[Register ("CustomObjects", "()Lcom/atinternet/tracker/CustomObjects;", "GetCustomObjectsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomObjects CustomObjects ()
		{
			const string __id = "CustomObjects.()Lcom/atinternet/tracker/CustomObjects;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObjects> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_;
#pragma warning disable 0169
		static Delegate GetSetAction_Lcom_atinternet_tracker_OnAppAd_Action_Handler ()
		{
			if (cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_ == null)
				cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetAction_Lcom_atinternet_tracker_OnAppAd_Action_);
			return cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_;
		}

		static IntPtr n_SetAction_Lcom_atinternet_tracker_OnAppAd_Action_ (IntPtr jnienv, IntPtr native__this, IntPtr native_action)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.OnAppAd.Action action = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OnAppAd.Action> (native_action, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetAction (action));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setAction' and count(parameter)=1 and parameter[1][@type='com.atinternet.tracker.OnAppAd.Action']]"
		[Register ("setAction", "(Lcom/atinternet/tracker/OnAppAd$Action;)Lcom/atinternet/tracker/Publisher;", "GetSetAction_Lcom_atinternet_tracker_OnAppAd_Action_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetAction (global::Com.Atinternet.Tracker.OnAppAd.Action action)
		{
			const string __id = "setAction.(Lcom/atinternet/tracker/OnAppAd$Action;)Lcom/atinternet/tracker/Publisher;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((action == null) ? IntPtr.Zero : ((global::Java.Lang.Object) action).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAdvertiserId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetAdvertiserId_Ljava_lang_String_Handler ()
		{
			if (cb_setAdvertiserId_Ljava_lang_String_ == null)
				cb_setAdvertiserId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetAdvertiserId_Ljava_lang_String_);
			return cb_setAdvertiserId_Ljava_lang_String_;
		}

		static IntPtr n_SetAdvertiserId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_advertiserId)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string advertiserId = JNIEnv.GetString (native_advertiserId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetAdvertiserId (advertiserId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setAdvertiserId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setAdvertiserId", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetAdvertiserId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetAdvertiserId (string advertiserId)
		{
			const string __id = "setAdvertiserId.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_advertiserId = JNIEnv.NewString (advertiserId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_advertiserId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_advertiserId);
			}
		}

		static Delegate cb_setCampaignId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCampaignId_Ljava_lang_String_Handler ()
		{
			if (cb_setCampaignId_Ljava_lang_String_ == null)
				cb_setCampaignId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetCampaignId_Ljava_lang_String_);
			return cb_setCampaignId_Ljava_lang_String_;
		}

		static IntPtr n_SetCampaignId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_campaignId)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string campaignId = JNIEnv.GetString (native_campaignId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetCampaignId (campaignId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setCampaignId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setCampaignId", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetCampaignId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetCampaignId (string campaignId)
		{
			const string __id = "setCampaignId.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_campaignId = JNIEnv.NewString (campaignId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_campaignId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_campaignId);
			}
		}

		static Delegate cb_setCreation_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCreation_Ljava_lang_String_Handler ()
		{
			if (cb_setCreation_Ljava_lang_String_ == null)
				cb_setCreation_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetCreation_Ljava_lang_String_);
			return cb_setCreation_Ljava_lang_String_;
		}

		static IntPtr n_SetCreation_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_creation)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string creation = JNIEnv.GetString (native_creation, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetCreation (creation));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setCreation' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setCreation", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetCreation_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetCreation (string creation)
		{
			const string __id = "setCreation.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_creation = JNIEnv.NewString (creation);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_creation);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_creation);
			}
		}

		static Delegate cb_setDetailedPlacement_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetDetailedPlacement_Ljava_lang_String_Handler ()
		{
			if (cb_setDetailedPlacement_Ljava_lang_String_ == null)
				cb_setDetailedPlacement_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetDetailedPlacement_Ljava_lang_String_);
			return cb_setDetailedPlacement_Ljava_lang_String_;
		}

		static IntPtr n_SetDetailedPlacement_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_detailedPlacement)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string detailedPlacement = JNIEnv.GetString (native_detailedPlacement, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetDetailedPlacement (detailedPlacement));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setDetailedPlacement' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setDetailedPlacement", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetDetailedPlacement_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetDetailedPlacement (string detailedPlacement)
		{
			const string __id = "setDetailedPlacement.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_detailedPlacement = JNIEnv.NewString (detailedPlacement);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_detailedPlacement);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_detailedPlacement);
			}
		}

		static Delegate cb_setFormat_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetFormat_Ljava_lang_String_Handler ()
		{
			if (cb_setFormat_Ljava_lang_String_ == null)
				cb_setFormat_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetFormat_Ljava_lang_String_);
			return cb_setFormat_Ljava_lang_String_;
		}

		static IntPtr n_SetFormat_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_format)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string format = JNIEnv.GetString (native_format, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetFormat (format));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setFormat' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setFormat", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetFormat_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetFormat (string format)
		{
			const string __id = "setFormat.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_format = JNIEnv.NewString (format);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_format);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_format);
			}
		}

		static Delegate cb_setGeneralPlacement_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetGeneralPlacement_Ljava_lang_String_Handler ()
		{
			if (cb_setGeneralPlacement_Ljava_lang_String_ == null)
				cb_setGeneralPlacement_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetGeneralPlacement_Ljava_lang_String_);
			return cb_setGeneralPlacement_Ljava_lang_String_;
		}

		static IntPtr n_SetGeneralPlacement_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_generalPlacement)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string generalPlacement = JNIEnv.GetString (native_generalPlacement, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetGeneralPlacement (generalPlacement));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setGeneralPlacement' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setGeneralPlacement", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetGeneralPlacement_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetGeneralPlacement (string generalPlacement)
		{
			const string __id = "setGeneralPlacement.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_generalPlacement = JNIEnv.NewString (generalPlacement);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_generalPlacement);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_generalPlacement);
			}
		}

		static Delegate cb_setUrl_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetUrl_Ljava_lang_String_Handler ()
		{
			if (cb_setUrl_Ljava_lang_String_ == null)
				cb_setUrl_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetUrl_Ljava_lang_String_);
			return cb_setUrl_Ljava_lang_String_;
		}

		static IntPtr n_SetUrl_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_url)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string url = JNIEnv.GetString (native_url, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetUrl (url));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setUrl' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setUrl", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetUrl_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetUrl (string url)
		{
			const string __id = "setUrl.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_url = JNIEnv.NewString (url);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_url);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_url);
			}
		}

		static Delegate cb_setVariant_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetVariant_Ljava_lang_String_Handler ()
		{
			if (cb_setVariant_Ljava_lang_String_ == null)
				cb_setVariant_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetVariant_Ljava_lang_String_);
			return cb_setVariant_Ljava_lang_String_;
		}

		static IntPtr n_SetVariant_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_variant)
		{
			global::Com.Atinternet.Tracker.Publisher __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string variant = JNIEnv.GetString (native_variant, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetVariant (variant));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publisher']/method[@name='setVariant' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setVariant", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetSetVariant_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher SetVariant (string variant)
		{
			const string __id = "setVariant.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_variant = JNIEnv.NewString (variant);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_variant);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_variant);
			}
		}

	}
}
