using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/SelfPromotion", DoNotGenerateAcw=true)]
	public partial class SelfPromotion : global::Com.Atinternet.Tracker.OnAppAd {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/SelfPromotion", typeof (SelfPromotion));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected SelfPromotion (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getAdId;
#pragma warning disable 0169
		static Delegate GetGetAdIdHandler ()
		{
			if (cb_getAdId == null)
				cb_getAdId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetAdId);
			return cb_getAdId;
		}

		static int n_GetAdId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.AdId;
		}
#pragma warning restore 0169

		public virtual unsafe int AdId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='getAdId' and count(parameter)=0]"
			[Register ("getAdId", "()I", "GetGetAdIdHandler")]
			get {
				const string __id = "getAdId.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getFormat;
#pragma warning disable 0169
		static Delegate GetGetFormatHandler ()
		{
			if (cb_getFormat == null)
				cb_getFormat = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetFormat);
			return cb_getFormat;
		}

		static IntPtr n_GetFormat (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Format);
		}
#pragma warning restore 0169

		public virtual unsafe string Format {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='getFormat' and count(parameter)=0]"
			[Register ("getFormat", "()Ljava/lang/String;", "GetGetFormatHandler")]
			get {
				const string __id = "getFormat.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getProductId;
#pragma warning disable 0169
		static Delegate GetGetProductIdHandler ()
		{
			if (cb_getProductId == null)
				cb_getProductId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetProductId);
			return cb_getProductId;
		}

		static IntPtr n_GetProductId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.ProductId);
		}
#pragma warning restore 0169

		public virtual unsafe string ProductId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='getProductId' and count(parameter)=0]"
			[Register ("getProductId", "()Ljava/lang/String;", "GetGetProductIdHandler")]
			get {
				const string __id = "getProductId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_CustomObjects;
#pragma warning disable 0169
		static Delegate GetCustomObjectsHandler ()
		{
			if (cb_CustomObjects == null)
				cb_CustomObjects = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_CustomObjects);
			return cb_CustomObjects;
		}

		static IntPtr n_CustomObjects (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CustomObjects ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='CustomObjects' and count(parameter)=0]"
		[Register ("CustomObjects", "()Lcom/atinternet/tracker/CustomObjects;", "GetCustomObjectsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomObjects CustomObjects ()
		{
			const string __id = "CustomObjects.()Lcom/atinternet/tracker/CustomObjects;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObjects> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_;
#pragma warning disable 0169
		static Delegate GetSetAction_Lcom_atinternet_tracker_OnAppAd_Action_Handler ()
		{
			if (cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_ == null)
				cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetAction_Lcom_atinternet_tracker_OnAppAd_Action_);
			return cb_setAction_Lcom_atinternet_tracker_OnAppAd_Action_;
		}

		static IntPtr n_SetAction_Lcom_atinternet_tracker_OnAppAd_Action_ (IntPtr jnienv, IntPtr native__this, IntPtr native_action)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.OnAppAd.Action action = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OnAppAd.Action> (native_action, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetAction (action));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='setAction' and count(parameter)=1 and parameter[1][@type='com.atinternet.tracker.OnAppAd.Action']]"
		[Register ("setAction", "(Lcom/atinternet/tracker/OnAppAd$Action;)Lcom/atinternet/tracker/SelfPromotion;", "GetSetAction_Lcom_atinternet_tracker_OnAppAd_Action_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.SelfPromotion SetAction (global::Com.Atinternet.Tracker.OnAppAd.Action action)
		{
			const string __id = "setAction.(Lcom/atinternet/tracker/OnAppAd$Action;)Lcom/atinternet/tracker/SelfPromotion;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((action == null) ? IntPtr.Zero : ((global::Java.Lang.Object) action).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAdId_I;
#pragma warning disable 0169
		static Delegate GetSetAdId_IHandler ()
		{
			if (cb_setAdId_I == null)
				cb_setAdId_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetAdId_I);
			return cb_setAdId_I;
		}

		static IntPtr n_SetAdId_I (IntPtr jnienv, IntPtr native__this, int adId)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetAdId (adId));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='setAdId' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setAdId", "(I)Lcom/atinternet/tracker/SelfPromotion;", "GetSetAdId_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.SelfPromotion SetAdId (int adId)
		{
			const string __id = "setAdId.(I)Lcom/atinternet/tracker/SelfPromotion;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (adId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setFormat_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetFormat_Ljava_lang_String_Handler ()
		{
			if (cb_setFormat_Ljava_lang_String_ == null)
				cb_setFormat_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetFormat_Ljava_lang_String_);
			return cb_setFormat_Ljava_lang_String_;
		}

		static IntPtr n_SetFormat_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_format)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string format = JNIEnv.GetString (native_format, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetFormat (format));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='setFormat' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setFormat", "(Ljava/lang/String;)Lcom/atinternet/tracker/SelfPromotion;", "GetSetFormat_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.SelfPromotion SetFormat (string format)
		{
			const string __id = "setFormat.(Ljava/lang/String;)Lcom/atinternet/tracker/SelfPromotion;";
			IntPtr native_format = JNIEnv.NewString (format);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_format);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_format);
			}
		}

		static Delegate cb_setProductId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetProductId_Ljava_lang_String_Handler ()
		{
			if (cb_setProductId_Ljava_lang_String_ == null)
				cb_setProductId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetProductId_Ljava_lang_String_);
			return cb_setProductId_Ljava_lang_String_;
		}

		static IntPtr n_SetProductId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_productId)
		{
			global::Com.Atinternet.Tracker.SelfPromotion __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string productId = JNIEnv.GetString (native_productId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetProductId (productId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='SelfPromotion']/method[@name='setProductId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setProductId", "(Ljava/lang/String;)Lcom/atinternet/tracker/SelfPromotion;", "GetSetProductId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.SelfPromotion SetProductId (string productId)
		{
			const string __id = "setProductId.(Ljava/lang/String;)Lcom/atinternet/tracker/SelfPromotion;";
			IntPtr native_productId = JNIEnv.NewString (productId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_productId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.SelfPromotion> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_productId);
			}
		}

	}
}
