using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Utility", DoNotGenerateAcw=true)]
	public partial class Utility : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Utility", typeof (Utility));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Utility (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/constructor[@name='Utility' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe Utility ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			const string __id = "()V";

			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				var __r = _members.InstanceMethods.StartCreateInstance (__id, ((object) this).GetType (), null);
				SetHandle (__r.Handle, JniHandleOwnership.TransferLocalRef);
				_members.InstanceMethods.FinishCreateInstance (__id, this, null);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/method[@name='getStringOrEmpty' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("getStringOrEmpty", "(Ljava/lang/String;)Ljava/lang/String;", "")]
		public static unsafe string GetStringOrEmpty (string s)
		{
			const string __id = "getStringOrEmpty.(Ljava/lang/String;)Ljava/lang/String;";
			IntPtr native_s = JNIEnv.NewString (s);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_s);
				var __rm = _members.StaticMethods.InvokeObjectMethod (__id, __args);
				return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_s);
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/method[@name='parseBoolean' and count(parameter)=1 and parameter[1][@type='java.lang.Object']]"
		[Register ("parseBoolean", "(Ljava/lang/Object;)Z", "")]
		public static unsafe bool ParseBoolean (global::Java.Lang.Object o)
		{
			const string __id = "parseBoolean.(Ljava/lang/Object;)Z";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((o == null) ? IntPtr.Zero : ((global::Java.Lang.Object) o).Handle);
				var __rm = _members.StaticMethods.InvokeBooleanMethod (__id, __args);
				return __rm;
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/method[@name='parseDouble' and count(parameter)=1 and parameter[1][@type='java.lang.Object']]"
		[Register ("parseDouble", "(Ljava/lang/Object;)D", "")]
		public static unsafe double ParseDouble (global::Java.Lang.Object o)
		{
			const string __id = "parseDouble.(Ljava/lang/Object;)D";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((o == null) ? IntPtr.Zero : ((global::Java.Lang.Object) o).Handle);
				var __rm = _members.StaticMethods.InvokeDoubleMethod (__id, __args);
				return __rm;
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/method[@name='parseInt' and count(parameter)=1 and parameter[1][@type='java.lang.Object']]"
		[Register ("parseInt", "(Ljava/lang/Object;)I", "")]
		public static unsafe int ParseInt (global::Java.Lang.Object o)
		{
			const string __id = "parseInt.(Ljava/lang/Object;)I";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((o == null) ? IntPtr.Zero : ((global::Java.Lang.Object) o).Handle);
				var __rm = _members.StaticMethods.InvokeInt32Method (__id, __args);
				return __rm;
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/method[@name='parseString' and count(parameter)=1 and parameter[1][@type='java.lang.Object']]"
		[Register ("parseString", "(Ljava/lang/Object;)Ljava/lang/String;", "")]
		public static unsafe string ParseString (global::Java.Lang.Object o)
		{
			const string __id = "parseString.(Ljava/lang/Object;)Ljava/lang/String;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((o == null) ? IntPtr.Zero : ((global::Java.Lang.Object) o).Handle);
				var __rm = _members.StaticMethods.InvokeObjectMethod (__id, __args);
				return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Utility']/method[@name='stringJoin' and count(parameter)=2 and parameter[1][@type='char'] and parameter[2][@type='java.lang.String...']]"
		[Register ("stringJoin", "(C[Ljava/lang/String;)Ljava/lang/String;", "")]
		public static unsafe string StringJoin (char delimiter, params string[] strs)
		{
			const string __id = "stringJoin.(C[Ljava/lang/String;)Ljava/lang/String;";
			IntPtr native_strs = JNIEnv.NewArray (strs);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (delimiter);
				__args [1] = new JniArgumentValue (native_strs);
				var __rm = _members.StaticMethods.InvokeObjectMethod (__id, __args);
				return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				if (strs != null) {
					JNIEnv.CopyArray (native_strs, strs);
					JNIEnv.DeleteLocalRef (native_strs);
				}
			}
		}

	}
}
