using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/ATInternet", DoNotGenerateAcw=true)]
	public sealed partial class ATInternet : global::Java.Lang.Object {


		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/field[@name='ALLOW_OVERLAY_INTENT_RESULT_CODE']"
		[Register ("ALLOW_OVERLAY_INTENT_RESULT_CODE")]
		public const int AllowOverlayIntentResultCode = (int) 230;
		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/ATInternet", typeof (ATInternet));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		internal ATInternet (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		public unsafe string ApplicationVersion {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getApplicationVersion' and count(parameter)=0]"
			[Register ("getApplicationVersion", "()Ljava/lang/String;", "")]
			get {
				const string __id = "getApplicationVersion.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='setApplicationVersion' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setApplicationVersion", "(Ljava/lang/String;)V", "")]
			set {
				const string __id = "setApplicationVersion.(Ljava/lang/String;)V";
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JniArgumentValue* __args = stackalloc JniArgumentValue [1];
					__args [0] = new JniArgumentValue (native_value);
					_members.InstanceMethods.InvokeAbstractVoidMethod (__id, this, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		public static unsafe string DatabasePath {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getDatabasePath' and count(parameter)=0]"
			[Register ("getDatabasePath", "()Ljava/lang/String;", "")]
			get {
				const string __id = "getDatabasePath.()Ljava/lang/String;";
				try {
					var __rm = _members.StaticMethods.InvokeObjectMethod (__id, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='setDatabasePath' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setDatabasePath", "(Ljava/lang/String;)V", "")]
			set {
				const string __id = "setDatabasePath.(Ljava/lang/String;)V";
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JniArgumentValue* __args = stackalloc JniArgumentValue [1];
					__args [0] = new JniArgumentValue (native_value);
					_members.StaticMethods.InvokeVoidMethod (__id, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		public unsafe global::Com.Atinternet.Tracker.Tracker DefaultTracker {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getDefaultTracker' and count(parameter)=0]"
			[Register ("getDefaultTracker", "()Lcom/atinternet/tracker/Tracker;", "")]
			get {
				const string __id = "getDefaultTracker.()Lcom/atinternet/tracker/Tracker;";
				try {
					var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, null);
					return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		public static unsafe global::Com.Atinternet.Tracker.ATInternet Instance {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getInstance' and count(parameter)=0]"
			[Register ("getInstance", "()Lcom/atinternet/tracker/ATInternet;", "")]
			get {
				const string __id = "getInstance.()Lcom/atinternet/tracker/ATInternet;";
				try {
					var __rm = _members.StaticMethods.InvokeObjectMethod (__id, null);
					return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ATInternet> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		public unsafe string UserAgent {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getUserAgent' and count(parameter)=0]"
			[Register ("getUserAgent", "()Ljava/lang/String;", "")]
			get {
				const string __id = "getUserAgent.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='setUserAgent' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setUserAgent", "(Ljava/lang/String;)V", "")]
			set {
				const string __id = "setUserAgent.(Ljava/lang/String;)V";
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JniArgumentValue* __args = stackalloc JniArgumentValue [1];
					__args [0] = new JniArgumentValue (native_value);
					_members.InstanceMethods.InvokeAbstractVoidMethod (__id, this, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getTracker' and count(parameter)=2 and parameter[1][@type='android.content.Context'] and parameter[2][@type='java.lang.String']]"
		[Register ("getTracker", "(Landroid/content/Context;Ljava/lang/String;)Lcom/atinternet/tracker/Tracker;", "")]
		public unsafe global::Com.Atinternet.Tracker.Tracker GetTracker (global::Android.Content.Context context, string trackerName)
		{
			const string __id = "getTracker.(Landroid/content/Context;Ljava/lang/String;)Lcom/atinternet/tracker/Tracker;";
			IntPtr native_trackerName = JNIEnv.NewString (trackerName);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				__args [1] = new JniArgumentValue (native_trackerName);
				var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_trackerName);
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getTracker' and count(parameter)=3 and parameter[1][@type='android.content.Context'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.util.HashMap&lt;java.lang.String, java.lang.Object&gt;']]"
		[Register ("getTracker", "(Landroid/content/Context;Ljava/lang/String;Ljava/util/HashMap;)Lcom/atinternet/tracker/Tracker;", "")]
		public unsafe global::Com.Atinternet.Tracker.Tracker GetTracker (global::Android.Content.Context context, string trackerName, global::System.Collections.Generic.IDictionary<string, global::Java.Lang.Object> configuration)
		{
			const string __id = "getTracker.(Landroid/content/Context;Ljava/lang/String;Ljava/util/HashMap;)Lcom/atinternet/tracker/Tracker;";
			IntPtr native_trackerName = JNIEnv.NewString (trackerName);
			IntPtr native_configuration = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.ToLocalJniHandle (configuration);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				__args [1] = new JniArgumentValue (native_trackerName);
				__args [2] = new JniArgumentValue (native_configuration);
				var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_trackerName);
				JNIEnv.DeleteLocalRef (native_configuration);
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getTracker' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("getTracker", "(Ljava/lang/String;)Lcom/atinternet/tracker/Tracker;", "")]
		public unsafe global::Com.Atinternet.Tracker.Tracker GetTracker (string trackerName)
		{
			const string __id = "getTracker.(Ljava/lang/String;)Lcom/atinternet/tracker/Tracker;";
			IntPtr native_trackerName = JNIEnv.NewString (trackerName);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_trackerName);
				var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_trackerName);
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='getTracker' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.util.HashMap&lt;java.lang.String, java.lang.Object&gt;']]"
		[Register ("getTracker", "(Ljava/lang/String;Ljava/util/HashMap;)Lcom/atinternet/tracker/Tracker;", "")]
		public unsafe global::Com.Atinternet.Tracker.Tracker GetTracker (string trackerName, global::System.Collections.Generic.IDictionary<string, global::Java.Lang.Object> configuration)
		{
			const string __id = "getTracker.(Ljava/lang/String;Ljava/util/HashMap;)Lcom/atinternet/tracker/Tracker;";
			IntPtr native_trackerName = JNIEnv.NewString (trackerName);
			IntPtr native_configuration = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.ToLocalJniHandle (configuration);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_trackerName);
				__args [1] = new JniArgumentValue (native_configuration);
				var __rm = _members.InstanceMethods.InvokeAbstractObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Tracker> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_trackerName);
				JNIEnv.DeleteLocalRef (native_configuration);
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='optOut' and count(parameter)=2 and parameter[1][@type='android.content.Context'] and parameter[2][@type='boolean']]"
		[Register ("optOut", "(Landroid/content/Context;Z)V", "")]
		public static unsafe void OptOut (global::Android.Content.Context context, bool enabled)
		{
			const string __id = "optOut.(Landroid/content/Context;Z)V";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				__args [1] = new JniArgumentValue (enabled);
				_members.StaticMethods.InvokeVoidMethod (__id, __args);
			} finally {
			}
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='ATInternet']/method[@name='optOutEnabled' and count(parameter)=1 and parameter[1][@type='android.content.Context']]"
		[Register ("optOutEnabled", "(Landroid/content/Context;)Z", "")]
		public static unsafe bool OptOutEnabled (global::Android.Content.Context context)
		{
			const string __id = "optOutEnabled.(Landroid/content/Context;)Z";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				var __rm = _members.StaticMethods.InvokeBooleanMethod (__id, __args);
				return __rm;
			} finally {
			}
		}

	}
}
