using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Campaign']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Campaign", DoNotGenerateAcw=true)]
	public partial class Campaign : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Campaign", typeof (Campaign));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Campaign (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getCampaignId;
#pragma warning disable 0169
		static Delegate GetGetCampaignIdHandler ()
		{
			if (cb_getCampaignId == null)
				cb_getCampaignId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCampaignId);
			return cb_getCampaignId;
		}

		static IntPtr n_GetCampaignId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Campaign __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Campaign> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.CampaignId);
		}
#pragma warning restore 0169

		public virtual unsafe string CampaignId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Campaign']/method[@name='getCampaignId' and count(parameter)=0]"
			[Register ("getCampaignId", "()Ljava/lang/String;", "GetGetCampaignIdHandler")]
			get {
				const string __id = "getCampaignId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_setCampaignId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCampaignId_Ljava_lang_String_Handler ()
		{
			if (cb_setCampaignId_Ljava_lang_String_ == null)
				cb_setCampaignId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetCampaignId_Ljava_lang_String_);
			return cb_setCampaignId_Ljava_lang_String_;
		}

		static IntPtr n_SetCampaignId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_campaignId)
		{
			global::Com.Atinternet.Tracker.Campaign __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Campaign> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string campaignId = JNIEnv.GetString (native_campaignId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetCampaignId (campaignId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Campaign']/method[@name='setCampaignId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setCampaignId", "(Ljava/lang/String;)Lcom/atinternet/tracker/Campaign;", "GetSetCampaignId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Campaign SetCampaignId (string campaignId)
		{
			const string __id = "setCampaignId.(Ljava/lang/String;)Lcom/atinternet/tracker/Campaign;";
			IntPtr native_campaignId = JNIEnv.NewString (campaignId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_campaignId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Campaign> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_campaignId);
			}
		}

	}
}
