using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Cart", DoNotGenerateAcw=true)]
	public partial class Cart : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Cart", typeof (Cart));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Cart (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getCartId;
#pragma warning disable 0169
		static Delegate GetGetCartIdHandler ()
		{
			if (cb_getCartId == null)
				cb_getCartId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCartId);
			return cb_getCartId;
		}

		static IntPtr n_GetCartId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Cart __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.CartId);
		}
#pragma warning restore 0169

		public virtual unsafe string CartId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']/method[@name='getCartId' and count(parameter)=0]"
			[Register ("getCartId", "()Ljava/lang/String;", "GetGetCartIdHandler")]
			get {
				const string __id = "getCartId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_Products;
#pragma warning disable 0169
		static Delegate GetProductsHandler ()
		{
			if (cb_Products == null)
				cb_Products = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Products);
			return cb_Products;
		}

		static IntPtr n_Products (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Cart __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Products ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']/method[@name='Products' and count(parameter)=0]"
		[Register ("Products", "()Lcom/atinternet/tracker/Products;", "GetProductsHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Products Products ()
		{
			const string __id = "Products.()Lcom/atinternet/tracker/Products;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Products> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_send;
#pragma warning disable 0169
		static Delegate GetSendHandler ()
		{
			if (cb_send == null)
				cb_send = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Send);
			return cb_send;
		}

		static void n_Send (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Cart __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Send ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']/method[@name='send' and count(parameter)=0]"
		[Register ("send", "()V", "GetSendHandler")]
		public virtual unsafe void Send ()
		{
			const string __id = "send.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

		static Delegate cb_set_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSet_Ljava_lang_String_Handler ()
		{
			if (cb_set_Ljava_lang_String_ == null)
				cb_set_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Set_Ljava_lang_String_);
			return cb_set_Ljava_lang_String_;
		}

		static IntPtr n_Set_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_cartId)
		{
			global::Com.Atinternet.Tracker.Cart __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string cartId = JNIEnv.GetString (native_cartId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Set (cartId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']/method[@name='set' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("set", "(Ljava/lang/String;)Lcom/atinternet/tracker/Cart;", "GetSet_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Cart Set (string cartId)
		{
			const string __id = "set.(Ljava/lang/String;)Lcom/atinternet/tracker/Cart;";
			IntPtr native_cartId = JNIEnv.NewString (cartId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_cartId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_cartId);
			}
		}

		static Delegate cb_setCartId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCartId_Ljava_lang_String_Handler ()
		{
			if (cb_setCartId_Ljava_lang_String_ == null)
				cb_setCartId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetCartId_Ljava_lang_String_);
			return cb_setCartId_Ljava_lang_String_;
		}

		static IntPtr n_SetCartId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_cartId)
		{
			global::Com.Atinternet.Tracker.Cart __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string cartId = JNIEnv.GetString (native_cartId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetCartId (cartId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']/method[@name='setCartId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setCartId", "(Ljava/lang/String;)Lcom/atinternet/tracker/Cart;", "GetSetCartId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Cart SetCartId (string cartId)
		{
			const string __id = "setCartId.(Ljava/lang/String;)Lcom/atinternet/tracker/Cart;";
			IntPtr native_cartId = JNIEnv.NewString (cartId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_cartId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_cartId);
			}
		}

		static Delegate cb_unset;
#pragma warning disable 0169
		static Delegate GetUnsetHandler ()
		{
			if (cb_unset == null)
				cb_unset = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Unset);
			return cb_unset;
		}

		static IntPtr n_Unset (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Cart __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Unset ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Cart']/method[@name='unset' and count(parameter)=0]"
		[Register ("unset", "()Lcom/atinternet/tracker/Cart;", "GetUnsetHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Cart Unset ()
		{
			const string __id = "unset.()Lcom/atinternet/tracker/Cart;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Cart> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
