using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObject']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/CustomObject", DoNotGenerateAcw=true)]
	public partial class CustomObject : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/CustomObject", typeof (CustomObject));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected CustomObject (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getValue;
#pragma warning disable 0169
		static Delegate GetGetValueHandler ()
		{
			if (cb_getValue == null)
				cb_getValue = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetValue);
			return cb_getValue;
		}

		static IntPtr n_GetValue (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.CustomObject __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObject> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Value);
		}
#pragma warning restore 0169

		public virtual unsafe string Value {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObject']/method[@name='getValue' and count(parameter)=0]"
			[Register ("getValue", "()Ljava/lang/String;", "GetGetValueHandler")]
			get {
				const string __id = "getValue.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_setPersistent_Z;
#pragma warning disable 0169
		static Delegate GetSetPersistent_ZHandler ()
		{
			if (cb_setPersistent_Z == null)
				cb_setPersistent_Z = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool, IntPtr>) n_SetPersistent_Z);
			return cb_setPersistent_Z;
		}

		static IntPtr n_SetPersistent_Z (IntPtr jnienv, IntPtr native__this, bool persistent)
		{
			global::Com.Atinternet.Tracker.CustomObject __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObject> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetPersistent (persistent));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObject']/method[@name='setPersistent' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setPersistent", "(Z)Lcom/atinternet/tracker/CustomObject;", "GetSetPersistent_ZHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomObject SetPersistent (bool persistent)
		{
			const string __id = "setPersistent.(Z)Lcom/atinternet/tracker/CustomObject;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (persistent);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObject> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
