using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObjects']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/CustomObjects", DoNotGenerateAcw=true)]
	public partial class CustomObjects : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/CustomObjects", typeof (CustomObjects));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected CustomObjects (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_customObject)
		{
			global::Com.Atinternet.Tracker.CustomObjects __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObjects> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string customObject = JNIEnv.GetString (native_customObject, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (customObject));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObjects']/method[@name='add' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;)Lcom/atinternet/tracker/CustomObject;", "GetAdd_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomObject Add (string customObject)
		{
			const string __id = "add.(Ljava/lang/String;)Lcom/atinternet/tracker/CustomObject;";
			IntPtr native_customObject = JNIEnv.NewString (customObject);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_customObject);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObject> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_customObject);
			}
		}

		static Delegate cb_add_Ljava_util_Map_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_util_Map_Handler ()
		{
			if (cb_add_Ljava_util_Map_ == null)
				cb_add_Ljava_util_Map_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_util_Map_);
			return cb_add_Ljava_util_Map_;
		}

		static IntPtr n_Add_Ljava_util_Map_ (IntPtr jnienv, IntPtr native__this, IntPtr native_customObject)
		{
			global::Com.Atinternet.Tracker.CustomObjects __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObjects> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			var customObject = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.FromJniHandle (native_customObject, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (customObject));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObjects']/method[@name='add' and count(parameter)=1 and parameter[1][@type='java.util.Map&lt;java.lang.String, java.lang.Object&gt;']]"
		[Register ("add", "(Ljava/util/Map;)Lcom/atinternet/tracker/CustomObject;", "GetAdd_Ljava_util_Map_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomObject Add (global::System.Collections.Generic.IDictionary<string, global::Java.Lang.Object> customObject)
		{
			const string __id = "add.(Ljava/util/Map;)Lcom/atinternet/tracker/CustomObject;";
			IntPtr native_customObject = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.ToLocalJniHandle (customObject);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_customObject);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObject> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_customObject);
			}
		}

		static Delegate cb_remove_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetRemove_Ljava_lang_String_Handler ()
		{
			if (cb_remove_Ljava_lang_String_ == null)
				cb_remove_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_Remove_Ljava_lang_String_);
			return cb_remove_Ljava_lang_String_;
		}

		static void n_Remove_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_customObjectId)
		{
			global::Com.Atinternet.Tracker.CustomObjects __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObjects> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string customObjectId = JNIEnv.GetString (native_customObjectId, JniHandleOwnership.DoNotTransfer);
			__this.Remove (customObjectId);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObjects']/method[@name='remove' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("remove", "(Ljava/lang/String;)V", "GetRemove_Ljava_lang_String_Handler")]
		public virtual unsafe void Remove (string customObjectId)
		{
			const string __id = "remove.(Ljava/lang/String;)V";
			IntPtr native_customObjectId = JNIEnv.NewString (customObjectId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_customObjectId);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_customObjectId);
			}
		}

		static Delegate cb_removeAll;
#pragma warning disable 0169
		static Delegate GetRemoveAllHandler ()
		{
			if (cb_removeAll == null)
				cb_removeAll = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_RemoveAll);
			return cb_removeAll;
		}

		static void n_RemoveAll (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.CustomObjects __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomObjects> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RemoveAll ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomObjects']/method[@name='removeAll' and count(parameter)=0]"
		[Register ("removeAll", "()V", "GetRemoveAllHandler")]
		public virtual unsafe void RemoveAll ()
		{
			const string __id = "removeAll.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
