using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/CustomTreeStructure", DoNotGenerateAcw=true)]
	public partial class CustomTreeStructure : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/CustomTreeStructure", typeof (CustomTreeStructure));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected CustomTreeStructure (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getCategory1;
#pragma warning disable 0169
		static Delegate GetGetCategory1Handler ()
		{
			if (cb_getCategory1 == null)
				cb_getCategory1 = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetCategory1);
			return cb_getCategory1;
		}

		static int n_GetCategory1 (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructure __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Category1;
		}
#pragma warning restore 0169

		public virtual unsafe int Category1 {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']/method[@name='getCategory1' and count(parameter)=0]"
			[Register ("getCategory1", "()I", "GetGetCategory1Handler")]
			get {
				const string __id = "getCategory1.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getCategory2;
#pragma warning disable 0169
		static Delegate GetGetCategory2Handler ()
		{
			if (cb_getCategory2 == null)
				cb_getCategory2 = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetCategory2);
			return cb_getCategory2;
		}

		static int n_GetCategory2 (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructure __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Category2;
		}
#pragma warning restore 0169

		public virtual unsafe int Category2 {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']/method[@name='getCategory2' and count(parameter)=0]"
			[Register ("getCategory2", "()I", "GetGetCategory2Handler")]
			get {
				const string __id = "getCategory2.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getCategory3;
#pragma warning disable 0169
		static Delegate GetGetCategory3Handler ()
		{
			if (cb_getCategory3 == null)
				cb_getCategory3 = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetCategory3);
			return cb_getCategory3;
		}

		static int n_GetCategory3 (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructure __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Category3;
		}
#pragma warning restore 0169

		public virtual unsafe int Category3 {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']/method[@name='getCategory3' and count(parameter)=0]"
			[Register ("getCategory3", "()I", "GetGetCategory3Handler")]
			get {
				const string __id = "getCategory3.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_setCategory1_I;
#pragma warning disable 0169
		static Delegate GetSetCategory1_IHandler ()
		{
			if (cb_setCategory1_I == null)
				cb_setCategory1_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetCategory1_I);
			return cb_setCategory1_I;
		}

		static IntPtr n_SetCategory1_I (IntPtr jnienv, IntPtr native__this, int category1)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructure __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetCategory1 (category1));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']/method[@name='setCategory1' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setCategory1", "(I)Lcom/atinternet/tracker/CustomTreeStructure;", "GetSetCategory1_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomTreeStructure SetCategory1 (int category1)
		{
			const string __id = "setCategory1.(I)Lcom/atinternet/tracker/CustomTreeStructure;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (category1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setCategory2_I;
#pragma warning disable 0169
		static Delegate GetSetCategory2_IHandler ()
		{
			if (cb_setCategory2_I == null)
				cb_setCategory2_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetCategory2_I);
			return cb_setCategory2_I;
		}

		static IntPtr n_SetCategory2_I (IntPtr jnienv, IntPtr native__this, int category2)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructure __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetCategory2 (category2));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']/method[@name='setCategory2' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setCategory2", "(I)Lcom/atinternet/tracker/CustomTreeStructure;", "GetSetCategory2_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomTreeStructure SetCategory2 (int category2)
		{
			const string __id = "setCategory2.(I)Lcom/atinternet/tracker/CustomTreeStructure;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (category2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setCategory3_I;
#pragma warning disable 0169
		static Delegate GetSetCategory3_IHandler ()
		{
			if (cb_setCategory3_I == null)
				cb_setCategory3_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetCategory3_I);
			return cb_setCategory3_I;
		}

		static IntPtr n_SetCategory3_I (IntPtr jnienv, IntPtr native__this, int category3)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructure __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetCategory3 (category3));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructure']/method[@name='setCategory3' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setCategory3", "(I)Lcom/atinternet/tracker/CustomTreeStructure;", "GetSetCategory3_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomTreeStructure SetCategory3 (int category3)
		{
			const string __id = "setCategory3.(I)Lcom/atinternet/tracker/CustomTreeStructure;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (category3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
