using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructures']"
	[ObsoleteAttribute (@"This class is obsoleted in this android platform")]
	[global::Android.Runtime.Register ("com/atinternet/tracker/CustomTreeStructures", DoNotGenerateAcw=true)]
	public partial class CustomTreeStructures : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/CustomTreeStructures", typeof (CustomTreeStructures));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected CustomTreeStructures (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_I;
#pragma warning disable 0169
		static Delegate GetAdd_IHandler ()
		{
			if (cb_add_I == null)
				cb_add_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_Add_I);
			return cb_add_I;
		}

		static IntPtr n_Add_I (IntPtr jnienv, IntPtr native__this, int category1)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructures __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructures> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Add (category1));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructures']/method[@name='add' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("add", "(I)Lcom/atinternet/tracker/CustomTreeStructure;", "GetAdd_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomTreeStructure Add (int category1)
		{
			const string __id = "add.(I)Lcom/atinternet/tracker/CustomTreeStructure;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (category1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_II;
#pragma warning disable 0169
		static Delegate GetAdd_IIHandler ()
		{
			if (cb_add_II == null)
				cb_add_II = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, int, IntPtr>) n_Add_II);
			return cb_add_II;
		}

		static IntPtr n_Add_II (IntPtr jnienv, IntPtr native__this, int category1, int category2)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructures __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructures> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Add (category1, category2));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructures']/method[@name='add' and count(parameter)=2 and parameter[1][@type='int'] and parameter[2][@type='int']]"
		[Register ("add", "(II)Lcom/atinternet/tracker/CustomTreeStructure;", "GetAdd_IIHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomTreeStructure Add (int category1, int category2)
		{
			const string __id = "add.(II)Lcom/atinternet/tracker/CustomTreeStructure;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (category1);
				__args [1] = new JniArgumentValue (category2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_III;
#pragma warning disable 0169
		static Delegate GetAdd_IIIHandler ()
		{
			if (cb_add_III == null)
				cb_add_III = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, int, int, IntPtr>) n_Add_III);
			return cb_add_III;
		}

		static IntPtr n_Add_III (IntPtr jnienv, IntPtr native__this, int category1, int category2, int category3)
		{
			global::Com.Atinternet.Tracker.CustomTreeStructures __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructures> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Add (category1, category2, category3));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomTreeStructures']/method[@name='add' and count(parameter)=3 and parameter[1][@type='int'] and parameter[2][@type='int'] and parameter[3][@type='int']]"
		[Register ("add", "(III)Lcom/atinternet/tracker/CustomTreeStructure;", "GetAdd_IIIHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomTreeStructure Add (int category1, int category2, int category3)
		{
			const string __id = "add.(III)Lcom/atinternet/tracker/CustomTreeStructure;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (category1);
				__args [1] = new JniArgumentValue (category2);
				__args [2] = new JniArgumentValue (category3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomTreeStructure> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
