using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomVars']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/CustomVars", DoNotGenerateAcw=true)]
	public partial class CustomVars : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/CustomVars", typeof (CustomVars));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected CustomVars (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_;
#pragma warning disable 0169
		static Delegate GetAdd_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_Handler ()
		{
			if (cb_add_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_ == null)
				cb_add_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr, IntPtr, IntPtr>) n_Add_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_);
			return cb_add_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_;
		}

		static IntPtr n_Add_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_ (IntPtr jnienv, IntPtr native__this, int varId, IntPtr native_value, IntPtr native_customVarType)
		{
			global::Com.Atinternet.Tracker.CustomVars __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomVars> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string value = JNIEnv.GetString (native_value, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.CustomVar.CustomVarType customVarType = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomVar.CustomVarType> (native_customVarType, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (varId, value, customVarType));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomVars']/method[@name='add' and count(parameter)=3 and parameter[1][@type='int'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='com.atinternet.tracker.CustomVar.CustomVarType']]"
		[Register ("add", "(ILjava/lang/String;Lcom/atinternet/tracker/CustomVar$CustomVarType;)Lcom/atinternet/tracker/CustomVar;", "GetAdd_ILjava_lang_String_Lcom_atinternet_tracker_CustomVar_CustomVarType_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.CustomVar Add (int varId, string value, global::Com.Atinternet.Tracker.CustomVar.CustomVarType customVarType)
		{
			const string __id = "add.(ILjava/lang/String;Lcom/atinternet/tracker/CustomVar$CustomVarType;)Lcom/atinternet/tracker/CustomVar;";
			IntPtr native_value = JNIEnv.NewString (value);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (varId);
				__args [1] = new JniArgumentValue (native_value);
				__args [2] = new JniArgumentValue ((customVarType == null) ? IntPtr.Zero : ((global::Java.Lang.Object) customVarType).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomVar> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_value);
			}
		}

		static Delegate cb_remove_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetRemove_Ljava_lang_String_Handler ()
		{
			if (cb_remove_Ljava_lang_String_ == null)
				cb_remove_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_Remove_Ljava_lang_String_);
			return cb_remove_Ljava_lang_String_;
		}

		static void n_Remove_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_customVarId)
		{
			global::Com.Atinternet.Tracker.CustomVars __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomVars> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string customVarId = JNIEnv.GetString (native_customVarId, JniHandleOwnership.DoNotTransfer);
			__this.Remove (customVarId);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomVars']/method[@name='remove' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("remove", "(Ljava/lang/String;)V", "GetRemove_Ljava_lang_String_Handler")]
		public virtual unsafe void Remove (string customVarId)
		{
			const string __id = "remove.(Ljava/lang/String;)V";
			IntPtr native_customVarId = JNIEnv.NewString (customVarId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_customVarId);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_customVarId);
			}
		}

		static Delegate cb_removeAll;
#pragma warning disable 0169
		static Delegate GetRemoveAllHandler ()
		{
			if (cb_removeAll == null)
				cb_removeAll = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_RemoveAll);
			return cb_removeAll;
		}

		static void n_RemoveAll (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.CustomVars __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.CustomVars> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RemoveAll ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='CustomVars']/method[@name='removeAll' and count(parameter)=0]"
		[Register ("removeAll", "()V", "GetRemoveAllHandler")]
		public virtual unsafe void RemoveAll ()
		{
			const string __id = "removeAll.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
