using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/DynamicScreen", DoNotGenerateAcw=true)]
	public partial class DynamicScreen : global::Com.Atinternet.Tracker.AbstractScreen {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/DynamicScreen", typeof (DynamicScreen));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected DynamicScreen (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getScreenId;
#pragma warning disable 0169
		static Delegate GetGetScreenIdHandler ()
		{
			if (cb_getScreenId == null)
				cb_getScreenId = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetScreenId);
			return cb_getScreenId;
		}

		static IntPtr n_GetScreenId (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.ScreenId);
		}
#pragma warning restore 0169

		public virtual unsafe string ScreenId {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='getScreenId' and count(parameter)=0]"
			[Register ("getScreenId", "()Ljava/lang/String;", "GetGetScreenIdHandler")]
			get {
				const string __id = "getScreenId.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getUpdate;
#pragma warning disable 0169
		static Delegate GetGetUpdateHandler ()
		{
			if (cb_getUpdate == null)
				cb_getUpdate = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetUpdate);
			return cb_getUpdate;
		}

		static IntPtr n_GetUpdate (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Update);
		}
#pragma warning restore 0169

		public virtual unsafe global::Java.Util.Date Update {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='getUpdate' and count(parameter)=0]"
			[Register ("getUpdate", "()Ljava/util/Date;", "GetGetUpdateHandler")]
			get {
				const string __id = "getUpdate.()Ljava/util/Date;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return global::Java.Lang.Object.GetObject<global::Java.Util.Date> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_setChapter1_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetChapter1_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter1_Ljava_lang_String_ == null)
				cb_setChapter1_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter1_Ljava_lang_String_);
			return cb_setChapter1_Ljava_lang_String_;
		}

		static IntPtr n_SetChapter1_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_chapter1)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter1 (chapter1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setChapter1' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setChapter1", "(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetSetChapter1_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetChapter1 (string chapter1)
		{
			const string __id = "setChapter1.(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_chapter1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_chapter1);
			}
		}

		static Delegate cb_setChapter2_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetChapter2_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter2_Ljava_lang_String_ == null)
				cb_setChapter2_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter2_Ljava_lang_String_);
			return cb_setChapter2_Ljava_lang_String_;
		}

		static IntPtr n_SetChapter2_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_chapter2)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter2 (chapter2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setChapter2' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setChapter2", "(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetSetChapter2_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetChapter2 (string chapter2)
		{
			const string __id = "setChapter2.(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_chapter2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_chapter2);
			}
		}

		static Delegate cb_setChapter3_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetChapter3_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter3_Ljava_lang_String_ == null)
				cb_setChapter3_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter3_Ljava_lang_String_);
			return cb_setChapter3_Ljava_lang_String_;
		}

		static IntPtr n_SetChapter3_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_chapter3)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string chapter3 = JNIEnv.GetString (native_chapter3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter3 (chapter3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setChapter3' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setChapter3", "(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetSetChapter3_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetChapter3 (string chapter3)
		{
			const string __id = "setChapter3.(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_chapter3 = JNIEnv.NewString (chapter3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_chapter3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_chapter3);
			}
		}

		static Delegate cb_setIsBasketScreen_Z;
#pragma warning disable 0169
		static Delegate GetSetIsBasketScreen_ZHandler ()
		{
			if (cb_setIsBasketScreen_Z == null)
				cb_setIsBasketScreen_Z = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool, IntPtr>) n_SetIsBasketScreen_Z);
			return cb_setIsBasketScreen_Z;
		}

		static IntPtr n_SetIsBasketScreen_Z (IntPtr jnienv, IntPtr native__this, bool isBasketScreen)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetIsBasketScreen (isBasketScreen));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setIsBasketScreen' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setIsBasketScreen", "(Z)Lcom/atinternet/tracker/DynamicScreen;", "GetSetIsBasketScreen_ZHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetIsBasketScreen (bool isBasketScreen)
		{
			const string __id = "setIsBasketScreen.(Z)Lcom/atinternet/tracker/DynamicScreen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (isBasketScreen);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setLevel2_I;
#pragma warning disable 0169
		static Delegate GetSetLevel2_IHandler ()
		{
			if (cb_setLevel2_I == null)
				cb_setLevel2_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetLevel2_I);
			return cb_setLevel2_I;
		}

		static IntPtr n_SetLevel2_I (IntPtr jnienv, IntPtr native__this, int level2)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetLevel2 (level2));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setLevel2' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setLevel2", "(I)Lcom/atinternet/tracker/DynamicScreen;", "GetSetLevel2_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetLevel2 (int level2)
		{
			const string __id = "setLevel2.(I)Lcom/atinternet/tracker/DynamicScreen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (level2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setName_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetName_Ljava_lang_String_Handler ()
		{
			if (cb_setName_Ljava_lang_String_ == null)
				cb_setName_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetName_Ljava_lang_String_);
			return cb_setName_Ljava_lang_String_;
		}

		static IntPtr n_SetName_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetName (name));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setName' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setName", "(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetSetName_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetName (string name)
		{
			const string __id = "setName.(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_name);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

		static Delegate cb_setScreenId_I;
#pragma warning disable 0169
		[Obsolete]
		static Delegate GetSetScreenId_IHandler ()
		{
			if (cb_setScreenId_I == null)
				cb_setScreenId_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetScreenId_I);
			return cb_setScreenId_I;
		}

		[Obsolete]
		static IntPtr n_SetScreenId_I (IntPtr jnienv, IntPtr native__this, int screenId)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetScreenId (screenId));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setScreenId' and count(parameter)=1 and parameter[1][@type='int']]"
		[Obsolete (@"deprecated")]
		[Register ("setScreenId", "(I)Lcom/atinternet/tracker/DynamicScreen;", "GetSetScreenId_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetScreenId (int screenId)
		{
			const string __id = "setScreenId.(I)Lcom/atinternet/tracker/DynamicScreen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (screenId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setScreenId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetScreenId_Ljava_lang_String_Handler ()
		{
			if (cb_setScreenId_Ljava_lang_String_ == null)
				cb_setScreenId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetScreenId_Ljava_lang_String_);
			return cb_setScreenId_Ljava_lang_String_;
		}

		static IntPtr n_SetScreenId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_screenId)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string screenId = JNIEnv.GetString (native_screenId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetScreenId (screenId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setScreenId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setScreenId", "(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;", "GetSetScreenId_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetScreenId (string screenId)
		{
			const string __id = "setScreenId.(Ljava/lang/String;)Lcom/atinternet/tracker/DynamicScreen;";
			IntPtr native_screenId = JNIEnv.NewString (screenId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_screenId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_screenId);
			}
		}

		static Delegate cb_setUpdate_Ljava_util_Date_;
#pragma warning disable 0169
		static Delegate GetSetUpdate_Ljava_util_Date_Handler ()
		{
			if (cb_setUpdate_Ljava_util_Date_ == null)
				cb_setUpdate_Ljava_util_Date_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetUpdate_Ljava_util_Date_);
			return cb_setUpdate_Ljava_util_Date_;
		}

		static IntPtr n_SetUpdate_Ljava_util_Date_ (IntPtr jnienv, IntPtr native__this, IntPtr native_update)
		{
			global::Com.Atinternet.Tracker.DynamicScreen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Java.Util.Date update = global::Java.Lang.Object.GetObject<global::Java.Util.Date> (native_update, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetUpdate (update));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='DynamicScreen']/method[@name='setUpdate' and count(parameter)=1 and parameter[1][@type='java.util.Date']]"
		[Register ("setUpdate", "(Ljava/util/Date;)Lcom/atinternet/tracker/DynamicScreen;", "GetSetUpdate_Ljava_util_Date_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.DynamicScreen SetUpdate (global::Java.Util.Date update)
		{
			const string __id = "setUpdate.(Ljava/util/Date;)Lcom/atinternet/tracker/DynamicScreen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((update == null) ? IntPtr.Zero : ((global::Java.Lang.Object) update).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.DynamicScreen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
