using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker.Ecommerce {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='ProductPurchased']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/ecommerce/ProductPurchased", DoNotGenerateAcw=true)]
	public partial class ProductPurchased : global::Com.Atinternet.Tracker.Event {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/ecommerce/ProductPurchased", typeof (ProductPurchased));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected ProductPurchased (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='ProductPurchased']/constructor[@name='ProductPurchased' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe ProductPurchased ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			const string __id = "()V";

			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				var __r = _members.InstanceMethods.StartCreateInstance (__id, ((object) this).GetType (), null);
				SetHandle (__r.Handle, JniHandleOwnership.TransferLocalRef);
				_members.InstanceMethods.FinishCreateInstance (__id, this, null);
			} finally {
			}
		}

		static Delegate cb_Cart;
#pragma warning disable 0169
		static Delegate GetCartHandler ()
		{
			if (cb_Cart == null)
				cb_Cart = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Cart);
			return cb_Cart;
		}

		static IntPtr n_Cart (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.ProductPurchased __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.ProductPurchased> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Cart ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='ProductPurchased']/method[@name='Cart' and count(parameter)=0]"
		[Register ("Cart", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceCart;", "GetCartHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceCart Cart ()
		{
			const string __id = "Cart.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceCart;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceCart> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Product;
#pragma warning disable 0169
		static Delegate GetProductHandler ()
		{
			if (cb_Product == null)
				cb_Product = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Product);
			return cb_Product;
		}

		static IntPtr n_Product (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.ProductPurchased __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.ProductPurchased> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Product ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='ProductPurchased']/method[@name='Product' and count(parameter)=0]"
		[Register ("Product", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceProduct;", "GetProductHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceProduct Product ()
		{
			const string __id = "Product.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceProduct;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceProduct> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_Transaction;
#pragma warning disable 0169
		static Delegate GetTransactionHandler ()
		{
			if (cb_Transaction == null)
				cb_Transaction = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Transaction);
			return cb_Transaction;
		}

		static IntPtr n_Transaction (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Ecommerce.ProductPurchased __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.ProductPurchased> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Transaction ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker.ecommerce']/class[@name='ProductPurchased']/method[@name='Transaction' and count(parameter)=0]"
		[Register ("Transaction", "()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceTransaction;", "GetTransactionHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceTransaction Transaction ()
		{
			const string __id = "Transaction.()Lcom/atinternet/tracker/ecommerce/objectproperties/ECommerceTransaction;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Ecommerce.Objectproperties.ECommerceTransaction> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
