using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Events']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Events", DoNotGenerateAcw=true)]
	public partial class Events : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Events", typeof (Events));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Events (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Lcom_atinternet_tracker_Event_;
#pragma warning disable 0169
		static Delegate GetAdd_Lcom_atinternet_tracker_Event_Handler ()
		{
			if (cb_add_Lcom_atinternet_tracker_Event_ == null)
				cb_add_Lcom_atinternet_tracker_Event_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Lcom_atinternet_tracker_Event_);
			return cb_add_Lcom_atinternet_tracker_Event_;
		}

		static IntPtr n_Add_Lcom_atinternet_tracker_Event_ (IntPtr jnienv, IntPtr native__this, IntPtr native_e)
		{
			global::Com.Atinternet.Tracker.Events __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Events> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Atinternet.Tracker.Event e = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (native_e, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (e));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Events']/method[@name='add' and count(parameter)=1 and parameter[1][@type='com.atinternet.tracker.Event']]"
		[Register ("add", "(Lcom/atinternet/tracker/Event;)Lcom/atinternet/tracker/Event;", "GetAdd_Lcom_atinternet_tracker_Event_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Event Add (global::Com.Atinternet.Tracker.Event e)
		{
			const string __id = "add.(Lcom/atinternet/tracker/Event;)Lcom/atinternet/tracker/Event;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((e == null) ? IntPtr.Zero : ((global::Java.Lang.Object) e).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_util_Map_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_util_Map_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_util_Map_ == null)
				cb_add_Ljava_lang_String_Ljava_util_Map_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_util_Map_);
			return cb_add_Ljava_lang_String_Ljava_util_Map_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_util_Map_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name, IntPtr native_dataObject)
		{
			global::Com.Atinternet.Tracker.Events __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Events> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			var dataObject = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.FromJniHandle (native_dataObject, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (name, dataObject));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Events']/method[@name='add' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.util.Map&lt;java.lang.String, java.lang.Object&gt;']]"
		[Register ("add", "(Ljava/lang/String;Ljava/util/Map;)Lcom/atinternet/tracker/Event;", "GetAdd_Ljava_lang_String_Ljava_util_Map_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Event Add (string name, global::System.Collections.Generic.IDictionary<string, global::Java.Lang.Object> dataObject)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/util/Map;)Lcom/atinternet/tracker/Event;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_dataObject = global::Android.Runtime.JavaDictionary<string, global::Java.Lang.Object>.ToLocalJniHandle (dataObject);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_name);
				__args [1] = new JniArgumentValue (native_dataObject);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Event> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_dataObject);
			}
		}

		static Delegate cb_send;
#pragma warning disable 0169
		static Delegate GetSendHandler ()
		{
			if (cb_send == null)
				cb_send = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Send);
			return cb_send;
		}

		static void n_Send (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Events __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Events> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Send ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Events']/method[@name='send' and count(parameter)=0]"
		[Register ("send", "()V", "GetSendHandler")]
		public virtual unsafe void Send ()
		{
			const string __id = "send.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
