using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath interface reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='SetConfigCallback']"
	[Register ("com/atinternet/tracker/SetConfigCallback", "", "Com.Atinternet.Tracker.ISetConfigCallbackInvoker")]
	public partial interface ISetConfigCallback : IJavaObject, IJavaPeerable {

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='SetConfigCallback']/method[@name='setConfigEnd' and count(parameter)=0]"
		[Register ("setConfigEnd", "()V", "GetSetConfigEndHandler:Com.Atinternet.Tracker.ISetConfigCallbackInvoker, ATInternet.Android")]
		void SetConfigEnd ();

	}

	[global::Android.Runtime.Register ("com/atinternet/tracker/SetConfigCallback", DoNotGenerateAcw=true)]
	internal partial class ISetConfigCallbackInvoker : global::Java.Lang.Object, ISetConfigCallback {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/SetConfigCallback", typeof (ISetConfigCallbackInvoker));

		static IntPtr java_class_ref {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		IntPtr class_ref;

		public static ISetConfigCallback GetObject (IntPtr handle, JniHandleOwnership transfer)
		{
			return global::Java.Lang.Object.GetObject<ISetConfigCallback> (handle, transfer);
		}

		static IntPtr Validate (IntPtr handle)
		{
			if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
				throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
							JNIEnv.GetClassNameFromInstance (handle), "com.atinternet.tracker.SetConfigCallback"));
			return handle;
		}

		protected override void Dispose (bool disposing)
		{
			if (this.class_ref != IntPtr.Zero)
				JNIEnv.DeleteGlobalRef (this.class_ref);
			this.class_ref = IntPtr.Zero;
			base.Dispose (disposing);
		}

		public ISetConfigCallbackInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
		{
			IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
			this.class_ref = JNIEnv.NewGlobalRef (local_ref);
			JNIEnv.DeleteLocalRef (local_ref);
		}

		static Delegate cb_setConfigEnd;
#pragma warning disable 0169
		static Delegate GetSetConfigEndHandler ()
		{
			if (cb_setConfigEnd == null)
				cb_setConfigEnd = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_SetConfigEnd);
			return cb_setConfigEnd;
		}

		static void n_SetConfigEnd (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.ISetConfigCallback __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.ISetConfigCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.SetConfigEnd ();
		}
#pragma warning restore 0169

		IntPtr id_setConfigEnd;
		public unsafe void SetConfigEnd ()
		{
			if (id_setConfigEnd == IntPtr.Zero)
				id_setConfigEnd = JNIEnv.GetMethodID (class_ref, "setConfigEnd", "()V");
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setConfigEnd);
		}

	}

}
