using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath interface reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='UserIdCallback']"
	[Register ("com/atinternet/tracker/UserIdCallback", "", "Com.Atinternet.Tracker.IUserIdCallbackInvoker")]
	public partial interface IUserIdCallback : IJavaObject, IJavaPeerable {

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/interface[@name='UserIdCallback']/method[@name='receiveUserId' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("receiveUserId", "(Ljava/lang/String;)V", "GetReceiveUserId_Ljava_lang_String_Handler:Com.Atinternet.Tracker.IUserIdCallbackInvoker, ATInternet.Android")]
		void ReceiveUserId (string p0);

	}

	[global::Android.Runtime.Register ("com/atinternet/tracker/UserIdCallback", DoNotGenerateAcw=true)]
	internal partial class IUserIdCallbackInvoker : global::Java.Lang.Object, IUserIdCallback {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/UserIdCallback", typeof (IUserIdCallbackInvoker));

		static IntPtr java_class_ref {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		IntPtr class_ref;

		public static IUserIdCallback GetObject (IntPtr handle, JniHandleOwnership transfer)
		{
			return global::Java.Lang.Object.GetObject<IUserIdCallback> (handle, transfer);
		}

		static IntPtr Validate (IntPtr handle)
		{
			if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
				throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
							JNIEnv.GetClassNameFromInstance (handle), "com.atinternet.tracker.UserIdCallback"));
			return handle;
		}

		protected override void Dispose (bool disposing)
		{
			if (this.class_ref != IntPtr.Zero)
				JNIEnv.DeleteGlobalRef (this.class_ref);
			this.class_ref = IntPtr.Zero;
			base.Dispose (disposing);
		}

		public IUserIdCallbackInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
		{
			IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
			this.class_ref = JNIEnv.NewGlobalRef (local_ref);
			JNIEnv.DeleteLocalRef (local_ref);
		}

		static Delegate cb_receiveUserId_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetReceiveUserId_Ljava_lang_String_Handler ()
		{
			if (cb_receiveUserId_Ljava_lang_String_ == null)
				cb_receiveUserId_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_ReceiveUserId_Ljava_lang_String_);
			return cb_receiveUserId_Ljava_lang_String_;
		}

		static void n_ReceiveUserId_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Atinternet.Tracker.IUserIdCallback __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.IUserIdCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.ReceiveUserId (p0);
		}
#pragma warning restore 0169

		IntPtr id_receiveUserId_Ljava_lang_String_;
		public unsafe void ReceiveUserId (string p0)
		{
			if (id_receiveUserId_Ljava_lang_String_ == IntPtr.Zero)
				id_receiveUserId_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "receiveUserId", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (native_p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_receiveUserId_Ljava_lang_String_, __args);
			JNIEnv.DeleteLocalRef (native_p0);
		}

	}

}
