using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/InternalSearch", DoNotGenerateAcw=true)]
	public partial class InternalSearch : global::Com.Atinternet.Tracker.BusinessObject {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/InternalSearch", typeof (InternalSearch));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected InternalSearch (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getKeyword;
#pragma warning disable 0169
		static Delegate GetGetKeywordHandler ()
		{
			if (cb_getKeyword == null)
				cb_getKeyword = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetKeyword);
			return cb_getKeyword;
		}

		static IntPtr n_GetKeyword (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.InternalSearch __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Keyword);
		}
#pragma warning restore 0169

		public virtual unsafe string Keyword {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']/method[@name='getKeyword' and count(parameter)=0]"
			[Register ("getKeyword", "()Ljava/lang/String;", "GetGetKeywordHandler")]
			get {
				const string __id = "getKeyword.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getResultPosition;
#pragma warning disable 0169
		static Delegate GetGetResultPositionHandler ()
		{
			if (cb_getResultPosition == null)
				cb_getResultPosition = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetResultPosition);
			return cb_getResultPosition;
		}

		static int n_GetResultPosition (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.InternalSearch __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.ResultPosition;
		}
#pragma warning restore 0169

		public virtual unsafe int ResultPosition {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']/method[@name='getResultPosition' and count(parameter)=0]"
			[Register ("getResultPosition", "()I", "GetGetResultPositionHandler")]
			get {
				const string __id = "getResultPosition.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getResultScreenNumber;
#pragma warning disable 0169
		static Delegate GetGetResultScreenNumberHandler ()
		{
			if (cb_getResultScreenNumber == null)
				cb_getResultScreenNumber = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetResultScreenNumber);
			return cb_getResultScreenNumber;
		}

		static int n_GetResultScreenNumber (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.InternalSearch __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.ResultScreenNumber;
		}
#pragma warning restore 0169

		public virtual unsafe int ResultScreenNumber {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']/method[@name='getResultScreenNumber' and count(parameter)=0]"
			[Register ("getResultScreenNumber", "()I", "GetGetResultScreenNumberHandler")]
			get {
				const string __id = "getResultScreenNumber.()I";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualInt32Method (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_setKeyword_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetKeyword_Ljava_lang_String_Handler ()
		{
			if (cb_setKeyword_Ljava_lang_String_ == null)
				cb_setKeyword_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetKeyword_Ljava_lang_String_);
			return cb_setKeyword_Ljava_lang_String_;
		}

		static IntPtr n_SetKeyword_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_keyword)
		{
			global::Com.Atinternet.Tracker.InternalSearch __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string keyword = JNIEnv.GetString (native_keyword, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetKeyword (keyword));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']/method[@name='setKeyword' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setKeyword", "(Ljava/lang/String;)Lcom/atinternet/tracker/InternalSearch;", "GetSetKeyword_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.InternalSearch SetKeyword (string keyword)
		{
			const string __id = "setKeyword.(Ljava/lang/String;)Lcom/atinternet/tracker/InternalSearch;";
			IntPtr native_keyword = JNIEnv.NewString (keyword);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_keyword);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_keyword);
			}
		}

		static Delegate cb_setResultPosition_I;
#pragma warning disable 0169
		static Delegate GetSetResultPosition_IHandler ()
		{
			if (cb_setResultPosition_I == null)
				cb_setResultPosition_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetResultPosition_I);
			return cb_setResultPosition_I;
		}

		static IntPtr n_SetResultPosition_I (IntPtr jnienv, IntPtr native__this, int resultPosition)
		{
			global::Com.Atinternet.Tracker.InternalSearch __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetResultPosition (resultPosition));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']/method[@name='setResultPosition' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setResultPosition", "(I)Lcom/atinternet/tracker/InternalSearch;", "GetSetResultPosition_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.InternalSearch SetResultPosition (int resultPosition)
		{
			const string __id = "setResultPosition.(I)Lcom/atinternet/tracker/InternalSearch;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (resultPosition);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setResultScreenNumber_I;
#pragma warning disable 0169
		static Delegate GetSetResultScreenNumber_IHandler ()
		{
			if (cb_setResultScreenNumber_I == null)
				cb_setResultScreenNumber_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetResultScreenNumber_I);
			return cb_setResultScreenNumber_I;
		}

		static IntPtr n_SetResultScreenNumber_I (IntPtr jnienv, IntPtr native__this, int resultScreenNumber)
		{
			global::Com.Atinternet.Tracker.InternalSearch __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetResultScreenNumber (resultScreenNumber));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearch']/method[@name='setResultScreenNumber' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setResultScreenNumber", "(I)Lcom/atinternet/tracker/InternalSearch;", "GetSetResultScreenNumber_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.InternalSearch SetResultScreenNumber (int resultScreenNumber)
		{
			const string __id = "setResultScreenNumber.(I)Lcom/atinternet/tracker/InternalSearch;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (resultScreenNumber);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
