using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearches']"
	[ObsoleteAttribute (@"This class is obsoleted in this android platform")]
	[global::Android.Runtime.Register ("com/atinternet/tracker/InternalSearches", DoNotGenerateAcw=true)]
	public partial class InternalSearches : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/InternalSearches", typeof (InternalSearches));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected InternalSearches (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Ljava_lang_String_I;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_IHandler ()
		{
			if (cb_add_Ljava_lang_String_I == null)
				cb_add_Ljava_lang_String_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, int, IntPtr>) n_Add_Ljava_lang_String_I);
			return cb_add_Ljava_lang_String_I;
		}

		static IntPtr n_Add_Ljava_lang_String_I (IntPtr jnienv, IntPtr native__this, IntPtr native_keywordLabel, int resultPageNumber)
		{
			global::Com.Atinternet.Tracker.InternalSearches __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearches> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string keywordLabel = JNIEnv.GetString (native_keywordLabel, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (keywordLabel, resultPageNumber));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearches']/method[@name='add' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='int']]"
		[Register ("add", "(Ljava/lang/String;I)Lcom/atinternet/tracker/InternalSearch;", "GetAdd_Ljava_lang_String_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.InternalSearch Add (string keywordLabel, int resultPageNumber)
		{
			const string __id = "add.(Ljava/lang/String;I)Lcom/atinternet/tracker/InternalSearch;";
			IntPtr native_keywordLabel = JNIEnv.NewString (keywordLabel);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_keywordLabel);
				__args [1] = new JniArgumentValue (resultPageNumber);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_keywordLabel);
			}
		}

		static Delegate cb_add_Ljava_lang_String_II;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_IIHandler ()
		{
			if (cb_add_Ljava_lang_String_II == null)
				cb_add_Ljava_lang_String_II = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, int, int, IntPtr>) n_Add_Ljava_lang_String_II);
			return cb_add_Ljava_lang_String_II;
		}

		static IntPtr n_Add_Ljava_lang_String_II (IntPtr jnienv, IntPtr native__this, IntPtr native_keywordLabel, int resultPageNumber, int resultPosition)
		{
			global::Com.Atinternet.Tracker.InternalSearches __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearches> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string keywordLabel = JNIEnv.GetString (native_keywordLabel, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (keywordLabel, resultPageNumber, resultPosition));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='InternalSearches']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='int'] and parameter[3][@type='int']]"
		[Register ("add", "(Ljava/lang/String;II)Lcom/atinternet/tracker/InternalSearch;", "GetAdd_Ljava_lang_String_IIHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.InternalSearch Add (string keywordLabel, int resultPageNumber, int resultPosition)
		{
			const string __id = "add.(Ljava/lang/String;II)Lcom/atinternet/tracker/InternalSearch;";
			IntPtr native_keywordLabel = JNIEnv.NewString (keywordLabel);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_keywordLabel);
				__args [1] = new JniArgumentValue (resultPageNumber);
				__args [2] = new JniArgumentValue (resultPosition);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.InternalSearch> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_keywordLabel);
			}
		}

	}
}
