using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Media", DoNotGenerateAcw=true)]
	public partial class Media : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Media", typeof (Media));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Media (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_I;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_IHandler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_I == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, int, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_I);
			return cb_add_Ljava_lang_String_Ljava_lang_String_I;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_I (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel, IntPtr native_mediaType, int duration)
		{
			global::Com.Atinternet.Tracker.Media __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			string mediaType = JNIEnv.GetString (native_mediaType, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (mediaLabel, mediaType, duration));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='int']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;", "GetAdd_Ljava_lang_String_Ljava_lang_String_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium Add (string mediaLabel, string mediaType, int duration)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			IntPtr native_mediaType = JNIEnv.NewString (mediaType);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				__args [1] = new JniArgumentValue (native_mediaType);
				__args [2] = new JniArgumentValue (duration);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
				JNIEnv.DeleteLocalRef (native_mediaType);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IHandler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, int, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel, IntPtr native_mediaTheme1, IntPtr native_mediaType, int duration)
		{
			global::Com.Atinternet.Tracker.Media __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			string mediaTheme1 = JNIEnv.GetString (native_mediaTheme1, JniHandleOwnership.DoNotTransfer);
			string mediaType = JNIEnv.GetString (native_mediaType, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (mediaLabel, mediaTheme1, mediaType, duration));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']/method[@name='add' and count(parameter)=4 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='int']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium Add (string mediaLabel, string mediaTheme1, string mediaType, int duration)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			IntPtr native_mediaTheme1 = JNIEnv.NewString (mediaTheme1);
			IntPtr native_mediaType = JNIEnv.NewString (mediaType);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [4];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				__args [1] = new JniArgumentValue (native_mediaTheme1);
				__args [2] = new JniArgumentValue (native_mediaType);
				__args [3] = new JniArgumentValue (duration);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
				JNIEnv.DeleteLocalRef (native_mediaTheme1);
				JNIEnv.DeleteLocalRef (native_mediaType);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IHandler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, int, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel, IntPtr native_mediaTheme1, IntPtr native_mediaTheme2, IntPtr native_mediaType, int duration)
		{
			global::Com.Atinternet.Tracker.Media __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			string mediaTheme1 = JNIEnv.GetString (native_mediaTheme1, JniHandleOwnership.DoNotTransfer);
			string mediaTheme2 = JNIEnv.GetString (native_mediaTheme2, JniHandleOwnership.DoNotTransfer);
			string mediaType = JNIEnv.GetString (native_mediaType, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (mediaLabel, mediaTheme1, mediaTheme2, mediaType, duration));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']/method[@name='add' and count(parameter)=5 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='int']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium Add (string mediaLabel, string mediaTheme1, string mediaTheme2, string mediaType, int duration)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			IntPtr native_mediaTheme1 = JNIEnv.NewString (mediaTheme1);
			IntPtr native_mediaTheme2 = JNIEnv.NewString (mediaTheme2);
			IntPtr native_mediaType = JNIEnv.NewString (mediaType);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [5];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				__args [1] = new JniArgumentValue (native_mediaTheme1);
				__args [2] = new JniArgumentValue (native_mediaTheme2);
				__args [3] = new JniArgumentValue (native_mediaType);
				__args [4] = new JniArgumentValue (duration);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
				JNIEnv.DeleteLocalRef (native_mediaTheme1);
				JNIEnv.DeleteLocalRef (native_mediaTheme2);
				JNIEnv.DeleteLocalRef (native_mediaType);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IHandler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, int, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_I (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel, IntPtr native_mediaTheme1, IntPtr native_mediaTheme2, IntPtr native_mediaTheme3, IntPtr native_mediaType, int duration)
		{
			global::Com.Atinternet.Tracker.Media __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			string mediaTheme1 = JNIEnv.GetString (native_mediaTheme1, JniHandleOwnership.DoNotTransfer);
			string mediaTheme2 = JNIEnv.GetString (native_mediaTheme2, JniHandleOwnership.DoNotTransfer);
			string mediaTheme3 = JNIEnv.GetString (native_mediaTheme3, JniHandleOwnership.DoNotTransfer);
			string mediaType = JNIEnv.GetString (native_mediaType, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (mediaLabel, mediaTheme1, mediaTheme2, mediaTheme3, mediaType, duration));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']/method[@name='add' and count(parameter)=6 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String'] and parameter[5][@type='java.lang.String'] and parameter[6][@type='int']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Medium Add (string mediaLabel, string mediaTheme1, string mediaTheme2, string mediaTheme3, string mediaType, int duration)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)Lcom/atinternet/tracker/Medium;";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			IntPtr native_mediaTheme1 = JNIEnv.NewString (mediaTheme1);
			IntPtr native_mediaTheme2 = JNIEnv.NewString (mediaTheme2);
			IntPtr native_mediaTheme3 = JNIEnv.NewString (mediaTheme3);
			IntPtr native_mediaType = JNIEnv.NewString (mediaType);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [6];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				__args [1] = new JniArgumentValue (native_mediaTheme1);
				__args [2] = new JniArgumentValue (native_mediaTheme2);
				__args [3] = new JniArgumentValue (native_mediaTheme3);
				__args [4] = new JniArgumentValue (native_mediaType);
				__args [5] = new JniArgumentValue (duration);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Medium> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
				JNIEnv.DeleteLocalRef (native_mediaTheme1);
				JNIEnv.DeleteLocalRef (native_mediaTheme2);
				JNIEnv.DeleteLocalRef (native_mediaTheme3);
				JNIEnv.DeleteLocalRef (native_mediaType);
			}
		}

		static Delegate cb_remove_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetRemove_Ljava_lang_String_Handler ()
		{
			if (cb_remove_Ljava_lang_String_ == null)
				cb_remove_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_Remove_Ljava_lang_String_);
			return cb_remove_Ljava_lang_String_;
		}

		static void n_Remove_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_mediaLabel)
		{
			global::Com.Atinternet.Tracker.Media __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string mediaLabel = JNIEnv.GetString (native_mediaLabel, JniHandleOwnership.DoNotTransfer);
			__this.Remove (mediaLabel);
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']/method[@name='remove' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("remove", "(Ljava/lang/String;)V", "GetRemove_Ljava_lang_String_Handler")]
		public virtual unsafe void Remove (string mediaLabel)
		{
			const string __id = "remove.(Ljava/lang/String;)V";
			IntPtr native_mediaLabel = JNIEnv.NewString (mediaLabel);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_mediaLabel);
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_mediaLabel);
			}
		}

		static Delegate cb_removeAll;
#pragma warning disable 0169
		static Delegate GetRemoveAllHandler ()
		{
			if (cb_removeAll == null)
				cb_removeAll = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_RemoveAll);
			return cb_removeAll;
		}

		static void n_RemoveAll (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Media __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Media> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RemoveAll ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Media']/method[@name='removeAll' and count(parameter)=0]"
		[Register ("removeAll", "()V", "GetRemoveAllHandler")]
		public virtual unsafe void RemoveAll ()
		{
			const string __id = "removeAll.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
