using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/OrderAmount", DoNotGenerateAcw=true)]
	public partial class OrderAmount : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/OrderAmount", typeof (OrderAmount));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected OrderAmount (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getAmountTaxFree;
#pragma warning disable 0169
		static Delegate GetGetAmountTaxFreeHandler ()
		{
			if (cb_getAmountTaxFree == null)
				cb_getAmountTaxFree = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetAmountTaxFree);
			return cb_getAmountTaxFree;
		}

		static double n_GetAmountTaxFree (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.AmountTaxFree;
		}
#pragma warning restore 0169

		public virtual unsafe double AmountTaxFree {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='getAmountTaxFree' and count(parameter)=0]"
			[Register ("getAmountTaxFree", "()D", "GetGetAmountTaxFreeHandler")]
			get {
				const string __id = "getAmountTaxFree.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getAmountTaxIncluded;
#pragma warning disable 0169
		static Delegate GetGetAmountTaxIncludedHandler ()
		{
			if (cb_getAmountTaxIncluded == null)
				cb_getAmountTaxIncluded = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetAmountTaxIncluded);
			return cb_getAmountTaxIncluded;
		}

		static double n_GetAmountTaxIncluded (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.AmountTaxIncluded;
		}
#pragma warning restore 0169

		public virtual unsafe double AmountTaxIncluded {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='getAmountTaxIncluded' and count(parameter)=0]"
			[Register ("getAmountTaxIncluded", "()D", "GetGetAmountTaxIncludedHandler")]
			get {
				const string __id = "getAmountTaxIncluded.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getTaxAmount;
#pragma warning disable 0169
		static Delegate GetGetTaxAmountHandler ()
		{
			if (cb_getTaxAmount == null)
				cb_getTaxAmount = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetTaxAmount);
			return cb_getTaxAmount;
		}

		static double n_GetTaxAmount (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.TaxAmount;
		}
#pragma warning restore 0169

		public virtual unsafe double TaxAmount {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='getTaxAmount' and count(parameter)=0]"
			[Register ("getTaxAmount", "()D", "GetGetTaxAmountHandler")]
			get {
				const string __id = "getTaxAmount.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_set_DDD;
#pragma warning disable 0169
		static Delegate GetSet_DDDHandler ()
		{
			if (cb_set_DDD == null)
				cb_set_DDD = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, double, double, IntPtr>) n_Set_DDD);
			return cb_set_DDD;
		}

		static IntPtr n_Set_DDD (IntPtr jnienv, IntPtr native__this, double amountTaxFree, double amountTaxIncluded, double taxAmount)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Set (amountTaxFree, amountTaxIncluded, taxAmount));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='set' and count(parameter)=3 and parameter[1][@type='double'] and parameter[2][@type='double'] and parameter[3][@type='double']]"
		[Register ("set", "(DDD)Lcom/atinternet/tracker/Order;", "GetSet_DDDHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order Set (double amountTaxFree, double amountTaxIncluded, double taxAmount)
		{
			const string __id = "set.(DDD)Lcom/atinternet/tracker/Order;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (amountTaxFree);
				__args [1] = new JniArgumentValue (amountTaxIncluded);
				__args [2] = new JniArgumentValue (taxAmount);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAmountTaxFree_D;
#pragma warning disable 0169
		static Delegate GetSetAmountTaxFree_DHandler ()
		{
			if (cb_setAmountTaxFree_D == null)
				cb_setAmountTaxFree_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetAmountTaxFree_D);
			return cb_setAmountTaxFree_D;
		}

		static IntPtr n_SetAmountTaxFree_D (IntPtr jnienv, IntPtr native__this, double amountTaxFree)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetAmountTaxFree (amountTaxFree));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='setAmountTaxFree' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setAmountTaxFree", "(D)Lcom/atinternet/tracker/OrderAmount;", "GetSetAmountTaxFree_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderAmount SetAmountTaxFree (double amountTaxFree)
		{
			const string __id = "setAmountTaxFree.(D)Lcom/atinternet/tracker/OrderAmount;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (amountTaxFree);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setAmountTaxIncluded_D;
#pragma warning disable 0169
		static Delegate GetSetAmountTaxIncluded_DHandler ()
		{
			if (cb_setAmountTaxIncluded_D == null)
				cb_setAmountTaxIncluded_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetAmountTaxIncluded_D);
			return cb_setAmountTaxIncluded_D;
		}

		static IntPtr n_SetAmountTaxIncluded_D (IntPtr jnienv, IntPtr native__this, double amountTaxIncluded)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetAmountTaxIncluded (amountTaxIncluded));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='setAmountTaxIncluded' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setAmountTaxIncluded", "(D)Lcom/atinternet/tracker/OrderAmount;", "GetSetAmountTaxIncluded_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderAmount SetAmountTaxIncluded (double amountTaxIncluded)
		{
			const string __id = "setAmountTaxIncluded.(D)Lcom/atinternet/tracker/OrderAmount;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (amountTaxIncluded);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setTaxAmount_D;
#pragma warning disable 0169
		static Delegate GetSetTaxAmount_DHandler ()
		{
			if (cb_setTaxAmount_D == null)
				cb_setTaxAmount_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetTaxAmount_D);
			return cb_setTaxAmount_D;
		}

		static IntPtr n_SetTaxAmount_D (IntPtr jnienv, IntPtr native__this, double taxAmount)
		{
			global::Com.Atinternet.Tracker.OrderAmount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetTaxAmount (taxAmount));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderAmount']/method[@name='setTaxAmount' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setTaxAmount", "(D)Lcom/atinternet/tracker/OrderAmount;", "GetSetTaxAmount_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderAmount SetTaxAmount (double taxAmount)
		{
			const string __id = "setTaxAmount.(D)Lcom/atinternet/tracker/OrderAmount;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (taxAmount);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderAmount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

	}
}
