using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/OrderDiscount", DoNotGenerateAcw=true)]
	public partial class OrderDiscount : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/OrderDiscount", typeof (OrderDiscount));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected OrderDiscount (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getDiscountTaxFree;
#pragma warning disable 0169
		static Delegate GetGetDiscountTaxFreeHandler ()
		{
			if (cb_getDiscountTaxFree == null)
				cb_getDiscountTaxFree = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetDiscountTaxFree);
			return cb_getDiscountTaxFree;
		}

		static double n_GetDiscountTaxFree (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.DiscountTaxFree;
		}
#pragma warning restore 0169

		public virtual unsafe double DiscountTaxFree {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='getDiscountTaxFree' and count(parameter)=0]"
			[Register ("getDiscountTaxFree", "()D", "GetGetDiscountTaxFreeHandler")]
			get {
				const string __id = "getDiscountTaxFree.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getDiscountTaxIncluded;
#pragma warning disable 0169
		static Delegate GetGetDiscountTaxIncludedHandler ()
		{
			if (cb_getDiscountTaxIncluded == null)
				cb_getDiscountTaxIncluded = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetDiscountTaxIncluded);
			return cb_getDiscountTaxIncluded;
		}

		static double n_GetDiscountTaxIncluded (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.DiscountTaxIncluded;
		}
#pragma warning restore 0169

		public virtual unsafe double DiscountTaxIncluded {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='getDiscountTaxIncluded' and count(parameter)=0]"
			[Register ("getDiscountTaxIncluded", "()D", "GetGetDiscountTaxIncludedHandler")]
			get {
				const string __id = "getDiscountTaxIncluded.()D";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualDoubleMethod (__id, this, null);
					return __rm;
				} finally {
				}
			}
		}

		static Delegate cb_getPromotionalCode;
#pragma warning disable 0169
		static Delegate GetGetPromotionalCodeHandler ()
		{
			if (cb_getPromotionalCode == null)
				cb_getPromotionalCode = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetPromotionalCode);
			return cb_getPromotionalCode;
		}

		static IntPtr n_GetPromotionalCode (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.PromotionalCode);
		}
#pragma warning restore 0169

		public virtual unsafe string PromotionalCode {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='getPromotionalCode' and count(parameter)=0]"
			[Register ("getPromotionalCode", "()Ljava/lang/String;", "GetGetPromotionalCodeHandler")]
			get {
				const string __id = "getPromotionalCode.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_set_DDLjava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSet_DDLjava_lang_String_Handler ()
		{
			if (cb_set_DDLjava_lang_String_ == null)
				cb_set_DDLjava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, double, IntPtr, IntPtr>) n_Set_DDLjava_lang_String_);
			return cb_set_DDLjava_lang_String_;
		}

		static IntPtr n_Set_DDLjava_lang_String_ (IntPtr jnienv, IntPtr native__this, double discountTaxFree, double discountTaxIncluded, IntPtr native_promotionalCode)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string promotionalCode = JNIEnv.GetString (native_promotionalCode, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Set (discountTaxFree, discountTaxIncluded, promotionalCode));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='set' and count(parameter)=3 and parameter[1][@type='double'] and parameter[2][@type='double'] and parameter[3][@type='java.lang.String']]"
		[Register ("set", "(DDLjava/lang/String;)Lcom/atinternet/tracker/Order;", "GetSet_DDLjava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Order Set (double discountTaxFree, double discountTaxIncluded, string promotionalCode)
		{
			const string __id = "set.(DDLjava/lang/String;)Lcom/atinternet/tracker/Order;";
			IntPtr native_promotionalCode = JNIEnv.NewString (promotionalCode);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (discountTaxFree);
				__args [1] = new JniArgumentValue (discountTaxIncluded);
				__args [2] = new JniArgumentValue (native_promotionalCode);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Order> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_promotionalCode);
			}
		}

		static Delegate cb_setDiscountTaxFree_D;
#pragma warning disable 0169
		static Delegate GetSetDiscountTaxFree_DHandler ()
		{
			if (cb_setDiscountTaxFree_D == null)
				cb_setDiscountTaxFree_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetDiscountTaxFree_D);
			return cb_setDiscountTaxFree_D;
		}

		static IntPtr n_SetDiscountTaxFree_D (IntPtr jnienv, IntPtr native__this, double discountTaxFree)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetDiscountTaxFree (discountTaxFree));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='setDiscountTaxFree' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setDiscountTaxFree", "(D)Lcom/atinternet/tracker/OrderDiscount;", "GetSetDiscountTaxFree_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDiscount SetDiscountTaxFree (double discountTaxFree)
		{
			const string __id = "setDiscountTaxFree.(D)Lcom/atinternet/tracker/OrderDiscount;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (discountTaxFree);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setDiscountTaxIncluded_D;
#pragma warning disable 0169
		static Delegate GetSetDiscountTaxIncluded_DHandler ()
		{
			if (cb_setDiscountTaxIncluded_D == null)
				cb_setDiscountTaxIncluded_D = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double, IntPtr>) n_SetDiscountTaxIncluded_D);
			return cb_setDiscountTaxIncluded_D;
		}

		static IntPtr n_SetDiscountTaxIncluded_D (IntPtr jnienv, IntPtr native__this, double discountTaxIncluded)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetDiscountTaxIncluded (discountTaxIncluded));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='setDiscountTaxIncluded' and count(parameter)=1 and parameter[1][@type='double']]"
		[Register ("setDiscountTaxIncluded", "(D)Lcom/atinternet/tracker/OrderDiscount;", "GetSetDiscountTaxIncluded_DHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDiscount SetDiscountTaxIncluded (double discountTaxIncluded)
		{
			const string __id = "setDiscountTaxIncluded.(D)Lcom/atinternet/tracker/OrderDiscount;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (discountTaxIncluded);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setPromotionalCode_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetPromotionalCode_Ljava_lang_String_Handler ()
		{
			if (cb_setPromotionalCode_Ljava_lang_String_ == null)
				cb_setPromotionalCode_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetPromotionalCode_Ljava_lang_String_);
			return cb_setPromotionalCode_Ljava_lang_String_;
		}

		static IntPtr n_SetPromotionalCode_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_promotionalCode)
		{
			global::Com.Atinternet.Tracker.OrderDiscount __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string promotionalCode = JNIEnv.GetString (native_promotionalCode, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetPromotionalCode (promotionalCode));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='OrderDiscount']/method[@name='setPromotionalCode' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setPromotionalCode", "(Ljava/lang/String;)Lcom/atinternet/tracker/OrderDiscount;", "GetSetPromotionalCode_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.OrderDiscount SetPromotionalCode (string promotionalCode)
		{
			const string __id = "setPromotionalCode.(Ljava/lang/String;)Lcom/atinternet/tracker/OrderDiscount;";
			IntPtr native_promotionalCode = JNIEnv.NewString (promotionalCode);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_promotionalCode);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.OrderDiscount> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_promotionalCode);
			}
		}

	}
}
