using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publishers']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Publishers", DoNotGenerateAcw=true)]
	public partial class Publishers : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Publishers", typeof (Publishers));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Publishers (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_campaignId)
		{
			global::Com.Atinternet.Tracker.Publishers __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publishers> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string campaignId = JNIEnv.GetString (native_campaignId, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (campaignId));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publishers']/method[@name='add' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;", "GetAdd_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Publisher Add (string campaignId)
		{
			const string __id = "add.(Ljava/lang/String;)Lcom/atinternet/tracker/Publisher;";
			IntPtr native_campaignId = JNIEnv.NewString (campaignId);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_campaignId);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publisher> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_campaignId);
			}
		}

		static Delegate cb_sendImpressions;
#pragma warning disable 0169
		static Delegate GetSendImpressionsHandler ()
		{
			if (cb_sendImpressions == null)
				cb_sendImpressions = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_SendImpressions);
			return cb_sendImpressions;
		}

		static void n_SendImpressions (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Publishers __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Publishers> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.SendImpressions ();
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Publishers']/method[@name='sendImpressions' and count(parameter)=0]"
		[Register ("sendImpressions", "()V", "GetSendImpressionsHandler")]
		public virtual unsafe void SendImpressions ()
		{
			const string __id = "sendImpressions.()V";
			try {
				_members.InstanceMethods.InvokeVirtualVoidMethod (__id, this, null);
			} finally {
			}
		}

	}
}
