using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Screen", DoNotGenerateAcw=true)]
	public partial class Screen : global::Com.Atinternet.Tracker.AbstractScreen {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Screen", typeof (Screen));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Screen (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_getCompleteLabel;
#pragma warning disable 0169
		static Delegate GetGetCompleteLabelHandler ()
		{
			if (cb_getCompleteLabel == null)
				cb_getCompleteLabel = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCompleteLabel);
			return cb_getCompleteLabel;
		}

		static IntPtr n_GetCompleteLabel (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.CompleteLabel);
		}
#pragma warning restore 0169

		public virtual unsafe string CompleteLabel {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='getCompleteLabel' and count(parameter)=0]"
			[Register ("getCompleteLabel", "()Ljava/lang/String;", "GetGetCompleteLabelHandler")]
			get {
				const string __id = "getCompleteLabel.()Ljava/lang/String;";
				try {
					var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
					return JNIEnv.GetString (__rm.Handle, JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_setChapter1_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetChapter1_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter1_Ljava_lang_String_ == null)
				cb_setChapter1_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter1_Ljava_lang_String_);
			return cb_setChapter1_Ljava_lang_String_;
		}

		static IntPtr n_SetChapter1_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_chapter1)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter1 (chapter1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='setChapter1' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setChapter1", "(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetSetChapter1_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen SetChapter1 (string chapter1)
		{
			const string __id = "setChapter1.(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_chapter1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_chapter1);
			}
		}

		static Delegate cb_setChapter2_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetChapter2_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter2_Ljava_lang_String_ == null)
				cb_setChapter2_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter2_Ljava_lang_String_);
			return cb_setChapter2_Ljava_lang_String_;
		}

		static IntPtr n_SetChapter2_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_chapter2)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter2 (chapter2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='setChapter2' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setChapter2", "(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetSetChapter2_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen SetChapter2 (string chapter2)
		{
			const string __id = "setChapter2.(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_chapter2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_chapter2);
			}
		}

		static Delegate cb_setChapter3_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetChapter3_Ljava_lang_String_Handler ()
		{
			if (cb_setChapter3_Ljava_lang_String_ == null)
				cb_setChapter3_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetChapter3_Ljava_lang_String_);
			return cb_setChapter3_Ljava_lang_String_;
		}

		static IntPtr n_SetChapter3_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_chapter3)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string chapter3 = JNIEnv.GetString (native_chapter3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetChapter3 (chapter3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='setChapter3' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setChapter3", "(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetSetChapter3_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen SetChapter3 (string chapter3)
		{
			const string __id = "setChapter3.(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_chapter3 = JNIEnv.NewString (chapter3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_chapter3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_chapter3);
			}
		}

		static Delegate cb_setIsBasketScreen_Z;
#pragma warning disable 0169
		static Delegate GetSetIsBasketScreen_ZHandler ()
		{
			if (cb_setIsBasketScreen_Z == null)
				cb_setIsBasketScreen_Z = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool, IntPtr>) n_SetIsBasketScreen_Z);
			return cb_setIsBasketScreen_Z;
		}

		static IntPtr n_SetIsBasketScreen_Z (IntPtr jnienv, IntPtr native__this, bool isBasketScreen)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetIsBasketScreen (isBasketScreen));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='setIsBasketScreen' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setIsBasketScreen", "(Z)Lcom/atinternet/tracker/Screen;", "GetSetIsBasketScreen_ZHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen SetIsBasketScreen (bool isBasketScreen)
		{
			const string __id = "setIsBasketScreen.(Z)Lcom/atinternet/tracker/Screen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (isBasketScreen);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setLevel2_I;
#pragma warning disable 0169
		static Delegate GetSetLevel2_IHandler ()
		{
			if (cb_setLevel2_I == null)
				cb_setLevel2_I = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, IntPtr>) n_SetLevel2_I);
			return cb_setLevel2_I;
		}

		static IntPtr n_SetLevel2_I (IntPtr jnienv, IntPtr native__this, int level2)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.SetLevel2 (level2));
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='setLevel2' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register ("setLevel2", "(I)Lcom/atinternet/tracker/Screen;", "GetSetLevel2_IHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen SetLevel2 (int level2)
		{
			const string __id = "setLevel2.(I)Lcom/atinternet/tracker/Screen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (level2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_setName_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetName_Ljava_lang_String_Handler ()
		{
			if (cb_setName_Ljava_lang_String_ == null)
				cb_setName_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetName_Ljava_lang_String_);
			return cb_setName_Ljava_lang_String_;
		}

		static IntPtr n_SetName_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name)
		{
			global::Com.Atinternet.Tracker.Screen __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.SetName (name));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screen']/method[@name='setName' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setName", "(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetSetName_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen SetName (string name)
		{
			const string __id = "setName.(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_name);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

	}
}
