using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/Screens", DoNotGenerateAcw=true)]
	public partial class Screens : global::Java.Lang.Object {

		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/Screens", typeof (Screens));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		protected Screens (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static Delegate cb_add;
#pragma warning disable 0169
		static Delegate GetAddHandler ()
		{
			if (cb_add == null)
				cb_add = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_Add);
			return cb_add;
		}

		static IntPtr n_Add (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Atinternet.Tracker.Screens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Add ());
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']/method[@name='add' and count(parameter)=0]"
		[Register ("add", "()Lcom/atinternet/tracker/Screen;", "GetAddHandler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen Add ()
		{
			const string __id = "add.()Lcom/atinternet/tracker/Screen;";
			try {
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, null);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_Landroid_content_Context_;
#pragma warning disable 0169
		static Delegate GetAdd_Landroid_content_Context_Handler ()
		{
			if (cb_add_Landroid_content_Context_ == null)
				cb_add_Landroid_content_Context_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Landroid_content_Context_);
			return cb_add_Landroid_content_Context_;
		}

		static IntPtr n_Add_Landroid_content_Context_ (IntPtr jnienv, IntPtr native__this, IntPtr native_context)
		{
			global::Com.Atinternet.Tracker.Screens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Content.Context context = global::Java.Lang.Object.GetObject<global::Android.Content.Context> (native_context, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (context));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']/method[@name='add' and count(parameter)=1 and parameter[1][@type='android.content.Context']]"
		[Register ("add", "(Landroid/content/Context;)Lcom/atinternet/tracker/Screen;", "GetAdd_Landroid_content_Context_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen Add (global::Android.Content.Context context)
		{
			const string __id = "add.(Landroid/content/Context;)Lcom/atinternet/tracker/Screen;";
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue ((context == null) ? IntPtr.Zero : ((global::Java.Lang.Object) context).Handle);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
			}
		}

		static Delegate cb_add_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name)
		{
			global::Com.Atinternet.Tracker.Screens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (name));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']/method[@name='add' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetAdd_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen Add (string name)
		{
			const string __id = "add.(Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_name = JNIEnv.NewString (name);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [1];
				__args [0] = new JniArgumentValue (native_name);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name, IntPtr native_chapter1)
		{
			global::Com.Atinternet.Tracker.Screens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (name, chapter1));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']/method[@name='add' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen Add (string name, string chapter1)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [2];
				__args [0] = new JniArgumentValue (native_name);
				__args [1] = new JniArgumentValue (native_chapter1);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name, IntPtr native_chapter1, IntPtr native_chapter2)
		{
			global::Com.Atinternet.Tracker.Screens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (name, chapter1, chapter2));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']/method[@name='add' and count(parameter)=3 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen Add (string name, string chapter1, string chapter2)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [3];
				__args [0] = new JniArgumentValue (native_name);
				__args [1] = new JniArgumentValue (native_chapter1);
				__args [2] = new JniArgumentValue (native_chapter2);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
				JNIEnv.DeleteLocalRef (native_chapter2);
			}
		}

		static Delegate cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler ()
		{
			if (cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ == null)
				cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_);
			return cb_add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_;
		}

		static IntPtr n_Add_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_name, IntPtr native_chapter1, IntPtr native_chapter2, IntPtr native_chapter3)
		{
			global::Com.Atinternet.Tracker.Screens __this = global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screens> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string name = JNIEnv.GetString (native_name, JniHandleOwnership.DoNotTransfer);
			string chapter1 = JNIEnv.GetString (native_chapter1, JniHandleOwnership.DoNotTransfer);
			string chapter2 = JNIEnv.GetString (native_chapter2, JniHandleOwnership.DoNotTransfer);
			string chapter3 = JNIEnv.GetString (native_chapter3, JniHandleOwnership.DoNotTransfer);
			IntPtr __ret = JNIEnv.ToLocalJniHandle (__this.Add (name, chapter1, chapter2, chapter3));
			return __ret;
		}
#pragma warning restore 0169

		// Metadata.xml XPath method reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='Screens']/method[@name='add' and count(parameter)=4 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='java.lang.String']]"
		[Register ("add", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Screen;", "GetAdd_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_Handler")]
		public virtual unsafe global::Com.Atinternet.Tracker.Screen Add (string name, string chapter1, string chapter2, string chapter3)
		{
			const string __id = "add.(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Lcom/atinternet/tracker/Screen;";
			IntPtr native_name = JNIEnv.NewString (name);
			IntPtr native_chapter1 = JNIEnv.NewString (chapter1);
			IntPtr native_chapter2 = JNIEnv.NewString (chapter2);
			IntPtr native_chapter3 = JNIEnv.NewString (chapter3);
			try {
				JniArgumentValue* __args = stackalloc JniArgumentValue [4];
				__args [0] = new JniArgumentValue (native_name);
				__args [1] = new JniArgumentValue (native_chapter1);
				__args [2] = new JniArgumentValue (native_chapter2);
				__args [3] = new JniArgumentValue (native_chapter3);
				var __rm = _members.InstanceMethods.InvokeVirtualObjectMethod (__id, this, __args);
				return global::Java.Lang.Object.GetObject<global::Com.Atinternet.Tracker.Screen> (__rm.Handle, JniHandleOwnership.TransferLocalRef);
			} finally {
				JNIEnv.DeleteLocalRef (native_name);
				JNIEnv.DeleteLocalRef (native_chapter1);
				JNIEnv.DeleteLocalRef (native_chapter2);
				JNIEnv.DeleteLocalRef (native_chapter3);
			}
		}

	}
}
