using System;
using System.Collections.Generic;
using Android.Runtime;
using Java.Interop;

namespace Com.Atinternet.Tracker {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']"
	[global::Android.Runtime.Register ("com/atinternet/tracker/TrackerConfigurationKeys", DoNotGenerateAcw=true)]
	public sealed partial class TrackerConfigurationKeys : global::Java.Lang.Object {


		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='AUTO_SALES_TRACKER']"
		[Register ("AUTO_SALES_TRACKER")]
		public const string AutoSalesTracker = (string) "autoSalesTracker";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='CAMPAIGN_LAST_PERSISTENCE']"
		[Register ("CAMPAIGN_LAST_PERSISTENCE")]
		public const string CampaignLastPersistence = (string) "campaignLastPersistence";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='CAMPAIGN_LIFETIME']"
		[Register ("CAMPAIGN_LIFETIME")]
		public const string CampaignLifetime = (string) "campaignLifetime";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='COLLECT_DOMAIN']"
		[Register ("COLLECT_DOMAIN")]
		public const string CollectDomain = (string) "collectDomain";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='DOMAIN']"
		[Register ("DOMAIN")]
		public const string Domain = (string) "domain";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='ENABLE_CRASH_DETECTION']"
		[Register ("ENABLE_CRASH_DETECTION")]
		public const string EnableCrashDetection = (string) "enableCrashDetection";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='HASH_USER_ID']"
		[Register ("HASH_USER_ID")]
		public const string HashUserId = (string) "hashUserId";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='IDENTIFIER']"
		[Register ("IDENTIFIER")]
		public const string Identifier = (string) "identifier";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='IGNORE_LIMITED_AD_TRACKING']"
		[Register ("IGNORE_LIMITED_AD_TRACKING")]
		public const string IgnoreLimitedAdTracking = (string) "ignoreLimitedAdTracking";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='LOG']"
		[Register ("LOG")]
		public const string Log = (string) "log";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='LOG_SSL']"
		[Register ("LOG_SSL")]
		public const string LogSsl = (string) "logSSL";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='OFFLINE_MODE']"
		[Register ("OFFLINE_MODE")]
		public const string OfflineMode = (string) "storage";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='PERSIST_IDENTIFIED_VISITOR']"
		[Register ("PERSIST_IDENTIFIED_VISITOR")]
		public const string PersistIdentifiedVisitor = (string) "persistIdentifiedVisitor";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='PIXEL_PATH']"
		[Register ("PIXEL_PATH")]
		public const string PixelPath = (string) "pixelPath";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='PLUGINS']"
		[Register ("PLUGINS")]
		public const string Plugins = (string) "plugins";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='SECURE']"
		[Register ("SECURE")]
		public const string Secure = (string) "secure";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='SEND_HIT_WHEN_OPT_OUT']"
		[Register ("SEND_HIT_WHEN_OPT_OUT")]
		public const string SendHitWhenOptOut = (string) "sendHitWhenOptOut";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='SESSION_BACKGROUND_DURATION']"
		[Register ("SESSION_BACKGROUND_DURATION")]
		public const string SessionBackgroundDuration = (string) "sessionBackgroundDuration";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.atinternet.tracker']/class[@name='TrackerConfigurationKeys']/field[@name='SITE']"
		[Register ("SITE")]
		public const string Site = (string) "site";
		internal static new readonly JniPeerMembers _members = new XAPeerMembers ("com/atinternet/tracker/TrackerConfigurationKeys", typeof (TrackerConfigurationKeys));
		internal static new IntPtr class_ref {
			get {
				return _members.JniPeerType.PeerReference.Handle;
			}
		}

		public override global::Java.Interop.JniPeerMembers JniPeerMembers {
			get { return _members; }
		}

		protected override IntPtr ThresholdClass {
			get { return _members.JniPeerType.PeerReference.Handle; }
		}

		protected override global::System.Type ThresholdType {
			get { return _members.ManagedPeerType; }
		}

		internal TrackerConfigurationKeys (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

	}
}
